package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.AgentVersionControl;
import com.trendmicro.deepsecurity.model.AgentVersionControls;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class AgentVersionControlsApi {
  private ApiClient apiClient;

  public AgentVersionControlsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public AgentVersionControlsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Describe an agent version control
   * Describe an Agent Version Control by ID.
   * @param agentVersionControlProfileID The ID number of the agent version control profile. (required)
   * @param agentVersionControlID The ID number of the agent version control to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return AgentVersionControl
   * @throws ApiException if fails to make API call
   */
  public AgentVersionControl describeAgentVersionControl(Integer agentVersionControlProfileID, Integer agentVersionControlID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'agentVersionControlProfileID' is set
    if (agentVersionControlProfileID == null) {
      throw new ApiException(400, "Missing the required parameter 'agentVersionControlProfileID' when calling describeAgentVersionControl");
    }
    
    // verify the required parameter 'agentVersionControlID' is set
    if (agentVersionControlID == null) {
      throw new ApiException(400, "Missing the required parameter 'agentVersionControlID' when calling describeAgentVersionControl");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeAgentVersionControl");
    }
    
    // create path and map variables
    String localVarPath = "/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols/{agentVersionControlID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "agentVersionControlProfileID" + "\\}", apiClient.escapeString(agentVersionControlProfileID.toString()))
      .replaceAll("\\{" + "agentVersionControlID" + "\\}", apiClient.escapeString(agentVersionControlID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AgentVersionControl> localVarReturnType = new GenericType<AgentVersionControl>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List agent version controls
   * Lists all agent version controls.
   * @param agentVersionControlProfileID The ID number of the agent version control profile. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return AgentVersionControls
   * @throws ApiException if fails to make API call
   */
  public AgentVersionControls listAgentVersionControls(Integer agentVersionControlProfileID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'agentVersionControlProfileID' is set
    if (agentVersionControlProfileID == null) {
      throw new ApiException(400, "Missing the required parameter 'agentVersionControlProfileID' when calling listAgentVersionControls");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listAgentVersionControls");
    }
    
    // create path and map variables
    String localVarPath = "/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "agentVersionControlProfileID" + "\\}", apiClient.escapeString(agentVersionControlProfileID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AgentVersionControls> localVarReturnType = new GenericType<AgentVersionControls>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify agent version controls
   * Modify the agent version controls. Any unset elements will be left unchanged.
   * @param agentVersionControlProfileID The ID number of the agent version control profile. (required)
   * @param agentVersionControls The agent version controls to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return AgentVersionControls
   * @throws ApiException if fails to make API call
   */
  public AgentVersionControls modifyAgentVersionControls(Integer agentVersionControlProfileID, AgentVersionControls agentVersionControls, String apiVersion) throws ApiException {
    Object localVarPostBody = agentVersionControls;
    
    // verify the required parameter 'agentVersionControlProfileID' is set
    if (agentVersionControlProfileID == null) {
      throw new ApiException(400, "Missing the required parameter 'agentVersionControlProfileID' when calling modifyAgentVersionControls");
    }
    
    // verify the required parameter 'agentVersionControls' is set
    if (agentVersionControls == null) {
      throw new ApiException(400, "Missing the required parameter 'agentVersionControls' when calling modifyAgentVersionControls");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyAgentVersionControls");
    }
    
    // create path and map variables
    String localVarPath = "/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "agentVersionControlProfileID" + "\\}", apiClient.escapeString(agentVersionControlProfileID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AgentVersionControls> localVarReturnType = new GenericType<AgentVersionControls>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search agent version controls
   * Search for agent version controls using optional filters.
   * @param agentVersionControlProfileID The ID number of the agent version control profile. (required)
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return AgentVersionControls
   * @throws ApiException if fails to make API call
   */
  public AgentVersionControls searchAgentVersionControls(Integer agentVersionControlProfileID, SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'agentVersionControlProfileID' is set
    if (agentVersionControlProfileID == null) {
      throw new ApiException(400, "Missing the required parameter 'agentVersionControlProfileID' when calling searchAgentVersionControls");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchAgentVersionControls");
    }
    
    // create path and map variables
    String localVarPath = "/agentversioncontrolprofiles/{agentVersionControlProfileID}/agentversioncontrols/search".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "agentVersionControlProfileID" + "\\}", apiClient.escapeString(agentVersionControlProfileID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AgentVersionControls> localVarReturnType = new GenericType<AgentVersionControls>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
