package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.ApiKey;
import com.trendmicro.deepsecurity.model.ApiKeyCurrent;
import com.trendmicro.deepsecurity.model.ApiKeys;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ApiKeysApi {
  private ApiClient apiClient;

  public ApiKeysApi() {
    this(Configuration.getDefaultApiClient());
  }

  public ApiKeysApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an API Key
   * Create a new API key.
   * @param apiKey The settings of the new API key. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKey
   * @throws ApiException if fails to make API call
   */
  public ApiKey createApiKey(ApiKey apiKey, String apiVersion) throws ApiException {
    Object localVarPostBody = apiKey;
    
    // verify the required parameter 'apiKey' is set
    if (apiKey == null) {
      throw new ApiException(400, "Missing the required parameter 'apiKey' when calling createApiKey");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createApiKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKey> localVarReturnType = new GenericType<ApiKey>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an API Key
   * Delete an API key by ID.
   * @param apiKeyID The ID number of the API key to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteApiKey(Integer apiKeyID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiKeyID' is set
    if (apiKeyID == null) {
      throw new ApiException(400, "Missing the required parameter 'apiKeyID' when calling deleteApiKey");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteApiKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/{apiKeyID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "apiKeyID" + "\\}", apiClient.escapeString(apiKeyID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an API Key
   * Describe an API key by ID.
   * @param apiKeyID The ID number of the API key to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKey
   * @throws ApiException if fails to make API call
   */
  public ApiKey describeApiKey(Integer apiKeyID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiKeyID' is set
    if (apiKeyID == null) {
      throw new ApiException(400, "Missing the required parameter 'apiKeyID' when calling describeApiKey");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeApiKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/{apiKeyID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "apiKeyID" + "\\}", apiClient.escapeString(apiKeyID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKey> localVarReturnType = new GenericType<ApiKey>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Describe the Current API Key
   * Describe the API key that is associated with the credentials that are being used to authenticate this call. Authentication must be done via an API secret key.
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKeyCurrent
   * @throws ApiException if fails to make API call
   */
  public ApiKeyCurrent describeCurrentApiKey(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeCurrentApiKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/current".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKeyCurrent> localVarReturnType = new GenericType<ApiKeyCurrent>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List API Keys
   * Lists all API keys.
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKeys
   * @throws ApiException if fails to make API call
   */
  public ApiKeys listApiKeys(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listApiKeys");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKeys> localVarReturnType = new GenericType<ApiKeys>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an API Key
   * Modify an API key by ID. Any unset elements will be left unchanged.
   * @param apiKeyID The ID number of the API key to modify. (required)
   * @param apiKey The settings of the API key to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKey
   * @throws ApiException if fails to make API call
   */
  public ApiKey modifyApiKey(Integer apiKeyID, ApiKey apiKey, String apiVersion) throws ApiException {
    Object localVarPostBody = apiKey;
    
    // verify the required parameter 'apiKeyID' is set
    if (apiKeyID == null) {
      throw new ApiException(400, "Missing the required parameter 'apiKeyID' when calling modifyApiKey");
    }
    
    // verify the required parameter 'apiKey' is set
    if (apiKey == null) {
      throw new ApiException(400, "Missing the required parameter 'apiKey' when calling modifyApiKey");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyApiKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/{apiKeyID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "apiKeyID" + "\\}", apiClient.escapeString(apiKeyID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKey> localVarReturnType = new GenericType<ApiKey>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify the Current API Key
   * Modify the API key that is associated with the credentials that are being used to authenticate this call. Authentication must be done via an API secret key. Writable fields are: keyName, description, locale, &amp; timeZone. Any unset elements will be left unchanged.
   * @param apiKey The settings of the API key to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKeyCurrent
   * @throws ApiException if fails to make API call
   */
  public ApiKeyCurrent modifyCurrentApiKey(ApiKeyCurrent apiKey, String apiVersion) throws ApiException {
    Object localVarPostBody = apiKey;
    
    // verify the required parameter 'apiKey' is set
    if (apiKey == null) {
      throw new ApiException(400, "Missing the required parameter 'apiKey' when calling modifyCurrentApiKey");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyCurrentApiKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/current".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKeyCurrent> localVarReturnType = new GenericType<ApiKeyCurrent>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Generate an API Secret Key
   * Generate a new API secret key.
   * @param apiKeyID The ID number of API key used to generate the secret key. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKey
   * @throws ApiException if fails to make API call
   */
  public ApiKey replaceApiSecretKey(Integer apiKeyID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiKeyID' is set
    if (apiKeyID == null) {
      throw new ApiException(400, "Missing the required parameter 'apiKeyID' when calling replaceApiSecretKey");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling replaceApiSecretKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/{apiKeyID}/secretkey".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "apiKeyID" + "\\}", apiClient.escapeString(apiKeyID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKey> localVarReturnType = new GenericType<ApiKey>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Generate a Secret Key for the Current API Key
   * Generate a new secret key for the current API key. Authentication must be done via an API secret key.
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKey
   * @throws ApiException if fails to make API call
   */
  public ApiKey replaceCurrentApiSecretKey(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling replaceCurrentApiSecretKey");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/current/secretkey".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKey> localVarReturnType = new GenericType<ApiKey>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search API Keys
   * Search for API keys using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return ApiKeys
   * @throws ApiException if fails to make API call
   */
  public ApiKeys searchApiKeys(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchApiKeys");
    }
    
    // create path and map variables
    String localVarPath = "/apikeys/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApiKeys> localVarReturnType = new GenericType<ApiKeys>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
