package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.ApplicationType;
import com.trendmicro.deepsecurity.model.ApplicationTypes;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ApplicationTypesApi {
  private ApiClient apiClient;

  public ApplicationTypesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public ApplicationTypesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an Application Type
   * Create a new application type.
   * @param applicationType The settings of the new application type. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationType
   * @throws ApiException if fails to make API call
   */
  public ApplicationType createApplicationType(ApplicationType applicationType, String apiVersion) throws ApiException {
    Object localVarPostBody = applicationType;
    
    // verify the required parameter 'applicationType' is set
    if (applicationType == null) {
      throw new ApiException(400, "Missing the required parameter 'applicationType' when calling createApplicationType");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createApplicationType");
    }
    
    // create path and map variables
    String localVarPath = "/applicationtypes".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationType> localVarReturnType = new GenericType<ApplicationType>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an Application Type
   * Delete an application type by ID.
   * @param applicationTypeID The ID number of the application type to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteApplicationType(Integer applicationTypeID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'applicationTypeID' is set
    if (applicationTypeID == null) {
      throw new ApiException(400, "Missing the required parameter 'applicationTypeID' when calling deleteApplicationType");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteApplicationType");
    }
    
    // create path and map variables
    String localVarPath = "/applicationtypes/{applicationTypeID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "applicationTypeID" + "\\}", apiClient.escapeString(applicationTypeID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an Application Type
   * Describe an application type by ID.
   * @param applicationTypeID The ID number of the application type to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationType
   * @throws ApiException if fails to make API call
   */
  public ApplicationType describeApplicationType(Integer applicationTypeID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'applicationTypeID' is set
    if (applicationTypeID == null) {
      throw new ApiException(400, "Missing the required parameter 'applicationTypeID' when calling describeApplicationType");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeApplicationType");
    }
    
    // create path and map variables
    String localVarPath = "/applicationtypes/{applicationTypeID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "applicationTypeID" + "\\}", apiClient.escapeString(applicationTypeID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationType> localVarReturnType = new GenericType<ApplicationType>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Application Types
   * Lists all application types.
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationTypes
   * @throws ApiException if fails to make API call
   */
  public ApplicationTypes listApplicationTypes(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listApplicationTypes");
    }
    
    // create path and map variables
    String localVarPath = "/applicationtypes".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationTypes> localVarReturnType = new GenericType<ApplicationTypes>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an Application Type
   * Modify an application type by ID. Any unset elements will be left unchanged.
   * @param applicationTypeID The ID number of the application type to modify. (required)
   * @param applicationType The settings of the application type to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationType
   * @throws ApiException if fails to make API call
   */
  public ApplicationType modifyApplicationType(Integer applicationTypeID, ApplicationType applicationType, String apiVersion) throws ApiException {
    Object localVarPostBody = applicationType;
    
    // verify the required parameter 'applicationTypeID' is set
    if (applicationTypeID == null) {
      throw new ApiException(400, "Missing the required parameter 'applicationTypeID' when calling modifyApplicationType");
    }
    
    // verify the required parameter 'applicationType' is set
    if (applicationType == null) {
      throw new ApiException(400, "Missing the required parameter 'applicationType' when calling modifyApplicationType");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyApplicationType");
    }
    
    // create path and map variables
    String localVarPath = "/applicationtypes/{applicationTypeID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "applicationTypeID" + "\\}", apiClient.escapeString(applicationTypeID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationType> localVarReturnType = new GenericType<ApplicationType>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Application Types
   * Search for application types using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationTypes
   * @throws ApiException if fails to make API call
   */
  public ApplicationTypes searchApplicationTypes(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchApplicationTypes");
    }
    
    // create path and map variables
    String localVarPath = "/applicationtypes/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationTypes> localVarReturnType = new GenericType<ApplicationTypes>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
