package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.Certificate;
import com.trendmicro.deepsecurity.model.Certificates;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class CertificatesApi {
  private ApiClient apiClient;

  public CertificatesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public CertificatesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Add a Certificate
   * Add a certificate to Deep Security Manager.
   * @param certificate  (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Certificate
   * @throws ApiException if fails to make API call
   */
  public Certificate addCertificate(Certificate certificate, String apiVersion) throws ApiException {
    Object localVarPostBody = certificate;
    
    // verify the required parameter 'certificate' is set
    if (certificate == null) {
      throw new ApiException(400, "Missing the required parameter 'certificate' when calling addCertificate");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling addCertificate");
    }
    
    // create path and map variables
    String localVarPath = "/certificates".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Certificate> localVarReturnType = new GenericType<Certificate>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Certificate
   * Delete a certificate by ID.
   * @param certificateID The ID number of the certificate to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteCertificate(Integer certificateID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'certificateID' is set
    if (certificateID == null) {
      throw new ApiException(400, "Missing the required parameter 'certificateID' when calling deleteCertificate");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteCertificate");
    }
    
    // create path and map variables
    String localVarPath = "/certificates/{certificateID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "certificateID" + "\\}", apiClient.escapeString(certificateID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Certificate
   * Describe a certificate by ID.
   * @param certificateID The ID number of the certificate to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Certificate
   * @throws ApiException if fails to make API call
   */
  public Certificate describeCertificate(Integer certificateID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'certificateID' is set
    if (certificateID == null) {
      throw new ApiException(400, "Missing the required parameter 'certificateID' when calling describeCertificate");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeCertificate");
    }
    
    // create path and map variables
    String localVarPath = "/certificates/{certificateID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "certificateID" + "\\}", apiClient.escapeString(certificateID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Certificate> localVarReturnType = new GenericType<Certificate>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Certificates
   * List all SSL certificates.
   * @param apiVersion The version of the api being called. (required)
   * @return Certificates
   * @throws ApiException if fails to make API call
   */
  public Certificates listCertificates(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listCertificates");
    }
    
    // create path and map variables
    String localVarPath = "/certificates".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Certificates> localVarReturnType = new GenericType<Certificates>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Retrieve a Certificate by URL
   * Retrieve a certificate by URL
   * @param URL The URL of the certificate to describe (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Certificate
   * @throws ApiException if fails to make API call
   */
  public Certificate targetCertificate(String URL, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'URL' is set
    if (URL == null) {
      throw new ApiException(400, "Missing the required parameter 'URL' when calling targetCertificate");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling targetCertificate");
    }
    
    // create path and map variables
    String localVarPath = "/certificates/target".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();

    localVarQueryParams.addAll(apiClient.parameterToPairs("", "URL", URL));

    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Certificate> localVarReturnType = new GenericType<Certificate>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
