package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.Contact;
import com.trendmicro.deepsecurity.model.Contacts;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ContactsApi {
  private ApiClient apiClient;

  public ContactsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public ContactsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Contact
   * Create a new contact.
   * @param contact The settings of the contact to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Contact
   * @throws ApiException if fails to make API call
   */
  public Contact createContact(Contact contact, String apiVersion) throws ApiException {
    Object localVarPostBody = contact;
    
    // verify the required parameter 'contact' is set
    if (contact == null) {
      throw new ApiException(400, "Missing the required parameter 'contact' when calling createContact");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createContact");
    }
    
    // create path and map variables
    String localVarPath = "/contacts".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Contact> localVarReturnType = new GenericType<Contact>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Contact
   * Delete a contact by ID.
   * @param contactID The ID number of the contact to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteContact(Integer contactID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'contactID' is set
    if (contactID == null) {
      throw new ApiException(400, "Missing the required parameter 'contactID' when calling deleteContact");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteContact");
    }
    
    // create path and map variables
    String localVarPath = "/contacts/{contactID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "contactID" + "\\}", apiClient.escapeString(contactID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Contact
   * Describe a contact by ID.
   * @param contactID The ID number of the contact to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Contact
   * @throws ApiException if fails to make API call
   */
  public Contact describeContact(Integer contactID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'contactID' is set
    if (contactID == null) {
      throw new ApiException(400, "Missing the required parameter 'contactID' when calling describeContact");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeContact");
    }
    
    // create path and map variables
    String localVarPath = "/contacts/{contactID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "contactID" + "\\}", apiClient.escapeString(contactID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Contact> localVarReturnType = new GenericType<Contact>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Contacts
   * Lists all contacts.
   * @param apiVersion The version of the api being called. (required)
   * @return Contacts
   * @throws ApiException if fails to make API call
   */
  public Contacts listContacts(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listContacts");
    }
    
    // create path and map variables
    String localVarPath = "/contacts".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Contacts> localVarReturnType = new GenericType<Contacts>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Contact
   * Modify a contact by ID. Any unset elements will be left unchanged.
   * @param contactID The ID number of the contact to modify. (required)
   * @param contact The settings of the contact to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return Contact
   * @throws ApiException if fails to make API call
   */
  public Contact modifyContact(Integer contactID, Contact contact, String apiVersion) throws ApiException {
    Object localVarPostBody = contact;
    
    // verify the required parameter 'contactID' is set
    if (contactID == null) {
      throw new ApiException(400, "Missing the required parameter 'contactID' when calling modifyContact");
    }
    
    // verify the required parameter 'contact' is set
    if (contact == null) {
      throw new ApiException(400, "Missing the required parameter 'contact' when calling modifyContact");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyContact");
    }
    
    // create path and map variables
    String localVarPath = "/contacts/{contactID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "contactID" + "\\}", apiClient.escapeString(contactID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Contact> localVarReturnType = new GenericType<Contact>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Contacts
   * Search for contacts using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return Contacts
   * @throws ApiException if fails to make API call
   */
  public Contacts searchContacts(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchContacts");
    }
    
    // create path and map variables
    String localVarPath = "/contacts/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<Contacts> localVarReturnType = new GenericType<Contacts>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
