package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.DirectoryList;
import com.trendmicro.deepsecurity.model.DirectoryLists;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class DirectoryListsApi {
  private ApiClient apiClient;

  public DirectoryListsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public DirectoryListsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Directory List
   * Create a new directory list.
   * @param directoryList The settings of the new directory list. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return DirectoryList
   * @throws ApiException if fails to make API call
   */
  public DirectoryList createDirectoryList(DirectoryList directoryList, String apiVersion) throws ApiException {
    Object localVarPostBody = directoryList;
    
    // verify the required parameter 'directoryList' is set
    if (directoryList == null) {
      throw new ApiException(400, "Missing the required parameter 'directoryList' when calling createDirectoryList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createDirectoryList");
    }
    
    // create path and map variables
    String localVarPath = "/directorylists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<DirectoryList> localVarReturnType = new GenericType<DirectoryList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Directory List
   * Delete a directory list by ID.
   * @param directoryListID The ID number of the directory list to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteDirectoryList(Integer directoryListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'directoryListID' is set
    if (directoryListID == null) {
      throw new ApiException(400, "Missing the required parameter 'directoryListID' when calling deleteDirectoryList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteDirectoryList");
    }
    
    // create path and map variables
    String localVarPath = "/directorylists/{directoryListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "directoryListID" + "\\}", apiClient.escapeString(directoryListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Directory List
   * Describe a directory list by ID.
   * @param directoryListID The ID number of the directory list to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return DirectoryList
   * @throws ApiException if fails to make API call
   */
  public DirectoryList describeDirectoryList(Integer directoryListID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'directoryListID' is set
    if (directoryListID == null) {
      throw new ApiException(400, "Missing the required parameter 'directoryListID' when calling describeDirectoryList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeDirectoryList");
    }
    
    // create path and map variables
    String localVarPath = "/directorylists/{directoryListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "directoryListID" + "\\}", apiClient.escapeString(directoryListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<DirectoryList> localVarReturnType = new GenericType<DirectoryList>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Directory Lists
   * Lists all directory lists.
   * @param apiVersion The version of the api being called. (required)
   * @return DirectoryLists
   * @throws ApiException if fails to make API call
   */
  public DirectoryLists listDirectoryLists(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listDirectoryLists");
    }
    
    // create path and map variables
    String localVarPath = "/directorylists".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<DirectoryLists> localVarReturnType = new GenericType<DirectoryLists>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Directory List
   * Modify a directory list by ID. Any unset elements will be left unchanged.
   * @param directoryListID The ID number of the directory list to modify. (required)
   * @param directoryList The settings of the directory list to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return DirectoryList
   * @throws ApiException if fails to make API call
   */
  public DirectoryList modifyDirectoryList(Integer directoryListID, DirectoryList directoryList, String apiVersion) throws ApiException {
    Object localVarPostBody = directoryList;
    
    // verify the required parameter 'directoryListID' is set
    if (directoryListID == null) {
      throw new ApiException(400, "Missing the required parameter 'directoryListID' when calling modifyDirectoryList");
    }
    
    // verify the required parameter 'directoryList' is set
    if (directoryList == null) {
      throw new ApiException(400, "Missing the required parameter 'directoryList' when calling modifyDirectoryList");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyDirectoryList");
    }
    
    // create path and map variables
    String localVarPath = "/directorylists/{directoryListID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "directoryListID" + "\\}", apiClient.escapeString(directoryListID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<DirectoryList> localVarReturnType = new GenericType<DirectoryList>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Directory Lists
   * Search for directory lists using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return DirectoryLists
   * @throws ApiException if fails to make API call
   */
  public DirectoryLists searchDirectoryLists(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchDirectoryLists");
    }
    
    // create path and map variables
    String localVarPath = "/directorylists/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<DirectoryLists> localVarReturnType = new GenericType<DirectoryLists>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
