package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.EventBasedTask;
import com.trendmicro.deepsecurity.model.EventBasedTasks;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class EventBasedTasksApi {
  private ApiClient apiClient;

  public EventBasedTasksApi() {
    this(Configuration.getDefaultApiClient());
  }

  public EventBasedTasksApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an Event Based Task
   * Create a new event based task.
   * @param eventBasedTask The settings of the new event based task. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return EventBasedTask
   * @throws ApiException if fails to make API call
   */
  public EventBasedTask createEventBasedTask(EventBasedTask eventBasedTask, String apiVersion) throws ApiException {
    Object localVarPostBody = eventBasedTask;
    
    // verify the required parameter 'eventBasedTask' is set
    if (eventBasedTask == null) {
      throw new ApiException(400, "Missing the required parameter 'eventBasedTask' when calling createEventBasedTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createEventBasedTask");
    }
    
    // create path and map variables
    String localVarPath = "/eventbasedtasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<EventBasedTask> localVarReturnType = new GenericType<EventBasedTask>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an Event Based Task
   * Delete an event based task by ID.
   * @param eventBasedTaskID The ID number of the event based task to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteEventBasedTask(Integer eventBasedTaskID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'eventBasedTaskID' is set
    if (eventBasedTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'eventBasedTaskID' when calling deleteEventBasedTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteEventBasedTask");
    }
    
    // create path and map variables
    String localVarPath = "/eventbasedtasks/{eventBasedTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "eventBasedTaskID" + "\\}", apiClient.escapeString(eventBasedTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an Event Based Task
   * Describe an event based task by ID.
   * @param eventBasedTaskID The ID number of the event based task to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return EventBasedTask
   * @throws ApiException if fails to make API call
   */
  public EventBasedTask describeEventBasedTask(Integer eventBasedTaskID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'eventBasedTaskID' is set
    if (eventBasedTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'eventBasedTaskID' when calling describeEventBasedTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeEventBasedTask");
    }
    
    // create path and map variables
    String localVarPath = "/eventbasedtasks/{eventBasedTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "eventBasedTaskID" + "\\}", apiClient.escapeString(eventBasedTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<EventBasedTask> localVarReturnType = new GenericType<EventBasedTask>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Event Based Tasks
   * Lists all event based tasks.
   * @param apiVersion The version of the api being called. (required)
   * @return EventBasedTasks
   * @throws ApiException if fails to make API call
   */
  public EventBasedTasks listEventBasedTasks(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listEventBasedTasks");
    }
    
    // create path and map variables
    String localVarPath = "/eventbasedtasks".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<EventBasedTasks> localVarReturnType = new GenericType<EventBasedTasks>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an Event Based Task
   * Modify an event based task by ID. Any unset elements will be left unchanged.
   * @param eventBasedTaskID The ID number of the event based task to modify. (required)
   * @param eventBasedTask The settings of the event based task to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return EventBasedTask
   * @throws ApiException if fails to make API call
   */
  public EventBasedTask modifyEventBasedTask(Integer eventBasedTaskID, EventBasedTask eventBasedTask, String apiVersion) throws ApiException {
    Object localVarPostBody = eventBasedTask;
    
    // verify the required parameter 'eventBasedTaskID' is set
    if (eventBasedTaskID == null) {
      throw new ApiException(400, "Missing the required parameter 'eventBasedTaskID' when calling modifyEventBasedTask");
    }
    
    // verify the required parameter 'eventBasedTask' is set
    if (eventBasedTask == null) {
      throw new ApiException(400, "Missing the required parameter 'eventBasedTask' when calling modifyEventBasedTask");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyEventBasedTask");
    }
    
    // create path and map variables
    String localVarPath = "/eventbasedtasks/{eventBasedTaskID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "eventBasedTaskID" + "\\}", apiClient.escapeString(eventBasedTaskID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<EventBasedTask> localVarReturnType = new GenericType<EventBasedTask>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Event Based Tasks
   * Search for event based tasks using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return EventBasedTasks
   * @throws ApiException if fails to make API call
   */
  public EventBasedTasks searchEventBasedTasks(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchEventBasedTasks");
    }
    
    // create path and map variables
    String localVarPath = "/eventbasedtasks/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<EventBasedTasks> localVarReturnType = new GenericType<EventBasedTasks>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
