package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.ApplicationControlGlobalRule;
import com.trendmicro.deepsecurity.model.ApplicationControlGlobalRules;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class GlobalRulesApi {
  private ApiClient apiClient;

  public GlobalRulesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public GlobalRulesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create and add new global rules
   * Create and add global rules.
   * @param globalrules The settings of the new rules. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlGlobalRules
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlGlobalRules addGlobalRules(ApplicationControlGlobalRules globalrules, String apiVersion) throws ApiException {
    Object localVarPostBody = globalrules;
    
    // verify the required parameter 'globalrules' is set
    if (globalrules == null) {
      throw new ApiException(400, "Missing the required parameter 'globalrules' when calling addGlobalRules");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling addGlobalRules");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontrolglobalrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlGlobalRules> localVarReturnType = new GenericType<ApplicationControlGlobalRules>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   *  Delete a global rule
   * Delete a global rule by ID.
   * @param ruleID The ID number of the rule to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteGlobalRule(Long ruleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'ruleID' is set
    if (ruleID == null) {
      throw new ApiException(400, "Missing the required parameter 'ruleID' when calling deleteGlobalRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteGlobalRule");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontrolglobalrules/{ruleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "ruleID" + "\\}", apiClient.escapeString(ruleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a global rule
   * Describe a global rule by ID.
   * @param ruleID The ID number of the rule to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlGlobalRule
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlGlobalRule describeGlobalRule(Long ruleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'ruleID' is set
    if (ruleID == null) {
      throw new ApiException(400, "Missing the required parameter 'ruleID' when calling describeGlobalRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeGlobalRule");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontrolglobalrules/{ruleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "ruleID" + "\\}", apiClient.escapeString(ruleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlGlobalRule> localVarReturnType = new GenericType<ApplicationControlGlobalRule>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List all global rules
   * List all global rules.
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlGlobalRules
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlGlobalRules listGlobalRules(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listGlobalRules");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontrolglobalrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlGlobalRules> localVarReturnType = new GenericType<ApplicationControlGlobalRules>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a global rule
   * Modify a global rule by ID. Any unset elements will be left unchanged.
   * @param ruleID The ID number of the rule to modify. (required)
   * @param globalrule The settings of the rule to be modified. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlGlobalRule
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlGlobalRule modifyGlobalRule(Long ruleID, ApplicationControlGlobalRule globalrule, String apiVersion) throws ApiException {
    Object localVarPostBody = globalrule;
    
    // verify the required parameter 'ruleID' is set
    if (ruleID == null) {
      throw new ApiException(400, "Missing the required parameter 'ruleID' when calling modifyGlobalRule");
    }
    
    // verify the required parameter 'globalrule' is set
    if (globalrule == null) {
      throw new ApiException(400, "Missing the required parameter 'globalrule' when calling modifyGlobalRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyGlobalRule");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontrolglobalrules/{ruleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "ruleID" + "\\}", apiClient.escapeString(ruleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlGlobalRule> localVarReturnType = new GenericType<ApplicationControlGlobalRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search global rules
   * Search for global rules using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return ApplicationControlGlobalRules
   * @throws ApiException if fails to make API call
   */
  public ApplicationControlGlobalRules searchGlobalRules(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchGlobalRules");
    }
    
    // create path and map variables
    String localVarPath = "/applicationcontrolglobalrules/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<ApplicationControlGlobalRules> localVarReturnType = new GenericType<ApplicationControlGlobalRules>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
