package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.IntegrityMonitoringRule;
import com.trendmicro.deepsecurity.model.IntegrityMonitoringRules;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class IntegrityMonitoringRulesApi {
  private ApiClient apiClient;

  public IntegrityMonitoringRulesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public IntegrityMonitoringRulesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an Integrity Monitoring Rule
   * Create a new integrity monitoring rule.
   * @param integrityMonitoringRule The settings of the new integrity monitoring rule. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return IntegrityMonitoringRule
   * @throws ApiException if fails to make API call
   */
  public IntegrityMonitoringRule createIntegrityMonitoringRule(IntegrityMonitoringRule integrityMonitoringRule, String apiVersion) throws ApiException {
    Object localVarPostBody = integrityMonitoringRule;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createIntegrityMonitoringRule");
    }
    
    // create path and map variables
    String localVarPath = "/integritymonitoringrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntegrityMonitoringRule> localVarReturnType = new GenericType<IntegrityMonitoringRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an Integrity Monitoring Rule
   * Delete an integrity monitoring rule by ID.
   * @param integrityMonitoringRuleID The ID number of the integrity monitoring rule to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteIntegrityMonitoringRule(Integer integrityMonitoringRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'integrityMonitoringRuleID' is set
    if (integrityMonitoringRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'integrityMonitoringRuleID' when calling deleteIntegrityMonitoringRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteIntegrityMonitoringRule");
    }
    
    // create path and map variables
    String localVarPath = "/integritymonitoringrules/{integrityMonitoringRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "integrityMonitoringRuleID" + "\\}", apiClient.escapeString(integrityMonitoringRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an Integrity Monitoring Rule
   * Describe an integrity monitoring rule by ID.
   * @param integrityMonitoringRuleID The ID number of the integrity monitoring rule to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IntegrityMonitoringRule
   * @throws ApiException if fails to make API call
   */
  public IntegrityMonitoringRule describeIntegrityMonitoringRule(Integer integrityMonitoringRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'integrityMonitoringRuleID' is set
    if (integrityMonitoringRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'integrityMonitoringRuleID' when calling describeIntegrityMonitoringRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeIntegrityMonitoringRule");
    }
    
    // create path and map variables
    String localVarPath = "/integritymonitoringrules/{integrityMonitoringRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "integrityMonitoringRuleID" + "\\}", apiClient.escapeString(integrityMonitoringRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntegrityMonitoringRule> localVarReturnType = new GenericType<IntegrityMonitoringRule>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Integrity Monitoring Rules
   * Lists all integrity monitoring rules.
   * @param apiVersion The version of the api being called. (required)
   * @return IntegrityMonitoringRules
   * @throws ApiException if fails to make API call
   */
  public IntegrityMonitoringRules listIntegrityMonitoringRules(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listIntegrityMonitoringRules");
    }
    
    // create path and map variables
    String localVarPath = "/integritymonitoringrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntegrityMonitoringRules> localVarReturnType = new GenericType<IntegrityMonitoringRules>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an Integrity Monitoring Rule
   * Modify an integrity monitoring rule by ID. Any unset elements will be left unchanged.
   * @param integrityMonitoringRuleID The ID number of the integrity monitoring rule to modify. (required)
   * @param integrityMonitoringRule The settings of the integrity monitoring rule to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IntegrityMonitoringRule
   * @throws ApiException if fails to make API call
   */
  public IntegrityMonitoringRule modifyIntegrityMonitoringRule(Integer integrityMonitoringRuleID, IntegrityMonitoringRule integrityMonitoringRule, String apiVersion) throws ApiException {
    Object localVarPostBody = integrityMonitoringRule;
    
    // verify the required parameter 'integrityMonitoringRuleID' is set
    if (integrityMonitoringRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'integrityMonitoringRuleID' when calling modifyIntegrityMonitoringRule");
    }
    
    // verify the required parameter 'integrityMonitoringRule' is set
    if (integrityMonitoringRule == null) {
      throw new ApiException(400, "Missing the required parameter 'integrityMonitoringRule' when calling modifyIntegrityMonitoringRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyIntegrityMonitoringRule");
    }
    
    // create path and map variables
    String localVarPath = "/integritymonitoringrules/{integrityMonitoringRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "integrityMonitoringRuleID" + "\\}", apiClient.escapeString(integrityMonitoringRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntegrityMonitoringRule> localVarReturnType = new GenericType<IntegrityMonitoringRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Integrity Monitoring Rules
   * Search for integrity monitoring rules using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return IntegrityMonitoringRules
   * @throws ApiException if fails to make API call
   */
  public IntegrityMonitoringRules searchIntegrityMonitoringRules(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchIntegrityMonitoringRules");
    }
    
    // create path and map variables
    String localVarPath = "/integritymonitoringrules/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntegrityMonitoringRules> localVarReturnType = new GenericType<IntegrityMonitoringRules>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
