package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.IntrusionPreventionRule;
import com.trendmicro.deepsecurity.model.IntrusionPreventionRules;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class IntrusionPreventionRulesApi {
  private ApiClient apiClient;

  public IntrusionPreventionRulesApi() {
    this(Configuration.getDefaultApiClient());
  }

  public IntrusionPreventionRulesApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an Intrusion Prevention Rule
   * Create a new intrusion prevention rule.
   * @param intrusionPreventionRule The settings of the new intrusion prevention rule. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IntrusionPreventionRule
   * @throws ApiException if fails to make API call
   */
  public IntrusionPreventionRule createIntrusionPreventionRule(IntrusionPreventionRule intrusionPreventionRule, String apiVersion) throws ApiException {
    Object localVarPostBody = intrusionPreventionRule;
    
    // verify the required parameter 'intrusionPreventionRule' is set
    if (intrusionPreventionRule == null) {
      throw new ApiException(400, "Missing the required parameter 'intrusionPreventionRule' when calling createIntrusionPreventionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createIntrusionPreventionRule");
    }
    
    // create path and map variables
    String localVarPath = "/intrusionpreventionrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntrusionPreventionRule> localVarReturnType = new GenericType<IntrusionPreventionRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an Intrusion Prevention Rule
   * Delete an intrusion prevention rule by ID.
   * @param intrusionPreventionRuleID The ID number of the intrusion prevention rule to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteIntrusionPreventionRule(Integer intrusionPreventionRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'intrusionPreventionRuleID' is set
    if (intrusionPreventionRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'intrusionPreventionRuleID' when calling deleteIntrusionPreventionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteIntrusionPreventionRule");
    }
    
    // create path and map variables
    String localVarPath = "/intrusionpreventionrules/{intrusionPreventionRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "intrusionPreventionRuleID" + "\\}", apiClient.escapeString(intrusionPreventionRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an Intrusion Prevention Rule
   * Describe an intrusion prevention rule by ID.
   * @param intrusionPreventionRuleID The ID number of the intrusion prevention rule to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IntrusionPreventionRule
   * @throws ApiException if fails to make API call
   */
  public IntrusionPreventionRule describeIntrusionPreventionRule(Integer intrusionPreventionRuleID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'intrusionPreventionRuleID' is set
    if (intrusionPreventionRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'intrusionPreventionRuleID' when calling describeIntrusionPreventionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeIntrusionPreventionRule");
    }
    
    // create path and map variables
    String localVarPath = "/intrusionpreventionrules/{intrusionPreventionRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "intrusionPreventionRuleID" + "\\}", apiClient.escapeString(intrusionPreventionRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntrusionPreventionRule> localVarReturnType = new GenericType<IntrusionPreventionRule>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Intrusion Prevention Rules
   * Lists all intrusion prevention rules.
   * @param apiVersion The version of the api being called. (required)
   * @return IntrusionPreventionRules
   * @throws ApiException if fails to make API call
   */
  public IntrusionPreventionRules listIntrusionPreventionRules(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listIntrusionPreventionRules");
    }
    
    // create path and map variables
    String localVarPath = "/intrusionpreventionrules".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntrusionPreventionRules> localVarReturnType = new GenericType<IntrusionPreventionRules>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an Intrusion Prevention Rule
   * Modify an intrusion prevention rule by ID. Any unset elements will be left unchanged.
   * @param intrusionPreventionRuleID The ID number of the intrusion prevention rule to modify. (required)
   * @param intrusionPreventionRule The settings of the intrusion prevention rules to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return IntrusionPreventionRule
   * @throws ApiException if fails to make API call
   */
  public IntrusionPreventionRule modifyIntrusionPreventionRule(Integer intrusionPreventionRuleID, IntrusionPreventionRule intrusionPreventionRule, String apiVersion) throws ApiException {
    Object localVarPostBody = intrusionPreventionRule;
    
    // verify the required parameter 'intrusionPreventionRuleID' is set
    if (intrusionPreventionRuleID == null) {
      throw new ApiException(400, "Missing the required parameter 'intrusionPreventionRuleID' when calling modifyIntrusionPreventionRule");
    }
    
    // verify the required parameter 'intrusionPreventionRule' is set
    if (intrusionPreventionRule == null) {
      throw new ApiException(400, "Missing the required parameter 'intrusionPreventionRule' when calling modifyIntrusionPreventionRule");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyIntrusionPreventionRule");
    }
    
    // create path and map variables
    String localVarPath = "/intrusionpreventionrules/{intrusionPreventionRuleID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "intrusionPreventionRuleID" + "\\}", apiClient.escapeString(intrusionPreventionRuleID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntrusionPreventionRule> localVarReturnType = new GenericType<IntrusionPreventionRule>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Intrusion Prevention Rules
   * Search for intrusion prevention rules using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return IntrusionPreventionRules
   * @throws ApiException if fails to make API call
   */
  public IntrusionPreventionRules searchIntrusionPreventionRules(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchIntrusionPreventionRules");
    }
    
    // create path and map variables
    String localVarPath = "/intrusionpreventionrules/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<IntrusionPreventionRules> localVarReturnType = new GenericType<IntrusionPreventionRules>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
