package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.SearchFilter;
import com.trendmicro.deepsecurity.model.StatefulConfiguration;
import com.trendmicro.deepsecurity.model.StatefulConfigurations;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class StatefulConfigurationsApi {
  private ApiClient apiClient;

  public StatefulConfigurationsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public StatefulConfigurationsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create a Stateful Configuration
   * Create a new stateful configuration.
   * @param statefulConfigurations The settings of the new stateful configuration. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return StatefulConfiguration
   * @throws ApiException if fails to make API call
   */
  public StatefulConfiguration createStatefulConfiguration(StatefulConfiguration statefulConfigurations, String apiVersion) throws ApiException {
    Object localVarPostBody = statefulConfigurations;
    
    // verify the required parameter 'statefulConfigurations' is set
    if (statefulConfigurations == null) {
      throw new ApiException(400, "Missing the required parameter 'statefulConfigurations' when calling createStatefulConfiguration");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createStatefulConfiguration");
    }
    
    // create path and map variables
    String localVarPath = "/statefulconfigurations".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<StatefulConfiguration> localVarReturnType = new GenericType<StatefulConfiguration>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete a Stateful Configuration
   * Delete a stateful configuration by ID.
   * @param statefulConfigurationID The ID number of the stateful configuration to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteStatefulConfiguration(Integer statefulConfigurationID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'statefulConfigurationID' is set
    if (statefulConfigurationID == null) {
      throw new ApiException(400, "Missing the required parameter 'statefulConfigurationID' when calling deleteStatefulConfiguration");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteStatefulConfiguration");
    }
    
    // create path and map variables
    String localVarPath = "/statefulconfigurations/{statefulConfigurationID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "statefulConfigurationID" + "\\}", apiClient.escapeString(statefulConfigurationID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe a Stateful Configuration
   * Describe a stateful configuration by ID.
   * @param statefulConfigurationID The ID number of the stateful configuration to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return StatefulConfiguration
   * @throws ApiException if fails to make API call
   */
  public StatefulConfiguration describeStatefulConfiguration(Integer statefulConfigurationID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'statefulConfigurationID' is set
    if (statefulConfigurationID == null) {
      throw new ApiException(400, "Missing the required parameter 'statefulConfigurationID' when calling describeStatefulConfiguration");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeStatefulConfiguration");
    }
    
    // create path and map variables
    String localVarPath = "/statefulconfigurations/{statefulConfigurationID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "statefulConfigurationID" + "\\}", apiClient.escapeString(statefulConfigurationID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<StatefulConfiguration> localVarReturnType = new GenericType<StatefulConfiguration>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Stateful Configurations
   * Lists all stateful configurations.
   * @param apiVersion The version of the api being called. (required)
   * @return StatefulConfigurations
   * @throws ApiException if fails to make API call
   */
  public StatefulConfigurations listStatefulConfigurations(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listStatefulConfigurations");
    }
    
    // create path and map variables
    String localVarPath = "/statefulconfigurations".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<StatefulConfigurations> localVarReturnType = new GenericType<StatefulConfigurations>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify a Stateful Configuration
   * Modify a stateful configuration by ID. Any unset elements will be left unchanged.
   * @param statefulConfigurationID The ID number of the stateful configuration to modify. (required)
   * @param statefulConfiguration The settings of the stateful configuration to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return StatefulConfiguration
   * @throws ApiException if fails to make API call
   */
  public StatefulConfiguration modifyStatefulConfiguration(Integer statefulConfigurationID, StatefulConfiguration statefulConfiguration, String apiVersion) throws ApiException {
    Object localVarPostBody = statefulConfiguration;
    
    // verify the required parameter 'statefulConfigurationID' is set
    if (statefulConfigurationID == null) {
      throw new ApiException(400, "Missing the required parameter 'statefulConfigurationID' when calling modifyStatefulConfiguration");
    }
    
    // verify the required parameter 'statefulConfiguration' is set
    if (statefulConfiguration == null) {
      throw new ApiException(400, "Missing the required parameter 'statefulConfiguration' when calling modifyStatefulConfiguration");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyStatefulConfiguration");
    }
    
    // create path and map variables
    String localVarPath = "/statefulconfigurations/{statefulConfigurationID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "statefulConfigurationID" + "\\}", apiClient.escapeString(statefulConfigurationID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<StatefulConfiguration> localVarReturnType = new GenericType<StatefulConfiguration>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Stateful Configurations
   * Search for stateful configurations using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return StatefulConfigurations
   * @throws ApiException if fails to make API call
   */
  public StatefulConfigurations searchStatefulConfigurations(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchStatefulConfigurations");
    }
    
    // create path and map variables
    String localVarPath = "/statefulconfigurations/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<StatefulConfigurations> localVarReturnType = new GenericType<StatefulConfigurations>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
