/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.AWSRegion;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Defines an AWS Cloud Connector that is used to retrieve information from AWS.
 */
@ApiModel(description = "Defines an AWS Cloud Connector that is used to retrieve information from AWS.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class AWSConnector {
  @JsonProperty("displayName")
  private String displayName = null;

  @JsonProperty("accountId")
  private String accountId = null;

  @JsonProperty("accountAlias")
  private String accountAlias = null;

  @JsonProperty("accessKey")
  private String accessKey = null;

  @JsonProperty("secretKey")
  private String secretKey = null;

  @JsonProperty("seedRegion")
  private String seedRegion = null;

  @JsonProperty("useInstanceRole")
  private Boolean useInstanceRole = null;

  @JsonProperty("crossAccountRoleArn")
  private String crossAccountRoleArn = null;

  @JsonProperty("lastSyncTime")
  private Long lastSyncTime = null;

  @JsonProperty("syncedRegions")
  private List<AWSRegion> syncedRegions = null;

  @JsonProperty("workspacesEnabled")
  private Boolean workspacesEnabled = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public AWSConnector displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * The AWS Connector&#39;s display name in DSM.
   * @return displayName
  **/
  @ApiModelProperty(value = "The AWS Connector's display name in DSM.")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

  public AWSConnector accountId(String accountId) {
    this.accountId = accountId;
    return this;
  }

   /**
   * The AWS Account ID. Searchable as String.
   * @return accountId
  **/
  @ApiModelProperty(value = "The AWS Account ID. Searchable as String.")
  public String getAccountId() {
    return accountId;
  }

  public void setAccountId(String accountId) {
    this.accountId = accountId;
  }

  public AWSConnector accountAlias(String accountAlias) {
    this.accountAlias = accountAlias;
    return this;
  }

   /**
   * The AWS Account Alias. Searchable as String.
   * @return accountAlias
  **/
  @ApiModelProperty(value = "The AWS Account Alias. Searchable as String.")
  public String getAccountAlias() {
    return accountAlias;
  }

  public void setAccountAlias(String accountAlias) {
    this.accountAlias = accountAlias;
  }

  public AWSConnector accessKey(String accessKey) {
    this.accessKey = accessKey;
    return this;
  }

   /**
   * The AWS Access Key of the account. If used, Cross Account Role ARN is not required. Searchable as String.
   * @return accessKey
  **/
  @ApiModelProperty(value = "The AWS Access Key of the account. If used, Cross Account Role ARN is not required. Searchable as String.")
  public String getAccessKey() {
    return accessKey;
  }

  public void setAccessKey(String accessKey) {
    this.accessKey = accessKey;
  }

  public AWSConnector secretKey(String secretKey) {
    this.secretKey = secretKey;
    return this;
  }

   /**
   * The AWS Secret Key required to add the connector using an Access Key. Not present in returned objects.
   * @return secretKey
  **/
  @ApiModelProperty(value = "The AWS Secret Key required to add the connector using an Access Key. Not present in returned objects.")
  public String getSecretKey() {
    return secretKey;
  }

  public void setSecretKey(String secretKey) {
    this.secretKey = secretKey;
  }

  public AWSConnector seedRegion(String seedRegion) {
    this.seedRegion = seedRegion;
    return this;
  }

   /**
   * The region to initialize the EC2 client in. This is an advanced option used if you want to access special regions. Searchable as String.
   * @return seedRegion
  **/
  @ApiModelProperty(value = "The region to initialize the EC2 client in. This is an advanced option used if you want to access special regions. Searchable as String.")
  public String getSeedRegion() {
    return seedRegion;
  }

  public void setSeedRegion(String seedRegion) {
    this.seedRegion = seedRegion;
  }

  public AWSConnector useInstanceRole(Boolean useInstanceRole) {
    this.useInstanceRole = useInstanceRole;
    return this;
  }

   /**
   * Specifies whether or not to use the DSM instance role to add the AWS Connector instead of an Access Key or a Cross Account Role ARN.
   * @return useInstanceRole
  **/
  @ApiModelProperty(value = "Specifies whether or not to use the DSM instance role to add the AWS Connector instead of an Access Key or a Cross Account Role ARN.")
  public Boolean isUseInstanceRole() {
    return useInstanceRole;
  }

  public void setUseInstanceRole(Boolean useInstanceRole) {
    this.useInstanceRole = useInstanceRole;
  }

  public AWSConnector crossAccountRoleArn(String crossAccountRoleArn) {
    this.crossAccountRoleArn = crossAccountRoleArn;
    return this;
  }

   /**
   * The Cross Account Role ARN of the AWS account. If used, Access Key is not required. Searchable as String.
   * @return crossAccountRoleArn
  **/
  @ApiModelProperty(value = "The Cross Account Role ARN of the AWS account. If used, Access Key is not required. Searchable as String.")
  public String getCrossAccountRoleArn() {
    return crossAccountRoleArn;
  }

  public void setCrossAccountRoleArn(String crossAccountRoleArn) {
    this.crossAccountRoleArn = crossAccountRoleArn;
  }

  public AWSConnector lastSyncTime(Long lastSyncTime) {
    this.lastSyncTime = lastSyncTime;
    return this;
  }

   /**
   * Timestamp of the last time the AWS Connector was successfully synchronized, in milliseconds since epoch. Searchable as Date.
   * @return lastSyncTime
  **/
  @ApiModelProperty(value = "Timestamp of the last time the AWS Connector was successfully synchronized, in milliseconds since epoch. Searchable as Date.")
  public Long getLastSyncTime() {
    return lastSyncTime;
  }

  public void setLastSyncTime(Long lastSyncTime) {
    this.lastSyncTime = lastSyncTime;
  }

  public AWSConnector syncedRegions(List<AWSRegion> syncedRegions) {
    this.syncedRegions = syncedRegions;
    return this;
  }

  public AWSConnector addSyncedRegionsItem(AWSRegion syncedRegionsItem) {
    if (this.syncedRegions == null) {
      this.syncedRegions = new ArrayList<>();
    }
    this.syncedRegions.add(syncedRegionsItem);
    return this;
  }

   /**
   * The list of AWS regions that have been synchronized for the connector.
   * @return syncedRegions
  **/
  @ApiModelProperty(value = "The list of AWS regions that have been synchronized for the connector.")
  public List<AWSRegion> getSyncedRegions() {
    return syncedRegions;
  }

  public void setSyncedRegions(List<AWSRegion> syncedRegions) {
    this.syncedRegions = syncedRegions;
  }

  public AWSConnector workspacesEnabled(Boolean workspacesEnabled) {
    this.workspacesEnabled = workspacesEnabled;
    return this;
  }

   /**
   * A flag controlling whether or not Amazon Workspaces are enabled for the connector. Searchable as Boolean. Default is false.
   * @return workspacesEnabled
  **/
  @ApiModelProperty(value = "A flag controlling whether or not Amazon Workspaces are enabled for the connector. Searchable as Boolean. Default is false.")
  public Boolean isWorkspacesEnabled() {
    return workspacesEnabled;
  }

  public void setWorkspacesEnabled(Boolean workspacesEnabled) {
    this.workspacesEnabled = workspacesEnabled;
  }

   /**
   * The Deep Security internal ID of the AWS Cloud Connector. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "The Deep Security internal ID of the AWS Cloud Connector. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AWSConnector awSConnector = (AWSConnector) o;
    return Objects.equals(this.displayName, awSConnector.displayName) &&
        Objects.equals(this.accountId, awSConnector.accountId) &&
        Objects.equals(this.accountAlias, awSConnector.accountAlias) &&
        Objects.equals(this.accessKey, awSConnector.accessKey) &&
        Objects.equals(this.secretKey, awSConnector.secretKey) &&
        Objects.equals(this.seedRegion, awSConnector.seedRegion) &&
        Objects.equals(this.useInstanceRole, awSConnector.useInstanceRole) &&
        Objects.equals(this.crossAccountRoleArn, awSConnector.crossAccountRoleArn) &&
        Objects.equals(this.lastSyncTime, awSConnector.lastSyncTime) &&
        Objects.equals(this.syncedRegions, awSConnector.syncedRegions) &&
        Objects.equals(this.workspacesEnabled, awSConnector.workspacesEnabled) &&
        Objects.equals(this.ID, awSConnector.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(displayName, accountId, accountAlias, accessKey, secretKey, seedRegion, useInstanceRole, crossAccountRoleArn, lastSyncTime, syncedRegions, workspacesEnabled, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AWSConnector {\n");
    
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    accountId: ").append(toIndentedString(accountId)).append("\n");
    sb.append("    accountAlias: ").append(toIndentedString(accountAlias)).append("\n");
    sb.append("    accessKey: ").append(toIndentedString(accessKey)).append("\n");
    sb.append("    secretKey: ").append(toIndentedString(secretKey)).append("\n");
    sb.append("    seedRegion: ").append(toIndentedString(seedRegion)).append("\n");
    sb.append("    useInstanceRole: ").append(toIndentedString(useInstanceRole)).append("\n");
    sb.append("    crossAccountRoleArn: ").append(toIndentedString(crossAccountRoleArn)).append("\n");
    sb.append("    lastSyncTime: ").append(toIndentedString(lastSyncTime)).append("\n");
    sb.append("    syncedRegions: ").append(toIndentedString(syncedRegions)).append("\n");
    sb.append("    workspacesEnabled: ").append(toIndentedString(workspacesEnabled)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

