/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Agent deployment script.
 */
@ApiModel(description = "Agent deployment script.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class AgentDeploymentScript {
  /**
   * Platform type for agent deployment.
   */
  public enum PlatformEnum {
    LINUX("linux"),
    
    WINDOWS("windows"),
    
    SOLARIS("solaris"),
    
    AIX("aix");

    private String value;

    PlatformEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PlatformEnum fromValue(String text) {
      for (PlatformEnum b : PlatformEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("platform")
  private PlatformEnum platform = null;

  @JsonProperty("validateCertificateRequired")
  private Boolean validateCertificateRequired = null;

  @JsonProperty("validateDigitalSignatureRequired")
  private Boolean validateDigitalSignatureRequired = null;

  @JsonProperty("activationRequired")
  private Boolean activationRequired = null;

  @JsonProperty("dsmProxyID")
  private Integer dsmProxyID = null;

  @JsonProperty("relayProxyID")
  private Integer relayProxyID = null;

  @JsonProperty("policyID")
  private Integer policyID = null;

  @JsonProperty("relayGroupID")
  private Integer relayGroupID = null;

  @JsonProperty("computerGroupID")
  private Integer computerGroupID = null;

  @JsonProperty("scriptBody")
  private String scriptBody = null;

  public AgentDeploymentScript platform(PlatformEnum platform) {
    this.platform = platform;
    return this;
  }

   /**
   * Platform type for agent deployment.
   * @return platform
  **/
  @ApiModelProperty(value = "Platform type for agent deployment.")
  public PlatformEnum getPlatform() {
    return platform;
  }

  public void setPlatform(PlatformEnum platform) {
    this.platform = platform;
  }

  public AgentDeploymentScript validateCertificateRequired(Boolean validateCertificateRequired) {
    this.validateCertificateRequired = validateCertificateRequired;
    return this;
  }

   /**
   * Validate if Deep Security Manager is using a valid TLS certificate from a trusted certificate authority (CA) when downloading the agent software.
   * @return validateCertificateRequired
  **/
  @ApiModelProperty(value = "Validate if Deep Security Manager is using a valid TLS certificate from a trusted certificate authority (CA) when downloading the agent software.")
  public Boolean isValidateCertificateRequired() {
    return validateCertificateRequired;
  }

  public void setValidateCertificateRequired(Boolean validateCertificateRequired) {
    this.validateCertificateRequired = validateCertificateRequired;
  }

  public AgentDeploymentScript validateDigitalSignatureRequired(Boolean validateDigitalSignatureRequired) {
    this.validateDigitalSignatureRequired = validateDigitalSignatureRequired;
    return this;
  }

   /**
   * Validate digital signature of Deep Security Agent installer.
   * @return validateDigitalSignatureRequired
  **/
  @ApiModelProperty(value = "Validate digital signature of Deep Security Agent installer.")
  public Boolean isValidateDigitalSignatureRequired() {
    return validateDigitalSignatureRequired;
  }

  public void setValidateDigitalSignatureRequired(Boolean validateDigitalSignatureRequired) {
    this.validateDigitalSignatureRequired = validateDigitalSignatureRequired;
  }

  public AgentDeploymentScript activationRequired(Boolean activationRequired) {
    this.activationRequired = activationRequired;
    return this;
  }

   /**
   * Activate the agent at startup.
   * @return activationRequired
  **/
  @ApiModelProperty(value = "Activate the agent at startup.")
  public Boolean isActivationRequired() {
    return activationRequired;
  }

  public void setActivationRequired(Boolean activationRequired) {
    this.activationRequired = activationRequired;
  }

  public AgentDeploymentScript dsmProxyID(Integer dsmProxyID) {
    this.dsmProxyID = dsmProxyID;
    return this;
  }

   /**
   * ID of the proxy server for contacting Deep Security Manager.
   * @return dsmProxyID
  **/
  @ApiModelProperty(value = "ID of the proxy server for contacting Deep Security Manager.")
  public Integer getDsmProxyID() {
    return dsmProxyID;
  }

  public void setDsmProxyID(Integer dsmProxyID) {
    this.dsmProxyID = dsmProxyID;
  }

  public AgentDeploymentScript relayProxyID(Integer relayProxyID) {
    this.relayProxyID = relayProxyID;
    return this;
  }

   /**
   * ID of the proxy server for contacting Relay(s).
   * @return relayProxyID
  **/
  @ApiModelProperty(value = "ID of the proxy server for contacting Relay(s).")
  public Integer getRelayProxyID() {
    return relayProxyID;
  }

  public void setRelayProxyID(Integer relayProxyID) {
    this.relayProxyID = relayProxyID;
  }

  public AgentDeploymentScript policyID(Integer policyID) {
    this.policyID = policyID;
    return this;
  }

   /**
   * ID of the policy assigned to the computer.
   * @return policyID
  **/
  @ApiModelProperty(value = "ID of the policy assigned to the computer.")
  public Integer getPolicyID() {
    return policyID;
  }

  public void setPolicyID(Integer policyID) {
    this.policyID = policyID;
  }

  public AgentDeploymentScript relayGroupID(Integer relayGroupID) {
    this.relayGroupID = relayGroupID;
    return this;
  }

   /**
   * ID of the relay group to which the computer belongs.
   * @return relayGroupID
  **/
  @ApiModelProperty(value = "ID of the relay group to which the computer belongs.")
  public Integer getRelayGroupID() {
    return relayGroupID;
  }

  public void setRelayGroupID(Integer relayGroupID) {
    this.relayGroupID = relayGroupID;
  }

  public AgentDeploymentScript computerGroupID(Integer computerGroupID) {
    this.computerGroupID = computerGroupID;
    return this;
  }

   /**
   * ID of the computer group to which the computer belongs.
   * @return computerGroupID
  **/
  @ApiModelProperty(value = "ID of the computer group to which the computer belongs.")
  public Integer getComputerGroupID() {
    return computerGroupID;
  }

  public void setComputerGroupID(Integer computerGroupID) {
    this.computerGroupID = computerGroupID;
  }

   /**
   * Agent deployment script.
   * @return scriptBody
  **/
  @ApiModelProperty(value = "Agent deployment script.")
  public String getScriptBody() {
    return scriptBody;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AgentDeploymentScript agentDeploymentScript = (AgentDeploymentScript) o;
    return Objects.equals(this.platform, agentDeploymentScript.platform) &&
        Objects.equals(this.validateCertificateRequired, agentDeploymentScript.validateCertificateRequired) &&
        Objects.equals(this.validateDigitalSignatureRequired, agentDeploymentScript.validateDigitalSignatureRequired) &&
        Objects.equals(this.activationRequired, agentDeploymentScript.activationRequired) &&
        Objects.equals(this.dsmProxyID, agentDeploymentScript.dsmProxyID) &&
        Objects.equals(this.relayProxyID, agentDeploymentScript.relayProxyID) &&
        Objects.equals(this.policyID, agentDeploymentScript.policyID) &&
        Objects.equals(this.relayGroupID, agentDeploymentScript.relayGroupID) &&
        Objects.equals(this.computerGroupID, agentDeploymentScript.computerGroupID) &&
        Objects.equals(this.scriptBody, agentDeploymentScript.scriptBody);
  }

  @Override
  public int hashCode() {
    return Objects.hash(platform, validateCertificateRequired, validateDigitalSignatureRequired, activationRequired, dsmProxyID, relayProxyID, policyID, relayGroupID, computerGroupID, scriptBody);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AgentDeploymentScript {\n");
    
    sb.append("    platform: ").append(toIndentedString(platform)).append("\n");
    sb.append("    validateCertificateRequired: ").append(toIndentedString(validateCertificateRequired)).append("\n");
    sb.append("    validateDigitalSignatureRequired: ").append(toIndentedString(validateDigitalSignatureRequired)).append("\n");
    sb.append("    activationRequired: ").append(toIndentedString(activationRequired)).append("\n");
    sb.append("    dsmProxyID: ").append(toIndentedString(dsmProxyID)).append("\n");
    sb.append("    relayProxyID: ").append(toIndentedString(relayProxyID)).append("\n");
    sb.append("    policyID: ").append(toIndentedString(policyID)).append("\n");
    sb.append("    relayGroupID: ").append(toIndentedString(relayGroupID)).append("\n");
    sb.append("    computerGroupID: ").append(toIndentedString(computerGroupID)).append("\n");
    sb.append("    scriptBody: ").append(toIndentedString(scriptBody)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

