/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of an API key. Use API keys to authenticate requests with Deep Security Manager.
 */
@ApiModel(description = "Details of an API key. Use API keys to authenticate requests with Deep Security Manager.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ApiKeyCurrent {
  @JsonProperty("keyName")
  private String keyName = null;

  @JsonProperty("description")
  private String description = null;

  /**
   * Country and language for the APIKey.
   */
  public enum LocaleEnum {
    EN_US("en-US"),
    
    JA_JP("ja-JP");

    private String value;

    LocaleEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static LocaleEnum fromValue(String text) {
      for (LocaleEnum b : LocaleEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("locale")
  private LocaleEnum locale = null;

  @JsonProperty("roleID")
  private Integer roleID = null;

  @JsonProperty("timeZone")
  private String timeZone = null;

  @JsonProperty("active")
  private Boolean active = null;

  @JsonProperty("created")
  private Long created = null;

  @JsonProperty("lastSignIn")
  private Long lastSignIn = null;

  @JsonProperty("unlockTime")
  private Long unlockTime = null;

  @JsonProperty("unsuccessfulSignInAttempts")
  private Integer unsuccessfulSignInAttempts = null;

  @JsonProperty("expiryDate")
  private Long expiryDate = null;

  @JsonProperty("secretKey")
  private String secretKey = null;

  @JsonProperty("serviceAccount")
  private Boolean serviceAccount = null;

  @JsonProperty("roleURN")
  private String roleURN = null;

  @JsonProperty("tenantID")
  private Integer tenantID = null;

  @JsonProperty("tenantGUID")
  private String tenantGUID = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public ApiKeyCurrent keyName(String keyName) {
    this.keyName = keyName;
    return this;
  }

   /**
   * Display name of the APIKey. Searchable as String.
   * @return keyName
  **/
  @ApiModelProperty(value = "Display name of the APIKey. Searchable as String.")
  public String getKeyName() {
    return keyName;
  }

  public void setKeyName(String keyName) {
    this.keyName = keyName;
  }

  public ApiKeyCurrent description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the APIKey. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the APIKey. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ApiKeyCurrent locale(LocaleEnum locale) {
    this.locale = locale;
    return this;
  }

   /**
   * Country and language for the APIKey.
   * @return locale
  **/
  @ApiModelProperty(value = "Country and language for the APIKey.")
  public LocaleEnum getLocale() {
    return locale;
  }

  public void setLocale(LocaleEnum locale) {
    this.locale = locale;
  }

  public ApiKeyCurrent roleID(Integer roleID) {
    this.roleID = roleID;
    return this;
  }

   /**
   * ID of the role assigned to the APIKey. Searchable as Numeric.
   * @return roleID
  **/
  @ApiModelProperty(value = "ID of the role assigned to the APIKey. Searchable as Numeric.")
  public Integer getRoleID() {
    return roleID;
  }

  public void setRoleID(Integer roleID) {
    this.roleID = roleID;
  }

  public ApiKeyCurrent timeZone(String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

   /**
   * Display name of the APIKey&#39;s time zone, e.g. America/New_York. Searchable as String.
   * @return timeZone
  **/
  @ApiModelProperty(value = "Display name of the APIKey's time zone, e.g. America/New_York. Searchable as String.")
  public String getTimeZone() {
    return timeZone;
  }

  public void setTimeZone(String timeZone) {
    this.timeZone = timeZone;
  }

  public ApiKeyCurrent active(Boolean active) {
    this.active = active;
    return this;
  }

   /**
   * If true, the APIKey can be used to authenticate. If false, the APIKey is locked out. Searchable as Boolean.
   * @return active
  **/
  @ApiModelProperty(value = "If true, the APIKey can be used to authenticate. If false, the APIKey is locked out. Searchable as Boolean.")
  public Boolean isActive() {
    return active;
  }

  public void setActive(Boolean active) {
    this.active = active;
  }

  public ApiKeyCurrent created(Long created) {
    this.created = created;
    return this;
  }

   /**
   * Timestamp of the APIKey&#39;s creation, in milliseconds since epoch. Searchable as Date.
   * @return created
  **/
  @ApiModelProperty(value = "Timestamp of the APIKey's creation, in milliseconds since epoch. Searchable as Date.")
  public Long getCreated() {
    return created;
  }

  public void setCreated(Long created) {
    this.created = created;
  }

  public ApiKeyCurrent lastSignIn(Long lastSignIn) {
    this.lastSignIn = lastSignIn;
    return this;
  }

   /**
   * Timestamp of the APIKey&#39;s last successful authentication, in milliseconds since epoch. Searchable as Date.
   * @return lastSignIn
  **/
  @ApiModelProperty(value = "Timestamp of the APIKey's last successful authentication, in milliseconds since epoch. Searchable as Date.")
  public Long getLastSignIn() {
    return lastSignIn;
  }

  public void setLastSignIn(Long lastSignIn) {
    this.lastSignIn = lastSignIn;
  }

  public ApiKeyCurrent unlockTime(Long unlockTime) {
    this.unlockTime = unlockTime;
    return this;
  }

   /**
   * Timestamp of when a locked out APIKey will be unlocked, in milliseconds since epoch. Searchable as Date.
   * @return unlockTime
  **/
  @ApiModelProperty(value = "Timestamp of when a locked out APIKey will be unlocked, in milliseconds since epoch. Searchable as Date.")
  public Long getUnlockTime() {
    return unlockTime;
  }

  public void setUnlockTime(Long unlockTime) {
    this.unlockTime = unlockTime;
  }

  public ApiKeyCurrent unsuccessfulSignInAttempts(Integer unsuccessfulSignInAttempts) {
    this.unsuccessfulSignInAttempts = unsuccessfulSignInAttempts;
    return this;
  }

   /**
   * Number of unsuccessful authentication attempts made since the last successful authentication. Searchable as Numeric.
   * @return unsuccessfulSignInAttempts
  **/
  @ApiModelProperty(value = "Number of unsuccessful authentication attempts made since the last successful authentication. Searchable as Numeric.")
  public Integer getUnsuccessfulSignInAttempts() {
    return unsuccessfulSignInAttempts;
  }

  public void setUnsuccessfulSignInAttempts(Integer unsuccessfulSignInAttempts) {
    this.unsuccessfulSignInAttempts = unsuccessfulSignInAttempts;
  }

  public ApiKeyCurrent expiryDate(Long expiryDate) {
    this.expiryDate = expiryDate;
    return this;
  }

   /**
   * Timestamp of the APIKey&#39;s expiry date, in milliseconds since epoch. Searchable as Date.
   * @return expiryDate
  **/
  @ApiModelProperty(value = "Timestamp of the APIKey's expiry date, in milliseconds since epoch. Searchable as Date.")
  public Long getExpiryDate() {
    return expiryDate;
  }

  public void setExpiryDate(Long expiryDate) {
    this.expiryDate = expiryDate;
  }

   /**
   * Secret key used to authenticate API requests. Only returned when creating a new APIKey or regenerating the secret key.
   * @return secretKey
  **/
  @ApiModelProperty(value = "Secret key used to authenticate API requests. Only returned when creating a new APIKey or regenerating the secret key.")
  public String getSecretKey() {
    return secretKey;
  }

   /**
   * If true, the APIKey was created by the primary tenant (T0) to authenticate API calls against other tenants&#39; databases. Searchable as Boolean.
   * @return serviceAccount
  **/
  @ApiModelProperty(value = "If true, the APIKey was created by the primary tenant (T0) to authenticate API calls against other tenants' databases. Searchable as Boolean.")
  public Boolean isServiceAccount() {
    return serviceAccount;
  }

   /**
   * Uniform resource name of the role assigned to the APIKey.
   * @return roleURN
  **/
  @ApiModelProperty(value = "Uniform resource name of the role assigned to the APIKey.")
  public String getRoleURN() {
    return roleURN;
  }

   /**
   * Tenant ID of the APIKey.
   * @return tenantID
  **/
  @ApiModelProperty(value = "Tenant ID of the APIKey.")
  public Integer getTenantID() {
    return tenantID;
  }

   /**
   * Tenant GUID of the APIKey.
   * @return tenantGUID
  **/
  @ApiModelProperty(value = "Tenant GUID of the APIKey.")
  public String getTenantGUID() {
    return tenantGUID;
  }

   /**
   * ID of the APIKey. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the APIKey. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiKeyCurrent apiKeyCurrent = (ApiKeyCurrent) o;
    return Objects.equals(this.keyName, apiKeyCurrent.keyName) &&
        Objects.equals(this.description, apiKeyCurrent.description) &&
        Objects.equals(this.locale, apiKeyCurrent.locale) &&
        Objects.equals(this.roleID, apiKeyCurrent.roleID) &&
        Objects.equals(this.timeZone, apiKeyCurrent.timeZone) &&
        Objects.equals(this.active, apiKeyCurrent.active) &&
        Objects.equals(this.created, apiKeyCurrent.created) &&
        Objects.equals(this.lastSignIn, apiKeyCurrent.lastSignIn) &&
        Objects.equals(this.unlockTime, apiKeyCurrent.unlockTime) &&
        Objects.equals(this.unsuccessfulSignInAttempts, apiKeyCurrent.unsuccessfulSignInAttempts) &&
        Objects.equals(this.expiryDate, apiKeyCurrent.expiryDate) &&
        Objects.equals(this.secretKey, apiKeyCurrent.secretKey) &&
        Objects.equals(this.serviceAccount, apiKeyCurrent.serviceAccount) &&
        Objects.equals(this.roleURN, apiKeyCurrent.roleURN) &&
        Objects.equals(this.tenantID, apiKeyCurrent.tenantID) &&
        Objects.equals(this.tenantGUID, apiKeyCurrent.tenantGUID) &&
        Objects.equals(this.ID, apiKeyCurrent.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(keyName, description, locale, roleID, timeZone, active, created, lastSignIn, unlockTime, unsuccessfulSignInAttempts, expiryDate, secretKey, serviceAccount, roleURN, tenantID, tenantGUID, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiKeyCurrent {\n");
    
    sb.append("    keyName: ").append(toIndentedString(keyName)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    locale: ").append(toIndentedString(locale)).append("\n");
    sb.append("    roleID: ").append(toIndentedString(roleID)).append("\n");
    sb.append("    timeZone: ").append(toIndentedString(timeZone)).append("\n");
    sb.append("    active: ").append(toIndentedString(active)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastSignIn: ").append(toIndentedString(lastSignIn)).append("\n");
    sb.append("    unlockTime: ").append(toIndentedString(unlockTime)).append("\n");
    sb.append("    unsuccessfulSignInAttempts: ").append(toIndentedString(unsuccessfulSignInAttempts)).append("\n");
    sb.append("    expiryDate: ").append(toIndentedString(expiryDate)).append("\n");
    sb.append("    secretKey: ").append(toIndentedString(secretKey)).append("\n");
    sb.append("    serviceAccount: ").append(toIndentedString(serviceAccount)).append("\n");
    sb.append("    roleURN: ").append(toIndentedString(roleURN)).append("\n");
    sb.append("    tenantID: ").append(toIndentedString(tenantID)).append("\n");
    sb.append("    tenantGUID: ").append(toIndentedString(tenantGUID)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

