/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Ruleset rule details.
 */
@ApiModel(description = "Ruleset rule details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ApplicationControlRule {
  @JsonProperty("sha256")
  private String sha256 = null;

  @JsonProperty("size")
  private Long size = null;

  /**
   * Action to take when a user launches the executable. Searchable as Choice.
   */
  public enum ActionEnum {
    ALLOW("allow"),
    
    BLOCK("block");

    private String value;

    ActionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ActionEnum fromValue(String text) {
      for (ActionEnum b : ActionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("action")
  private ActionEnum action = null;

  @JsonProperty("path")
  private String path = null;

  @JsonProperty("fileName")
  private String fileName = null;

  @JsonProperty("lastUpdatedAdministrator")
  private Integer lastUpdatedAdministrator = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("ID")
  private Long ID = null;

   /**
   * SHA-256 hash of the executable. Searchable as String.
   * @return sha256
  **/
  @ApiModelProperty(value = "SHA-256 hash of the executable. Searchable as String.")
  public String getSha256() {
    return sha256;
  }

   /**
   * Size of the executable in bytes. Searchable as Numeric.
   * @return size
  **/
  @ApiModelProperty(value = "Size of the executable in bytes. Searchable as Numeric.")
  public Long getSize() {
    return size;
  }

  public ApplicationControlRule action(ActionEnum action) {
    this.action = action;
    return this;
  }

   /**
   * Action to take when a user launches the executable. Searchable as Choice.
   * @return action
  **/
  @ApiModelProperty(value = "Action to take when a user launches the executable. Searchable as Choice.")
  public ActionEnum getAction() {
    return action;
  }

  public void setAction(ActionEnum action) {
    this.action = action;
  }

   /**
   * Full path of the executable. Searchable as String.
   * @return path
  **/
  @ApiModelProperty(value = "Full path of the executable. Searchable as String.")
  public String getPath() {
    return path;
  }

   /**
   * File name of the executable.
   * @return fileName
  **/
  @ApiModelProperty(value = "File name of the executable.")
  public String getFileName() {
    return fileName;
  }

   /**
   * ID of the last administrator to update the rule. Searchable as Numeric.
   * @return lastUpdatedAdministrator
  **/
  @ApiModelProperty(value = "ID of the last administrator to update the rule. Searchable as Numeric.")
  public Integer getLastUpdatedAdministrator() {
    return lastUpdatedAdministrator;
  }

   /**
   * Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp of the last rule modification, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

   /**
   * ID of the rule. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the rule. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationControlRule applicationControlRule = (ApplicationControlRule) o;
    return Objects.equals(this.sha256, applicationControlRule.sha256) &&
        Objects.equals(this.size, applicationControlRule.size) &&
        Objects.equals(this.action, applicationControlRule.action) &&
        Objects.equals(this.path, applicationControlRule.path) &&
        Objects.equals(this.fileName, applicationControlRule.fileName) &&
        Objects.equals(this.lastUpdatedAdministrator, applicationControlRule.lastUpdatedAdministrator) &&
        Objects.equals(this.lastUpdated, applicationControlRule.lastUpdated) &&
        Objects.equals(this.ID, applicationControlRule.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sha256, size, action, path, fileName, lastUpdatedAdministrator, lastUpdated, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationControlRule {\n");
    
    sb.append("    sha256: ").append(toIndentedString(sha256)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("    path: ").append(toIndentedString(path)).append("\n");
    sb.append("    fileName: ").append(toIndentedString(fileName)).append("\n");
    sb.append("    lastUpdatedAdministrator: ").append(toIndentedString(lastUpdatedAdministrator)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

