/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Application Types are useful for grouping intrusion prevention rules that have a common purpose.
 */
@ApiModel(description = "Application Types are useful for grouping intrusion prevention rules that have a common purpose.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ApplicationType {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("minimumAgentVersion")
  private String minimumAgentVersion = null;

  /**
   * Direction of the initial communication for the ApplicationType (e.g. &#39;outgoing&#39; for web browsers). Searchable as Choice.
   */
  public enum DirectionEnum {
    INCOMING("incoming"),
    
    OUTGOING("outgoing");

    private String value;

    DirectionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DirectionEnum fromValue(String text) {
      for (DirectionEnum b : DirectionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("direction")
  private DirectionEnum direction = null;

  /**
   * Protocol used by the ApplicationType. Searchable as Choice.
   */
  public enum ProtocolEnum {
    ICMP("icmp"),
    
    TCP("tcp"),
    
    UDP("udp"),
    
    TCP_UDP("tcp-udp");

    private String value;

    ProtocolEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ProtocolEnum fromValue(String text) {
      for (ProtocolEnum b : ProtocolEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("protocol")
  private ProtocolEnum protocol = null;

  /**
   * Port number configuration type. Searchable as Choice.
   */
  public enum PortTypeEnum {
    ANY("any"),
    
    MULTIPLE("multiple"),
    
    PORT_LIST("port-list");

    private String value;

    PortTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PortTypeEnum fromValue(String text) {
      for (PortTypeEnum b : PortTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("portType")
  private PortTypeEnum portType = null;

  @JsonProperty("portMultiple")
  private List<String> portMultiple = null;

  @JsonProperty("portListID")
  private Integer portListID = null;

  /**
   * Indicates whether recommendation scans consider the ApplicationType. Create an ApplicationType computer or policy override to modify this value. Searchable as Choice.
   */
  public enum RecommendationsModeEnum {
    ENABLED("enabled"),
    
    IGNORED("ignored"),
    
    UNKNOWN("unknown"),
    
    DISABLED("disabled");

    private String value;

    RecommendationsModeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RecommendationsModeEnum fromValue(String text) {
      for (RecommendationsModeEnum b : RecommendationsModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("recommendationsMode")
  private RecommendationsModeEnum recommendationsMode = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public ApplicationType name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Display name of the ApplicationType. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Display name of the ApplicationType. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ApplicationType description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the ApplicationType. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the ApplicationType. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ApplicationType minimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
    return this;
  }

   /**
   * Version of the Deep Security agent or appliance required to support the ApplicationType. Searchable as String.
   * @return minimumAgentVersion
  **/
  @ApiModelProperty(value = "Version of the Deep Security agent or appliance required to support the ApplicationType. Searchable as String.")
  public String getMinimumAgentVersion() {
    return minimumAgentVersion;
  }

  public void setMinimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
  }

  public ApplicationType direction(DirectionEnum direction) {
    this.direction = direction;
    return this;
  }

   /**
   * Direction of the initial communication for the ApplicationType (e.g. &#39;outgoing&#39; for web browsers). Searchable as Choice.
   * @return direction
  **/
  @ApiModelProperty(value = "Direction of the initial communication for the ApplicationType (e.g. 'outgoing' for web browsers). Searchable as Choice.")
  public DirectionEnum getDirection() {
    return direction;
  }

  public void setDirection(DirectionEnum direction) {
    this.direction = direction;
  }

  public ApplicationType protocol(ProtocolEnum protocol) {
    this.protocol = protocol;
    return this;
  }

   /**
   * Protocol used by the ApplicationType. Searchable as Choice.
   * @return protocol
  **/
  @ApiModelProperty(value = "Protocol used by the ApplicationType. Searchable as Choice.")
  public ProtocolEnum getProtocol() {
    return protocol;
  }

  public void setProtocol(ProtocolEnum protocol) {
    this.protocol = protocol;
  }

  public ApplicationType portType(PortTypeEnum portType) {
    this.portType = portType;
    return this;
  }

   /**
   * Port number configuration type. Searchable as Choice.
   * @return portType
  **/
  @ApiModelProperty(value = "Port number configuration type. Searchable as Choice.")
  public PortTypeEnum getPortType() {
    return portType;
  }

  public void setPortType(PortTypeEnum portType) {
    this.portType = portType;
  }

  public ApplicationType portMultiple(List<String> portMultiple) {
    this.portMultiple = portMultiple;
    return this;
  }

  public ApplicationType addPortMultipleItem(String portMultipleItem) {
    if (this.portMultiple == null) {
      this.portMultiple = new ArrayList<>();
    }
    this.portMultiple.add(portMultipleItem);
    return this;
  }

   /**
   * If portType is multiple, the list of port numbers the ApplicationType monitors. Searchable as String.
   * @return portMultiple
  **/
  @ApiModelProperty(value = "If portType is multiple, the list of port numbers the ApplicationType monitors. Searchable as String.")
  public List<String> getPortMultiple() {
    return portMultiple;
  }

  public void setPortMultiple(List<String> portMultiple) {
    this.portMultiple = portMultiple;
  }

  public ApplicationType portListID(Integer portListID) {
    this.portListID = portListID;
    return this;
  }

   /**
   * If portType is port-list, ID of the PortList containing the port numbers the ApplicationType monitors. Searchable as Numeric.
   * @return portListID
  **/
  @ApiModelProperty(value = "If portType is port-list, ID of the PortList containing the port numbers the ApplicationType monitors. Searchable as Numeric.")
  public Integer getPortListID() {
    return portListID;
  }

  public void setPortListID(Integer portListID) {
    this.portListID = portListID;
  }

  public ApplicationType recommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
    return this;
  }

   /**
   * Indicates whether recommendation scans consider the ApplicationType. Create an ApplicationType computer or policy override to modify this value. Searchable as Choice.
   * @return recommendationsMode
  **/
  @ApiModelProperty(value = "Indicates whether recommendation scans consider the ApplicationType. Create an ApplicationType computer or policy override to modify this value. Searchable as Choice.")
  public RecommendationsModeEnum getRecommendationsMode() {
    return recommendationsMode;
  }

  public void setRecommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
  }

   /**
   * ID of the ApplicationType. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the ApplicationType. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApplicationType applicationType = (ApplicationType) o;
    return Objects.equals(this.name, applicationType.name) &&
        Objects.equals(this.description, applicationType.description) &&
        Objects.equals(this.minimumAgentVersion, applicationType.minimumAgentVersion) &&
        Objects.equals(this.direction, applicationType.direction) &&
        Objects.equals(this.protocol, applicationType.protocol) &&
        Objects.equals(this.portType, applicationType.portType) &&
        Objects.equals(this.portMultiple, applicationType.portMultiple) &&
        Objects.equals(this.portListID, applicationType.portListID) &&
        Objects.equals(this.recommendationsMode, applicationType.recommendationsMode) &&
        Objects.equals(this.ID, applicationType.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, minimumAgentVersion, direction, protocol, portType, portMultiple, portListID, recommendationsMode, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApplicationType {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    minimumAgentVersion: ").append(toIndentedString(minimumAgentVersion)).append("\n");
    sb.append("    direction: ").append(toIndentedString(direction)).append("\n");
    sb.append("    protocol: ").append(toIndentedString(protocol)).append("\n");
    sb.append("    portType: ").append(toIndentedString(portType)).append("\n");
    sb.append("    portMultiple: ").append(toIndentedString(portMultiple)).append("\n");
    sb.append("    portListID: ").append(toIndentedString(portListID)).append("\n");
    sb.append("    recommendationsMode: ").append(toIndentedString(recommendationsMode)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

