/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details for an Azure virtual machine.
 */
@ApiModel(description = "Details for an Azure virtual machine.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class AzureVMVirtualMachineSummary {
  @JsonProperty("cloudProvider")
  private String cloudProvider = null;

  @JsonProperty("subscriptionID")
  private String subscriptionID = null;

  @JsonProperty("operatingSystem")
  private String operatingSystem = null;

  @JsonProperty("publicVirtualIPAddress")
  private String publicVirtualIPAddress = null;

  @JsonProperty("privateIPAddress")
  private String privateIPAddress = null;

  @JsonProperty("publicIPAddress")
  private String publicIPAddress = null;

  @JsonProperty("location")
  private String location = null;

  @JsonProperty("instanceID")
  private String instanceID = null;

  @JsonProperty("imageID")
  private String imageID = null;

  @JsonProperty("cloudService")
  private String cloudService = null;

  @JsonProperty("deploymentID")
  private String deploymentID = null;

  @JsonProperty("type")
  private String type = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("DNSName")
  private String dnSName = null;

  public AzureVMVirtualMachineSummary cloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
    return this;
  }

   /**
   * Cloud provider: \&quot;Azure\&quot;.
   * @return cloudProvider
  **/
  @ApiModelProperty(value = "Cloud provider: \"Azure\".")
  public String getCloudProvider() {
    return cloudProvider;
  }

  public void setCloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
  }

  public AzureVMVirtualMachineSummary subscriptionID(String subscriptionID) {
    this.subscriptionID = subscriptionID;
    return this;
  }

   /**
   * Subscription ID. Searchable as String.
   * @return subscriptionID
  **/
  @ApiModelProperty(value = "Subscription ID. Searchable as String.")
  public String getSubscriptionID() {
    return subscriptionID;
  }

  public void setSubscriptionID(String subscriptionID) {
    this.subscriptionID = subscriptionID;
  }

  public AzureVMVirtualMachineSummary operatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
    return this;
  }

   /**
   * Operating system, for example: \&quot;Microsoft Windows\&quot;. Searchable as String.
   * @return operatingSystem
  **/
  @ApiModelProperty(value = "Operating system, for example: \"Microsoft Windows\". Searchable as String.")
  public String getOperatingSystem() {
    return operatingSystem;
  }

  public void setOperatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
  }

  public AzureVMVirtualMachineSummary publicVirtualIPAddress(String publicVirtualIPAddress) {
    this.publicVirtualIPAddress = publicVirtualIPAddress;
    return this;
  }

   /**
   * Public virtual IP address. Searchable as String.
   * @return publicVirtualIPAddress
  **/
  @ApiModelProperty(value = "Public virtual IP address. Searchable as String.")
  public String getPublicVirtualIPAddress() {
    return publicVirtualIPAddress;
  }

  public void setPublicVirtualIPAddress(String publicVirtualIPAddress) {
    this.publicVirtualIPAddress = publicVirtualIPAddress;
  }

  public AzureVMVirtualMachineSummary privateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
    return this;
  }

   /**
   * Private IP address. Searchable as String.
   * @return privateIPAddress
  **/
  @ApiModelProperty(value = "Private IP address. Searchable as String.")
  public String getPrivateIPAddress() {
    return privateIPAddress;
  }

  public void setPrivateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
  }

  public AzureVMVirtualMachineSummary publicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
    return this;
  }

   /**
   * Public IP address. Searchable as String.
   * @return publicIPAddress
  **/
  @ApiModelProperty(value = "Public IP address. Searchable as String.")
  public String getPublicIPAddress() {
    return publicIPAddress;
  }

  public void setPublicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
  }

  public AzureVMVirtualMachineSummary location(String location) {
    this.location = location;
    return this;
  }

   /**
   * Physical location of the VM, for example: \&quot;East US\&quot;. Searchable as String.
   * @return location
  **/
  @ApiModelProperty(value = "Physical location of the VM, for example: \"East US\". Searchable as String.")
  public String getLocation() {
    return location;
  }

  public void setLocation(String location) {
    this.location = location;
  }

  public AzureVMVirtualMachineSummary instanceID(String instanceID) {
    this.instanceID = instanceID;
    return this;
  }

   /**
   * Instance ID. Searchable as String.
   * @return instanceID
  **/
  @ApiModelProperty(value = "Instance ID. Searchable as String.")
  public String getInstanceID() {
    return instanceID;
  }

  public void setInstanceID(String instanceID) {
    this.instanceID = instanceID;
  }

  public AzureVMVirtualMachineSummary imageID(String imageID) {
    this.imageID = imageID;
    return this;
  }

   /**
   * Image ID, for example: \&quot;a699494373c04fc0bc8f2bb1389d6106__Windows-Server-2012-R2-201503.01-en.us-127GB.vhd\&quot;. Searchable as String.
   * @return imageID
  **/
  @ApiModelProperty(value = "Image ID, for example: \"a699494373c04fc0bc8f2bb1389d6106__Windows-Server-2012-R2-201503.01-en.us-127GB.vhd\". Searchable as String.")
  public String getImageID() {
    return imageID;
  }

  public void setImageID(String imageID) {
    this.imageID = imageID;
  }

  public AzureVMVirtualMachineSummary cloudService(String cloudService) {
    this.cloudService = cloudService;
    return this;
  }

   /**
   * Cloud service, for example: \&quot;DH-DC\&quot;. Searchable as String.
   * @return cloudService
  **/
  @ApiModelProperty(value = "Cloud service, for example: \"DH-DC\". Searchable as String.")
  public String getCloudService() {
    return cloudService;
  }

  public void setCloudService(String cloudService) {
    this.cloudService = cloudService;
  }

  public AzureVMVirtualMachineSummary deploymentID(String deploymentID) {
    this.deploymentID = deploymentID;
    return this;
  }

   /**
   * Deployment ID, for example: \&quot;76ab36a0fb8d4c4ab6b802acdf58b3a4\&quot;. Searchable as String.
   * @return deploymentID
  **/
  @ApiModelProperty(value = "Deployment ID, for example: \"76ab36a0fb8d4c4ab6b802acdf58b3a4\". Searchable as String.")
  public String getDeploymentID() {
    return deploymentID;
  }

  public void setDeploymentID(String deploymentID) {
    this.deploymentID = deploymentID;
  }

  public AzureVMVirtualMachineSummary type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Hardware type, for example: \&quot;Standard_DS1_v2\&quot;. Searchable as String.
   * @return type
  **/
  @ApiModelProperty(value = "Hardware type, for example: \"Standard_DS1_v2\". Searchable as String.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public AzureVMVirtualMachineSummary state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Power state, for example, \&quot;POWER ON\&quot;.
   * @return state
  **/
  @ApiModelProperty(value = "Power state, for example, \"POWER ON\".")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public AzureVMVirtualMachineSummary dnSName(String dnSName) {
    this.dnSName = dnSName;
    return this;
  }

   /**
   * Get dnSName
   * @return dnSName
  **/
  @ApiModelProperty(value = "")
  public String getDnSName() {
    return dnSName;
  }

  public void setDnSName(String dnSName) {
    this.dnSName = dnSName;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AzureVMVirtualMachineSummary azureVMVirtualMachineSummary = (AzureVMVirtualMachineSummary) o;
    return Objects.equals(this.cloudProvider, azureVMVirtualMachineSummary.cloudProvider) &&
        Objects.equals(this.subscriptionID, azureVMVirtualMachineSummary.subscriptionID) &&
        Objects.equals(this.operatingSystem, azureVMVirtualMachineSummary.operatingSystem) &&
        Objects.equals(this.publicVirtualIPAddress, azureVMVirtualMachineSummary.publicVirtualIPAddress) &&
        Objects.equals(this.privateIPAddress, azureVMVirtualMachineSummary.privateIPAddress) &&
        Objects.equals(this.publicIPAddress, azureVMVirtualMachineSummary.publicIPAddress) &&
        Objects.equals(this.location, azureVMVirtualMachineSummary.location) &&
        Objects.equals(this.instanceID, azureVMVirtualMachineSummary.instanceID) &&
        Objects.equals(this.imageID, azureVMVirtualMachineSummary.imageID) &&
        Objects.equals(this.cloudService, azureVMVirtualMachineSummary.cloudService) &&
        Objects.equals(this.deploymentID, azureVMVirtualMachineSummary.deploymentID) &&
        Objects.equals(this.type, azureVMVirtualMachineSummary.type) &&
        Objects.equals(this.state, azureVMVirtualMachineSummary.state) &&
        Objects.equals(this.dnSName, azureVMVirtualMachineSummary.dnSName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cloudProvider, subscriptionID, operatingSystem, publicVirtualIPAddress, privateIPAddress, publicIPAddress, location, instanceID, imageID, cloudService, deploymentID, type, state, dnSName);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AzureVMVirtualMachineSummary {\n");
    
    sb.append("    cloudProvider: ").append(toIndentedString(cloudProvider)).append("\n");
    sb.append("    subscriptionID: ").append(toIndentedString(subscriptionID)).append("\n");
    sb.append("    operatingSystem: ").append(toIndentedString(operatingSystem)).append("\n");
    sb.append("    publicVirtualIPAddress: ").append(toIndentedString(publicVirtualIPAddress)).append("\n");
    sb.append("    privateIPAddress: ").append(toIndentedString(privateIPAddress)).append("\n");
    sb.append("    publicIPAddress: ").append(toIndentedString(publicIPAddress)).append("\n");
    sb.append("    location: ").append(toIndentedString(location)).append("\n");
    sb.append("    instanceID: ").append(toIndentedString(instanceID)).append("\n");
    sb.append("    imageID: ").append(toIndentedString(imageID)).append("\n");
    sb.append("    cloudService: ").append(toIndentedString(cloudService)).append("\n");
    sb.append("    deploymentID: ").append(toIndentedString(deploymentID)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    dnSName: ").append(toIndentedString(dnSName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

