/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Certificate details
 */
@ApiModel(description = "Certificate details")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class CertificateDetails {
  @JsonProperty("issuerDN")
  private String issuerDN = null;

  @JsonProperty("subjectDN")
  private String subjectDN = null;

  @JsonProperty("notBefore")
  private Long notBefore = null;

  @JsonProperty("notAfter")
  private Long notAfter = null;

  @JsonProperty("serialNumber")
  private String serialNumber = null;

  @JsonProperty("sha1Fingerprint")
  private String sha1Fingerprint = null;

  @JsonProperty("sha256Fingerprint")
  private String sha256Fingerprint = null;

   /**
   * The certificate issuer.
   * @return issuerDN
  **/
  @ApiModelProperty(value = "The certificate issuer.")
  public String getIssuerDN() {
    return issuerDN;
  }

   /**
   * The certificate subject (owner).
   * @return subjectDN
  **/
  @ApiModelProperty(value = "The certificate subject (owner).")
  public String getSubjectDN() {
    return subjectDN;
  }

   /**
   * The date on which the certificate validity period begins.
   * @return notBefore
  **/
  @ApiModelProperty(value = "The date on which the certificate validity period begins.")
  public Long getNotBefore() {
    return notBefore;
  }

   /**
   * The date on which the certificate validity period ends.
   * @return notAfter
  **/
  @ApiModelProperty(value = "The date on which the certificate validity period ends.")
  public Long getNotAfter() {
    return notAfter;
  }

   /**
   * A number that uniquely identifies the certificate and is issued by the certification authority.
   * @return serialNumber
  **/
  @ApiModelProperty(value = "A number that uniquely identifies the certificate and is issued by the certification authority.")
  public String getSerialNumber() {
    return serialNumber;
  }

   /**
   * The sha1 fingerprint of the certificate.
   * @return sha1Fingerprint
  **/
  @ApiModelProperty(value = "The sha1 fingerprint of the certificate.")
  public String getSha1Fingerprint() {
    return sha1Fingerprint;
  }

   /**
   * The sha256 fingerprint of the certificate.
   * @return sha256Fingerprint
  **/
  @ApiModelProperty(value = "The sha256 fingerprint of the certificate.")
  public String getSha256Fingerprint() {
    return sha256Fingerprint;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CertificateDetails certificateDetails = (CertificateDetails) o;
    return Objects.equals(this.issuerDN, certificateDetails.issuerDN) &&
        Objects.equals(this.subjectDN, certificateDetails.subjectDN) &&
        Objects.equals(this.notBefore, certificateDetails.notBefore) &&
        Objects.equals(this.notAfter, certificateDetails.notAfter) &&
        Objects.equals(this.serialNumber, certificateDetails.serialNumber) &&
        Objects.equals(this.sha1Fingerprint, certificateDetails.sha1Fingerprint) &&
        Objects.equals(this.sha256Fingerprint, certificateDetails.sha256Fingerprint);
  }

  @Override
  public int hashCode() {
    return Objects.hash(issuerDN, subjectDN, notBefore, notAfter, serialNumber, sha1Fingerprint, sha256Fingerprint);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CertificateDetails {\n");
    
    sb.append("    issuerDN: ").append(toIndentedString(issuerDN)).append("\n");
    sb.append("    subjectDN: ").append(toIndentedString(subjectDN)).append("\n");
    sb.append("    notBefore: ").append(toIndentedString(notBefore)).append("\n");
    sb.append("    notAfter: ").append(toIndentedString(notAfter)).append("\n");
    sb.append("    serialNumber: ").append(toIndentedString(serialNumber)).append("\n");
    sb.append("    sha1Fingerprint: ").append(toIndentedString(sha1Fingerprint)).append("\n");
    sb.append("    sha256Fingerprint: ").append(toIndentedString(sha256Fingerprint)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

