/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Security update component.
 */
@ApiModel(description = "Security update component.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class Component {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("forUseBy")
  private String forUseBy = null;

  @JsonProperty("platform")
  private String platform = null;

  @JsonProperty("version")
  private String version = null;

  @JsonProperty("latest")
  private Boolean latest = null;

   /**
   * Name of the component.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the component.")
  public String getName() {
    return name;
  }

   /**
   * Name and version of the component consumer.
   * @return forUseBy
  **/
  @ApiModelProperty(value = "Name and version of the component consumer.")
  public String getForUseBy() {
    return forUseBy;
  }

   /**
   * Platform of the component.
   * @return platform
  **/
  @ApiModelProperty(value = "Platform of the component.")
  public String getPlatform() {
    return platform;
  }

   /**
   * Version of the component.
   * @return version
  **/
  @ApiModelProperty(value = "Version of the component.")
  public String getVersion() {
    return version;
  }

   /**
   * True if the component is the latest version.
   * @return latest
  **/
  @ApiModelProperty(value = "True if the component is the latest version.")
  public Boolean isLatest() {
    return latest;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Component component = (Component) o;
    return Objects.equals(this.name, component.name) &&
        Objects.equals(this.forUseBy, component.forUseBy) &&
        Objects.equals(this.platform, component.platform) &&
        Objects.equals(this.version, component.version) &&
        Objects.equals(this.latest, component.latest);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, forUseBy, platform, version, latest);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Component {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    forUseBy: ").append(toIndentedString(forUseBy)).append("\n");
    sb.append("    platform: ").append(toIndentedString(platform)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    latest: ").append(toIndentedString(latest)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

