/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ActivityMonitoringComputerExtension;
import com.trendmicro.deepsecurity.model.AntiMalwareComputerExtension;
import com.trendmicro.deepsecurity.model.ApplicationControlComputerExtension;
import com.trendmicro.deepsecurity.model.AzureARMVirtualMachineSummary;
import com.trendmicro.deepsecurity.model.AzureVMVirtualMachineSummary;
import com.trendmicro.deepsecurity.model.ComputerSettings;
import com.trendmicro.deepsecurity.model.ComputerStatus;
import com.trendmicro.deepsecurity.model.ComputerTasks;
import com.trendmicro.deepsecurity.model.ESXSummary;
import com.trendmicro.deepsecurity.model.Ec2VirtualMachineSummary;
import com.trendmicro.deepsecurity.model.FirewallComputerExtension;
import com.trendmicro.deepsecurity.model.GcpVirtualMachineSummary;
import com.trendmicro.deepsecurity.model.IntegrityMonitoringComputerExtension;
import com.trendmicro.deepsecurity.model.Interfaces;
import com.trendmicro.deepsecurity.model.IntrusionPreventionComputerExtension;
import com.trendmicro.deepsecurity.model.LogInspectionComputerExtension;
import com.trendmicro.deepsecurity.model.NoConnectorVirtualMachineSummary;
import com.trendmicro.deepsecurity.model.SAPComputerExtension;
import com.trendmicro.deepsecurity.model.SecurityUpdates;
import com.trendmicro.deepsecurity.model.VcloudVMVirtualMachineSummary;
import com.trendmicro.deepsecurity.model.VmwareVMVirtualMachineSummary;
import com.trendmicro.deepsecurity.model.WebReputationComputerExtension;
import com.trendmicro.deepsecurity.model.WorkspaceVirtualMachineSummary;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Computer details. Settings set on the computer override settings on an assigned policy. When the computer is virtual, additional information about the virtual machine is provided.
 */
@ApiModel(description = "Computer details. Settings set on the computer override settings on an assigned policy. When the computer is virtual, additional information about the virtual machine is provided.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class Computer {
  @JsonProperty("hostName")
  private String hostName = null;

  @JsonProperty("displayName")
  private String displayName = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("lastIPUsed")
  private String lastIPUsed = null;

  @JsonProperty("platform")
  private String platform = null;

  @JsonProperty("groupID")
  private Integer groupID = null;

  @JsonProperty("policyID")
  private Integer policyID = null;

  @JsonProperty("assetImportanceID")
  private Integer assetImportanceID = null;

  @JsonProperty("relayListID")
  private Integer relayListID = null;

  @JsonProperty("agentFingerPrint")
  private String agentFingerPrint = null;

  @JsonProperty("applianceFingerPrint")
  private String applianceFingerPrint = null;

  @JsonProperty("lastAgentCommunication")
  private Long lastAgentCommunication = null;

  @JsonProperty("lastApplianceCommunication")
  private Long lastApplianceCommunication = null;

  @JsonProperty("lastSendPolicyRequest")
  private Long lastSendPolicyRequest = null;

  @JsonProperty("lastSendPolicySuccess")
  private Long lastSendPolicySuccess = null;

  @JsonProperty("agentVersion")
  private String agentVersion = null;

  @JsonProperty("computerStatus")
  private ComputerStatus computerStatus = null;

  @JsonProperty("tasks")
  private ComputerTasks tasks = null;

  @JsonProperty("securityUpdates")
  private SecurityUpdates securityUpdates = null;

  @JsonProperty("computerSettings")
  private ComputerSettings computerSettings = null;

  @JsonProperty("interfaces")
  private Interfaces interfaces = null;

  @JsonProperty("biosUUID")
  private String biosUUID = null;

  @JsonProperty("azureARMVirtualMachineSummary")
  private AzureARMVirtualMachineSummary azureARMVirtualMachineSummary = null;

  @JsonProperty("azureVMVirtualMachineSummary")
  private AzureVMVirtualMachineSummary azureVMVirtualMachineSummary = null;

  @JsonProperty("ec2VirtualMachineSummary")
  private Ec2VirtualMachineSummary ec2VirtualMachineSummary = null;

  @JsonProperty("noConnectorVirtualMachineSummary")
  private NoConnectorVirtualMachineSummary noConnectorVirtualMachineSummary = null;

  @JsonProperty("vmwareVMVirtualMachineSummary")
  private VmwareVMVirtualMachineSummary vmwareVMVirtualMachineSummary = null;

  @JsonProperty("vcloudVMVirtualMachineSummary")
  private VcloudVMVirtualMachineSummary vcloudVMVirtualMachineSummary = null;

  @JsonProperty("workspaceVirtualMachineSummary")
  private WorkspaceVirtualMachineSummary workspaceVirtualMachineSummary = null;

  @JsonProperty("gcpVirtualMachineSummary")
  private GcpVirtualMachineSummary gcpVirtualMachineSummary = null;

  @JsonProperty("hostGUID")
  private String hostGUID = null;

  @JsonProperty("ID")
  private Integer ID = null;

  @JsonProperty("antiMalware")
  private AntiMalwareComputerExtension antiMalware = null;

  @JsonProperty("webReputation")
  private WebReputationComputerExtension webReputation = null;

  @JsonProperty("activityMonitoring")
  private ActivityMonitoringComputerExtension activityMonitoring = null;

  @JsonProperty("firewall")
  private FirewallComputerExtension firewall = null;

  @JsonProperty("intrusionPrevention")
  private IntrusionPreventionComputerExtension intrusionPrevention = null;

  @JsonProperty("integrityMonitoring")
  private IntegrityMonitoringComputerExtension integrityMonitoring = null;

  @JsonProperty("logInspection")
  private LogInspectionComputerExtension logInspection = null;

  @JsonProperty("applicationControl")
  private ApplicationControlComputerExtension applicationControl = null;

  @JsonProperty("SAP")
  private SAPComputerExtension SAP = null;

  @JsonProperty("ESXSummary")
  private ESXSummary esXSummary = null;

  public Computer hostName(String hostName) {
    this.hostName = hostName;
    return this;
  }

   /**
   * Hostname of the computer. Searchable as String.
   * @return hostName
  **/
  @ApiModelProperty(value = "Hostname of the computer. Searchable as String.")
  public String getHostName() {
    return hostName;
  }

  public void setHostName(String hostName) {
    this.hostName = hostName;
  }

  public Computer displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * Display name of the computer. Searchable as String.
   * @return displayName
  **/
  @ApiModelProperty(value = "Display name of the computer. Searchable as String.")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

  public Computer description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the computer. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the computer. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Most recent IP address used by the computer. This value is null when the computer is not activated. Searchable as String.
   * @return lastIPUsed
  **/
  @ApiModelProperty(value = "Most recent IP address used by the computer. This value is null when the computer is not activated. Searchable as String.")
  public String getLastIPUsed() {
    return lastIPUsed;
  }

   /**
   * Platform of the computer. Automatically detected and set. Searchable as String
   * @return platform
  **/
  @ApiModelProperty(value = "Platform of the computer. Automatically detected and set. Searchable as String")
  public String getPlatform() {
    return platform;
  }

  public Computer groupID(Integer groupID) {
    this.groupID = groupID;
    return this;
  }

   /**
   * ID of the computer group to which the computer belongs. Searchable as Numeric.
   * @return groupID
  **/
  @ApiModelProperty(value = "ID of the computer group to which the computer belongs. Searchable as Numeric.")
  public Integer getGroupID() {
    return groupID;
  }

  public void setGroupID(Integer groupID) {
    this.groupID = groupID;
  }

  public Computer policyID(Integer policyID) {
    this.policyID = policyID;
    return this;
  }

   /**
   * ID of the policy assigned to the computer. Searchable as Numeric.
   * @return policyID
  **/
  @ApiModelProperty(value = "ID of the policy assigned to the computer. Searchable as Numeric.")
  public Integer getPolicyID() {
    return policyID;
  }

  public void setPolicyID(Integer policyID) {
    this.policyID = policyID;
  }

  public Computer assetImportanceID(Integer assetImportanceID) {
    this.assetImportanceID = assetImportanceID;
    return this;
  }

   /**
   * ID of the asset importance assigned to the computer. Searchable as Numeric.
   * @return assetImportanceID
  **/
  @ApiModelProperty(value = "ID of the asset importance assigned to the computer. Searchable as Numeric.")
  public Integer getAssetImportanceID() {
    return assetImportanceID;
  }

  public void setAssetImportanceID(Integer assetImportanceID) {
    this.assetImportanceID = assetImportanceID;
  }

  public Computer relayListID(Integer relayListID) {
    this.relayListID = relayListID;
    return this;
  }

   /**
   * ID of the relay list that is assigned to the computer. Searchable as Numeric.
   * @return relayListID
  **/
  @ApiModelProperty(value = "ID of the relay list that is assigned to the computer. Searchable as Numeric.")
  public Integer getRelayListID() {
    return relayListID;
  }

  public void setRelayListID(Integer relayListID) {
    this.relayListID = relayListID;
  }

   /**
   * FingerPrint of the Agent on the computer. This value is null when no agent is installed or activated. Searchable as String.
   * @return agentFingerPrint
  **/
  @ApiModelProperty(value = "FingerPrint of the Agent on the computer. This value is null when no agent is installed or activated. Searchable as String.")
  public String getAgentFingerPrint() {
    return agentFingerPrint;
  }

   /**
   * FingerPrint of the Appliance protecting the computer. This value is null when no Deep Security Virtual Appliance is protecting the computer.
   * @return applianceFingerPrint
  **/
  @ApiModelProperty(value = "FingerPrint of the Appliance protecting the computer. This value is null when no Deep Security Virtual Appliance is protecting the computer.")
  public String getApplianceFingerPrint() {
    return applianceFingerPrint;
  }

   /**
   * Timestamp of the last agent communication, in milliseconds since epoch. Searchable as Date.
   * @return lastAgentCommunication
  **/
  @ApiModelProperty(value = "Timestamp of the last agent communication, in milliseconds since epoch. Searchable as Date.")
  public Long getLastAgentCommunication() {
    return lastAgentCommunication;
  }

   /**
   * Timestamp of the last appliance communication, in milliseconds since epoch.
   * @return lastApplianceCommunication
  **/
  @ApiModelProperty(value = "Timestamp of the last appliance communication, in milliseconds since epoch.")
  public Long getLastApplianceCommunication() {
    return lastApplianceCommunication;
  }

   /**
   * Timestamp of the last policy request sent, in milliseconds since epoch. Searchable as Date.
   * @return lastSendPolicyRequest
  **/
  @ApiModelProperty(value = "Timestamp of the last policy request sent, in milliseconds since epoch. Searchable as Date.")
  public Long getLastSendPolicyRequest() {
    return lastSendPolicyRequest;
  }

   /**
   * Timestamp of last successful policy sent, in milliseconds since epoch.  Searchable as Date.
   * @return lastSendPolicySuccess
  **/
  @ApiModelProperty(value = "Timestamp of last successful policy sent, in milliseconds since epoch.  Searchable as Date.")
  public Long getLastSendPolicySuccess() {
    return lastSendPolicySuccess;
  }

   /**
   * Version of Deep Security Agent that is installed on the computer. When no agent software is installed or activated, the version is &#39;0.0.0.0&#39;. Searchable as String, however to search for computers without an agent, search for computers that have no agent fingerprint.&#39;.
   * @return agentVersion
  **/
  @ApiModelProperty(value = "Version of Deep Security Agent that is installed on the computer. When no agent software is installed or activated, the version is '0.0.0.0'. Searchable as String, however to search for computers without an agent, search for computers that have no agent fingerprint.'.")
  public String getAgentVersion() {
    return agentVersion;
  }

  public Computer computerStatus(ComputerStatus computerStatus) {
    this.computerStatus = computerStatus;
    return this;
  }

   /**
   * Get computerStatus
   * @return computerStatus
  **/
  @ApiModelProperty(value = "")
  public ComputerStatus getComputerStatus() {
    return computerStatus;
  }

  public void setComputerStatus(ComputerStatus computerStatus) {
    this.computerStatus = computerStatus;
  }

  public Computer tasks(ComputerTasks tasks) {
    this.tasks = tasks;
    return this;
  }

   /**
   * Get tasks
   * @return tasks
  **/
  @ApiModelProperty(value = "")
  public ComputerTasks getTasks() {
    return tasks;
  }

  public void setTasks(ComputerTasks tasks) {
    this.tasks = tasks;
  }

  public Computer securityUpdates(SecurityUpdates securityUpdates) {
    this.securityUpdates = securityUpdates;
    return this;
  }

   /**
   * Security Update information.
   * @return securityUpdates
  **/
  @ApiModelProperty(value = "Security Update information.")
  public SecurityUpdates getSecurityUpdates() {
    return securityUpdates;
  }

  public void setSecurityUpdates(SecurityUpdates securityUpdates) {
    this.securityUpdates = securityUpdates;
  }

  public Computer computerSettings(ComputerSettings computerSettings) {
    this.computerSettings = computerSettings;
    return this;
  }

   /**
   * Settings that can be applied directly to the computer. Those settings will generally override policy settings.
   * @return computerSettings
  **/
  @ApiModelProperty(value = "Settings that can be applied directly to the computer. Those settings will generally override policy settings.")
  public ComputerSettings getComputerSettings() {
    return computerSettings;
  }

  public void setComputerSettings(ComputerSettings computerSettings) {
    this.computerSettings = computerSettings;
  }

   /**
   * List of interfaces detected on the computer. This value is null when the computer is not activated.
   * @return interfaces
  **/
  @ApiModelProperty(value = "List of interfaces detected on the computer. This value is null when the computer is not activated.")
  public Interfaces getInterfaces() {
    return interfaces;
  }

   /**
   * BIOS UUID, for example: \&quot;421e1137-5c49-56e4-246d-9bf7637e69f5\&quot;. Only applies to VMware VMs.
   * @return biosUUID
  **/
  @ApiModelProperty(value = "BIOS UUID, for example: \"421e1137-5c49-56e4-246d-9bf7637e69f5\". Only applies to VMware VMs.")
  public String getBiosUUID() {
    return biosUUID;
  }

   /**
   * Get azureARMVirtualMachineSummary
   * @return azureARMVirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public AzureARMVirtualMachineSummary getAzureARMVirtualMachineSummary() {
    return azureARMVirtualMachineSummary;
  }

   /**
   * Get azureVMVirtualMachineSummary
   * @return azureVMVirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public AzureVMVirtualMachineSummary getAzureVMVirtualMachineSummary() {
    return azureVMVirtualMachineSummary;
  }

   /**
   * Get ec2VirtualMachineSummary
   * @return ec2VirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public Ec2VirtualMachineSummary getEc2VirtualMachineSummary() {
    return ec2VirtualMachineSummary;
  }

   /**
   * Get noConnectorVirtualMachineSummary
   * @return noConnectorVirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public NoConnectorVirtualMachineSummary getNoConnectorVirtualMachineSummary() {
    return noConnectorVirtualMachineSummary;
  }

   /**
   * Get vmwareVMVirtualMachineSummary
   * @return vmwareVMVirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public VmwareVMVirtualMachineSummary getVmwareVMVirtualMachineSummary() {
    return vmwareVMVirtualMachineSummary;
  }

   /**
   * Get vcloudVMVirtualMachineSummary
   * @return vcloudVMVirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public VcloudVMVirtualMachineSummary getVcloudVMVirtualMachineSummary() {
    return vcloudVMVirtualMachineSummary;
  }

   /**
   * Get workspaceVirtualMachineSummary
   * @return workspaceVirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public WorkspaceVirtualMachineSummary getWorkspaceVirtualMachineSummary() {
    return workspaceVirtualMachineSummary;
  }

   /**
   * Get gcpVirtualMachineSummary
   * @return gcpVirtualMachineSummary
  **/
  @ApiModelProperty(value = "")
  public GcpVirtualMachineSummary getGcpVirtualMachineSummary() {
    return gcpVirtualMachineSummary;
  }

   /**
   * HostGUID of the computer. Searchable as String.
   * @return hostGUID
  **/
  @ApiModelProperty(value = "HostGUID of the computer. Searchable as String.")
  public String getHostGUID() {
    return hostGUID;
  }

   /**
   * ID of the computer. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the computer. Searchable as ID.")
  public Integer getID() {
    return ID;
  }

  public Computer antiMalware(AntiMalwareComputerExtension antiMalware) {
    this.antiMalware = antiMalware;
    return this;
  }

   /**
   * Get antiMalware
   * @return antiMalware
  **/
  @ApiModelProperty(value = "")
  public AntiMalwareComputerExtension getAntiMalware() {
    return antiMalware;
  }

  public void setAntiMalware(AntiMalwareComputerExtension antiMalware) {
    this.antiMalware = antiMalware;
  }

  public Computer webReputation(WebReputationComputerExtension webReputation) {
    this.webReputation = webReputation;
    return this;
  }

   /**
   * Get webReputation
   * @return webReputation
  **/
  @ApiModelProperty(value = "")
  public WebReputationComputerExtension getWebReputation() {
    return webReputation;
  }

  public void setWebReputation(WebReputationComputerExtension webReputation) {
    this.webReputation = webReputation;
  }

  public Computer activityMonitoring(ActivityMonitoringComputerExtension activityMonitoring) {
    this.activityMonitoring = activityMonitoring;
    return this;
  }

   /**
   * Get activityMonitoring
   * @return activityMonitoring
  **/
  @ApiModelProperty(value = "")
  public ActivityMonitoringComputerExtension getActivityMonitoring() {
    return activityMonitoring;
  }

  public void setActivityMonitoring(ActivityMonitoringComputerExtension activityMonitoring) {
    this.activityMonitoring = activityMonitoring;
  }

  public Computer firewall(FirewallComputerExtension firewall) {
    this.firewall = firewall;
    return this;
  }

   /**
   * Get firewall
   * @return firewall
  **/
  @ApiModelProperty(value = "")
  public FirewallComputerExtension getFirewall() {
    return firewall;
  }

  public void setFirewall(FirewallComputerExtension firewall) {
    this.firewall = firewall;
  }

  public Computer intrusionPrevention(IntrusionPreventionComputerExtension intrusionPrevention) {
    this.intrusionPrevention = intrusionPrevention;
    return this;
  }

   /**
   * Get intrusionPrevention
   * @return intrusionPrevention
  **/
  @ApiModelProperty(value = "")
  public IntrusionPreventionComputerExtension getIntrusionPrevention() {
    return intrusionPrevention;
  }

  public void setIntrusionPrevention(IntrusionPreventionComputerExtension intrusionPrevention) {
    this.intrusionPrevention = intrusionPrevention;
  }

  public Computer integrityMonitoring(IntegrityMonitoringComputerExtension integrityMonitoring) {
    this.integrityMonitoring = integrityMonitoring;
    return this;
  }

   /**
   * Get integrityMonitoring
   * @return integrityMonitoring
  **/
  @ApiModelProperty(value = "")
  public IntegrityMonitoringComputerExtension getIntegrityMonitoring() {
    return integrityMonitoring;
  }

  public void setIntegrityMonitoring(IntegrityMonitoringComputerExtension integrityMonitoring) {
    this.integrityMonitoring = integrityMonitoring;
  }

  public Computer logInspection(LogInspectionComputerExtension logInspection) {
    this.logInspection = logInspection;
    return this;
  }

   /**
   * Get logInspection
   * @return logInspection
  **/
  @ApiModelProperty(value = "")
  public LogInspectionComputerExtension getLogInspection() {
    return logInspection;
  }

  public void setLogInspection(LogInspectionComputerExtension logInspection) {
    this.logInspection = logInspection;
  }

  public Computer applicationControl(ApplicationControlComputerExtension applicationControl) {
    this.applicationControl = applicationControl;
    return this;
  }

   /**
   * Get applicationControl
   * @return applicationControl
  **/
  @ApiModelProperty(value = "")
  public ApplicationControlComputerExtension getApplicationControl() {
    return applicationControl;
  }

  public void setApplicationControl(ApplicationControlComputerExtension applicationControl) {
    this.applicationControl = applicationControl;
  }

  public Computer SAP(SAPComputerExtension SAP) {
    this.SAP = SAP;
    return this;
  }

   /**
   * Get SAP
   * @return SAP
  **/
  @ApiModelProperty(value = "")
  public SAPComputerExtension getSAP() {
    return SAP;
  }

  public void setSAP(SAPComputerExtension SAP) {
    this.SAP = SAP;
  }

  public Computer esXSummary(ESXSummary esXSummary) {
    this.esXSummary = esXSummary;
    return this;
  }

   /**
   * Get esXSummary
   * @return esXSummary
  **/
  @ApiModelProperty(value = "")
  public ESXSummary getEsXSummary() {
    return esXSummary;
  }

  public void setEsXSummary(ESXSummary esXSummary) {
    this.esXSummary = esXSummary;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Computer computer = (Computer) o;
    return Objects.equals(this.hostName, computer.hostName) &&
        Objects.equals(this.displayName, computer.displayName) &&
        Objects.equals(this.description, computer.description) &&
        Objects.equals(this.lastIPUsed, computer.lastIPUsed) &&
        Objects.equals(this.platform, computer.platform) &&
        Objects.equals(this.groupID, computer.groupID) &&
        Objects.equals(this.policyID, computer.policyID) &&
        Objects.equals(this.assetImportanceID, computer.assetImportanceID) &&
        Objects.equals(this.relayListID, computer.relayListID) &&
        Objects.equals(this.agentFingerPrint, computer.agentFingerPrint) &&
        Objects.equals(this.applianceFingerPrint, computer.applianceFingerPrint) &&
        Objects.equals(this.lastAgentCommunication, computer.lastAgentCommunication) &&
        Objects.equals(this.lastApplianceCommunication, computer.lastApplianceCommunication) &&
        Objects.equals(this.lastSendPolicyRequest, computer.lastSendPolicyRequest) &&
        Objects.equals(this.lastSendPolicySuccess, computer.lastSendPolicySuccess) &&
        Objects.equals(this.agentVersion, computer.agentVersion) &&
        Objects.equals(this.computerStatus, computer.computerStatus) &&
        Objects.equals(this.tasks, computer.tasks) &&
        Objects.equals(this.securityUpdates, computer.securityUpdates) &&
        Objects.equals(this.computerSettings, computer.computerSettings) &&
        Objects.equals(this.interfaces, computer.interfaces) &&
        Objects.equals(this.biosUUID, computer.biosUUID) &&
        Objects.equals(this.azureARMVirtualMachineSummary, computer.azureARMVirtualMachineSummary) &&
        Objects.equals(this.azureVMVirtualMachineSummary, computer.azureVMVirtualMachineSummary) &&
        Objects.equals(this.ec2VirtualMachineSummary, computer.ec2VirtualMachineSummary) &&
        Objects.equals(this.noConnectorVirtualMachineSummary, computer.noConnectorVirtualMachineSummary) &&
        Objects.equals(this.vmwareVMVirtualMachineSummary, computer.vmwareVMVirtualMachineSummary) &&
        Objects.equals(this.vcloudVMVirtualMachineSummary, computer.vcloudVMVirtualMachineSummary) &&
        Objects.equals(this.workspaceVirtualMachineSummary, computer.workspaceVirtualMachineSummary) &&
        Objects.equals(this.gcpVirtualMachineSummary, computer.gcpVirtualMachineSummary) &&
        Objects.equals(this.hostGUID, computer.hostGUID) &&
        Objects.equals(this.ID, computer.ID) &&
        Objects.equals(this.antiMalware, computer.antiMalware) &&
        Objects.equals(this.webReputation, computer.webReputation) &&
        Objects.equals(this.activityMonitoring, computer.activityMonitoring) &&
        Objects.equals(this.firewall, computer.firewall) &&
        Objects.equals(this.intrusionPrevention, computer.intrusionPrevention) &&
        Objects.equals(this.integrityMonitoring, computer.integrityMonitoring) &&
        Objects.equals(this.logInspection, computer.logInspection) &&
        Objects.equals(this.applicationControl, computer.applicationControl) &&
        Objects.equals(this.SAP, computer.SAP) &&
        Objects.equals(this.esXSummary, computer.esXSummary);
  }

  @Override
  public int hashCode() {
    return Objects.hash(hostName, displayName, description, lastIPUsed, platform, groupID, policyID, assetImportanceID, relayListID, agentFingerPrint, applianceFingerPrint, lastAgentCommunication, lastApplianceCommunication, lastSendPolicyRequest, lastSendPolicySuccess, agentVersion, computerStatus, tasks, securityUpdates, computerSettings, interfaces, biosUUID, azureARMVirtualMachineSummary, azureVMVirtualMachineSummary, ec2VirtualMachineSummary, noConnectorVirtualMachineSummary, vmwareVMVirtualMachineSummary, vcloudVMVirtualMachineSummary, workspaceVirtualMachineSummary, gcpVirtualMachineSummary, hostGUID, ID, antiMalware, webReputation, activityMonitoring, firewall, intrusionPrevention, integrityMonitoring, logInspection, applicationControl, SAP, esXSummary);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Computer {\n");
    
    sb.append("    hostName: ").append(toIndentedString(hostName)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    lastIPUsed: ").append(toIndentedString(lastIPUsed)).append("\n");
    sb.append("    platform: ").append(toIndentedString(platform)).append("\n");
    sb.append("    groupID: ").append(toIndentedString(groupID)).append("\n");
    sb.append("    policyID: ").append(toIndentedString(policyID)).append("\n");
    sb.append("    assetImportanceID: ").append(toIndentedString(assetImportanceID)).append("\n");
    sb.append("    relayListID: ").append(toIndentedString(relayListID)).append("\n");
    sb.append("    agentFingerPrint: ").append(toIndentedString(agentFingerPrint)).append("\n");
    sb.append("    applianceFingerPrint: ").append(toIndentedString(applianceFingerPrint)).append("\n");
    sb.append("    lastAgentCommunication: ").append(toIndentedString(lastAgentCommunication)).append("\n");
    sb.append("    lastApplianceCommunication: ").append(toIndentedString(lastApplianceCommunication)).append("\n");
    sb.append("    lastSendPolicyRequest: ").append(toIndentedString(lastSendPolicyRequest)).append("\n");
    sb.append("    lastSendPolicySuccess: ").append(toIndentedString(lastSendPolicySuccess)).append("\n");
    sb.append("    agentVersion: ").append(toIndentedString(agentVersion)).append("\n");
    sb.append("    computerStatus: ").append(toIndentedString(computerStatus)).append("\n");
    sb.append("    tasks: ").append(toIndentedString(tasks)).append("\n");
    sb.append("    securityUpdates: ").append(toIndentedString(securityUpdates)).append("\n");
    sb.append("    computerSettings: ").append(toIndentedString(computerSettings)).append("\n");
    sb.append("    interfaces: ").append(toIndentedString(interfaces)).append("\n");
    sb.append("    biosUUID: ").append(toIndentedString(biosUUID)).append("\n");
    sb.append("    azureARMVirtualMachineSummary: ").append(toIndentedString(azureARMVirtualMachineSummary)).append("\n");
    sb.append("    azureVMVirtualMachineSummary: ").append(toIndentedString(azureVMVirtualMachineSummary)).append("\n");
    sb.append("    ec2VirtualMachineSummary: ").append(toIndentedString(ec2VirtualMachineSummary)).append("\n");
    sb.append("    noConnectorVirtualMachineSummary: ").append(toIndentedString(noConnectorVirtualMachineSummary)).append("\n");
    sb.append("    vmwareVMVirtualMachineSummary: ").append(toIndentedString(vmwareVMVirtualMachineSummary)).append("\n");
    sb.append("    vcloudVMVirtualMachineSummary: ").append(toIndentedString(vcloudVMVirtualMachineSummary)).append("\n");
    sb.append("    workspaceVirtualMachineSummary: ").append(toIndentedString(workspaceVirtualMachineSummary)).append("\n");
    sb.append("    gcpVirtualMachineSummary: ").append(toIndentedString(gcpVirtualMachineSummary)).append("\n");
    sb.append("    hostGUID: ").append(toIndentedString(hostGUID)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    antiMalware: ").append(toIndentedString(antiMalware)).append("\n");
    sb.append("    webReputation: ").append(toIndentedString(webReputation)).append("\n");
    sb.append("    activityMonitoring: ").append(toIndentedString(activityMonitoring)).append("\n");
    sb.append("    firewall: ").append(toIndentedString(firewall)).append("\n");
    sb.append("    intrusionPrevention: ").append(toIndentedString(intrusionPrevention)).append("\n");
    sb.append("    integrityMonitoring: ").append(toIndentedString(integrityMonitoring)).append("\n");
    sb.append("    logInspection: ").append(toIndentedString(logInspection)).append("\n");
    sb.append("    applicationControl: ").append(toIndentedString(applicationControl)).append("\n");
    sb.append("    SAP: ").append(toIndentedString(SAP)).append("\n");
    sb.append("    esXSummary: ").append(toIndentedString(esXSummary)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

