/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of a computer filter. A computer filter identifies the computers that certain types of scheduled tasks act on.
 */
@ApiModel(description = "Details of a computer filter. A computer filter identifies the computers that certain types of scheduled tasks act on.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ComputerFilter {
  /**
   * The type of computer filter.
   */
  public enum TypeEnum {
    COMPUTER("computer"),
    
    ALL_COMPUTERS("all-computers"),
    
    COMPUTERS_IN_GROUP("computers-in-group"),
    
    COMPUTERS_IN_GROUP_OR_SUBGROUP("computers-in-group-or-subgroup"),
    
    COMPUTERS_USING_POLICY("computers-using-policy"),
    
    COMPUTERS_USING_POLICY_OR_SUBPOLICY("computers-using-policy-or-subpolicy"),
    
    COMPUTERS_IN_SMART_FOLDER("computers-in-smart-folder");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("computerID")
  private Integer computerID = null;

  @JsonProperty("computerGroupID")
  private Integer computerGroupID = null;

  @JsonProperty("policyID")
  private Integer policyID = null;

  @JsonProperty("smartFolderID")
  private Long smartFolderID = null;

  public ComputerFilter type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * The type of computer filter.
   * @return type
  **/
  @ApiModelProperty(value = "The type of computer filter.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public ComputerFilter computerID(Integer computerID) {
    this.computerID = computerID;
    return this;
  }

   /**
   * Computer ID for filter type: computer.
   * @return computerID
  **/
  @ApiModelProperty(value = "Computer ID for filter type: computer.")
  public Integer getComputerID() {
    return computerID;
  }

  public void setComputerID(Integer computerID) {
    this.computerID = computerID;
  }

  public ComputerFilter computerGroupID(Integer computerGroupID) {
    this.computerGroupID = computerGroupID;
    return this;
  }

   /**
   * Computer Group ID for filter type: computers-in-group or computers-in-group-or-subgroup.
   * @return computerGroupID
  **/
  @ApiModelProperty(value = "Computer Group ID for filter type: computers-in-group or computers-in-group-or-subgroup.")
  public Integer getComputerGroupID() {
    return computerGroupID;
  }

  public void setComputerGroupID(Integer computerGroupID) {
    this.computerGroupID = computerGroupID;
  }

  public ComputerFilter policyID(Integer policyID) {
    this.policyID = policyID;
    return this;
  }

   /**
   * Policy ID for filter type: computers-using-policy or computers-using-policy-or-subpolicy.
   * @return policyID
  **/
  @ApiModelProperty(value = "Policy ID for filter type: computers-using-policy or computers-using-policy-or-subpolicy.")
  public Integer getPolicyID() {
    return policyID;
  }

  public void setPolicyID(Integer policyID) {
    this.policyID = policyID;
  }

  public ComputerFilter smartFolderID(Long smartFolderID) {
    this.smartFolderID = smartFolderID;
    return this;
  }

   /**
   * Smart Folder ID for filter type: computers-in-smart-folder.
   * @return smartFolderID
  **/
  @ApiModelProperty(value = "Smart Folder ID for filter type: computers-in-smart-folder.")
  public Long getSmartFolderID() {
    return smartFolderID;
  }

  public void setSmartFolderID(Long smartFolderID) {
    this.smartFolderID = smartFolderID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ComputerFilter computerFilter = (ComputerFilter) o;
    return Objects.equals(this.type, computerFilter.type) &&
        Objects.equals(this.computerID, computerFilter.computerID) &&
        Objects.equals(this.computerGroupID, computerFilter.computerGroupID) &&
        Objects.equals(this.policyID, computerFilter.policyID) &&
        Objects.equals(this.smartFolderID, computerFilter.smartFolderID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, computerID, computerGroupID, policyID, smartFolderID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ComputerFilter {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    computerID: ").append(toIndentedString(computerID)).append("\n");
    sb.append("    computerGroupID: ").append(toIndentedString(computerGroupID)).append("\n");
    sb.append("    policyID: ").append(toIndentedString(policyID)).append("\n");
    sb.append("    smartFolderID: ").append(toIndentedString(smartFolderID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

