/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Logical containers to organize computers that are protected by Deep Security Manager.
 */
@ApiModel(description = "Logical containers to organize computers that are protected by Deep Security Manager.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ComputerGroup {
  /**
   * Specifies what type the ComputerGroup is. Defaults to &#x60;folder&#x60;
   */
  public enum TypeEnum {
    AD_ADD_DIRECTORY("ad-add-directory"),
    
    AD_FOLDER_NETWORK("ad-folder-network"),
    
    AWS_REGION("aws-region"),
    
    AWS_VPC("aws-vpc"),
    
    AWS_SUBNET("aws-subnet"),
    
    AWS_WORKSPACES("aws-workspaces"),
    
    AWS_DIRECTORY("aws-directory"),
    
    AZURE_TOP("azure-top"),
    
    AZURE_GROUP("azure-group"),
    
    GCP_CONNECTOR("gcp-connector"),
    
    GCP_PROJECT("gcp-project"),
    
    CLOUD_PROVIDER_TOP("cloud-provider-top"),
    
    VCLOUD_TOP("vcloud-top"),
    
    AWS_ACCOUNT("aws-account"),
    
    VM_GROUP("vm-group"),
    
    VCLOUD_PROVIDER_DATACENTER("vcloud-provider_datacenter"),
    
    VCLOUD_VAPP("vcloud-vapp"),
    
    VCENTERS_TOP("vcenters-top"),
    
    VCENTER_FOLDER_NETWORK("vcenter-folder-network"),
    
    VMWARE_DATACENTER("vmware-datacenter"),
    
    VCENTER_CLUSTER_GROUP("vcenter-cluster-group"),
    
    EXTERNAL_GROUP("external-group"),
    
    FOLDER("folder"),
    
    ROOT("root");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("parentGroupID")
  private Integer parentGroupID = null;

  @JsonProperty("directoryID")
  private Integer directoryID = null;

  @JsonProperty("externalID")
  private String externalID = null;

  @JsonProperty("virtualID")
  private Integer virtualID = null;

  @JsonProperty("virtualType")
  private Integer virtualType = null;

  @JsonProperty("virtualName")
  private String virtualName = null;

  /**
   * Cloud platform of the ComputerGroup.  Ignored if the ComputerGroup does not represent a cloud container. Searchable as Choice.
   */
  public enum CloudTypeEnum {
    AMAZON("amazon"),
    
    VCLOUD_PRIVATE_CLOUD("vcloud-private-cloud"),
    
    AZURE("azure"),
    
    AZURE_ARM("azure-arm"),
    
    GCP("gcp");

    private String value;

    CloudTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static CloudTypeEnum fromValue(String text) {
      for (CloudTypeEnum b : CloudTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("cloudType")
  private CloudTypeEnum cloudType = null;

  /**
   * Cloud container type of the ComputerGroup. This is platform dependent. Ignored if the ComputerGroup does not represent a cloud container. Searchable as Numeric.
   */
  public enum CloudResourceTypeEnum {
    PHYSICAL("physical"),
    
    TOP_LEVEL("top-level"),
    
    PARTITION("partition"),
    
    AWS_EC2_INSTANCE("aws-ec2-instance"),
    
    AWS_WORKSPACE("aws-workspace"),
    
    VCLOUD_ORGANIZATION("vcloud-organization"),
    
    VCLOUD_CATALOG("vcloud-catalog"),
    
    VCLOUD_NETWORKS("vcloud-networks"),
    
    VCLOUD_VIRTUAL_DATA_CENTER("vcloud-virtual-data-center"),
    
    VCLOUD_VIRTUAL_APPLICATION("vcloud-virtual-application"),
    
    VCLOUD_VIRTUAL_APPLICATION_TEMPLATE("vcloud-virtual-application-template"),
    
    VCLOUD_VIRTUAL_MACHINE("vcloud-virtual-machine"),
    
    AZURE_INSTANCE("azure-instance"),
    
    AZURE_ARM_INSTANCE("azure-arm-instance");

    private String value;

    CloudResourceTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static CloudResourceTypeEnum fromValue(String text) {
      for (CloudResourceTypeEnum b : CloudResourceTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("cloudResourceType")
  private CloudResourceTypeEnum cloudResourceType = null;

  @JsonProperty("cloudID")
  private Integer cloudID = null;

  @JsonProperty("amazonAccountID")
  private Integer amazonAccountID = null;

  @JsonProperty("amazonRegionID")
  private Long amazonRegionID = null;

  @JsonProperty("amazonVPCID")
  private Long amazonVPCID = null;

  @JsonProperty("amazonSubnetID")
  private Long amazonSubnetID = null;

  @JsonProperty("amazonWorkspacesID")
  private Long amazonWorkspacesID = null;

  @JsonProperty("amazonDirectoryID")
  private Long amazonDirectoryID = null;

  @JsonProperty("ID")
  private Integer ID = null;

   /**
   * Specifies what type the ComputerGroup is. Defaults to &#x60;folder&#x60;
   * @return type
  **/
  @ApiModelProperty(value = "Specifies what type the ComputerGroup is. Defaults to `folder`")
  public TypeEnum getType() {
    return type;
  }

  public ComputerGroup name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the ComputerGroup. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the ComputerGroup. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ComputerGroup description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the ComputerGroup. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the ComputerGroup. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ComputerGroup parentGroupID(Integer parentGroupID) {
    this.parentGroupID = parentGroupID;
    return this;
  }

   /**
   * ID of the ComputerGroup&#39;s parent group. Empty if the parent is a root ComputerGroup. ComputerGroup will be a root group unless a valid value for &#x60;parentGroupID&#x60; is set. Searchable as Numeric.
   * @return parentGroupID
  **/
  @ApiModelProperty(value = "ID of the ComputerGroup's parent group. Empty if the parent is a root ComputerGroup. ComputerGroup will be a root group unless a valid value for `parentGroupID` is set. Searchable as Numeric.")
  public Integer getParentGroupID() {
    return parentGroupID;
  }

  public void setParentGroupID(Integer parentGroupID) {
    this.parentGroupID = parentGroupID;
  }

   /**
   * ID of the ComputerGroup&#39;s directory server. Set to &#x60;0&#x60; if the group is not a directory server. Searchable as Numeric.
   * @return directoryID
  **/
  @ApiModelProperty(value = "ID of the ComputerGroup's directory server. Set to `0` if the group is not a directory server. Searchable as Numeric.")
  public Integer getDirectoryID() {
    return directoryID;
  }

   /**
   * External ID of the ComputerGroup. Empty if the ComputerGroup is not created/managed by a cloud account. Searchable as String.
   * @return externalID
  **/
  @ApiModelProperty(value = "External ID of the ComputerGroup. Empty if the ComputerGroup is not created/managed by a cloud account. Searchable as String.")
  public String getExternalID() {
    return externalID;
  }

   /**
   * ID of the ComputerGroup as it exists in VMware vCloud. Set to &#x60;0&#x60; if the ComputerGroup is not from vCloud. Searchable as Numeric.
   * @return virtualID
  **/
  @ApiModelProperty(value = "ID of the ComputerGroup as it exists in VMware vCloud. Set to `0` if the ComputerGroup is not from vCloud. Searchable as Numeric.")
  public Integer getVirtualID() {
    return virtualID;
  }

   /**
   * Type of the ComputerGroup as it exists in VMware vCloud. Set to &#x60;0&#x60; if the ComputerGroup is not from vCloud. Searchable as Numeric.
   * @return virtualType
  **/
  @ApiModelProperty(value = "Type of the ComputerGroup as it exists in VMware vCloud. Set to `0` if the ComputerGroup is not from vCloud. Searchable as Numeric.")
  public Integer getVirtualType() {
    return virtualType;
  }

   /**
   * Name of the ComputerGroup as it exists in VMware vCloud. Ignored if the ComputerGroup is not from vCloud. Searchable as String.
   * @return virtualName
  **/
  @ApiModelProperty(value = "Name of the ComputerGroup as it exists in VMware vCloud. Ignored if the ComputerGroup is not from vCloud. Searchable as String.")
  public String getVirtualName() {
    return virtualName;
  }

   /**
   * Cloud platform of the ComputerGroup.  Ignored if the ComputerGroup does not represent a cloud container. Searchable as Choice.
   * @return cloudType
  **/
  @ApiModelProperty(value = "Cloud platform of the ComputerGroup.  Ignored if the ComputerGroup does not represent a cloud container. Searchable as Choice.")
  public CloudTypeEnum getCloudType() {
    return cloudType;
  }

   /**
   * Cloud container type of the ComputerGroup. This is platform dependent. Ignored if the ComputerGroup does not represent a cloud container. Searchable as Numeric.
   * @return cloudResourceType
  **/
  @ApiModelProperty(value = "Cloud container type of the ComputerGroup. This is platform dependent. Ignored if the ComputerGroup does not represent a cloud container. Searchable as Numeric.")
  public CloudResourceTypeEnum getCloudResourceType() {
    return cloudResourceType;
  }

   /**
   * Cloud container ID of the ComputerGroup. Ignored if the ComputerGroup does not represent a cloud container. Searchable as Numeric.
   * @return cloudID
  **/
  @ApiModelProperty(value = "Cloud container ID of the ComputerGroup. Ignored if the ComputerGroup does not represent a cloud container. Searchable as Numeric.")
  public Integer getCloudID() {
    return cloudID;
  }

   /**
   * Amazon Web Services account ID of the ComputerGroup. Set to &#x60;0&#x60; if the ComputerGroup does not represent an Amazon Web Services account. Searchable as Numeric.
   * @return amazonAccountID
  **/
  @ApiModelProperty(value = "Amazon Web Services account ID of the ComputerGroup. Set to `0` if the ComputerGroup does not represent an Amazon Web Services account. Searchable as Numeric.")
  public Integer getAmazonAccountID() {
    return amazonAccountID;
  }

   /**
   * Amazon Web Services region ID of the ComputerGroup. Set to &#x60;0&#x60; if the ComputerGroup does not represent an Amazon Web Services region. amazonWorkspacesID will be used instead if the ComputerGroup represents an Amazon Web Services WorkSpaces node. Searchable as Numeric.
   * @return amazonRegionID
  **/
  @ApiModelProperty(value = "Amazon Web Services region ID of the ComputerGroup. Set to `0` if the ComputerGroup does not represent an Amazon Web Services region. amazonWorkspacesID will be used instead if the ComputerGroup represents an Amazon Web Services WorkSpaces node. Searchable as Numeric.")
  public Long getAmazonRegionID() {
    return amazonRegionID;
  }

   /**
   * Amazon Web Services Virtual Private Cloud ID of the ComputerGroup. Set to &#x60;0&#x60; if the ComputerGroup does not represent an Amazon Web Services Virtual Private Cloud. Searchable as Numeric.
   * @return amazonVPCID
  **/
  @ApiModelProperty(value = "Amazon Web Services Virtual Private Cloud ID of the ComputerGroup. Set to `0` if the ComputerGroup does not represent an Amazon Web Services Virtual Private Cloud. Searchable as Numeric.")
  public Long getAmazonVPCID() {
    return amazonVPCID;
  }

   /**
   * Amazon Web Services subnet ID of the ComputerGroup. Set to &#x60;0&#x60; if the ComputerGroup does not represent an Amazon Web Services subnet. Searchable as Numeric.
   * @return amazonSubnetID
  **/
  @ApiModelProperty(value = "Amazon Web Services subnet ID of the ComputerGroup. Set to `0` if the ComputerGroup does not represent an Amazon Web Services subnet. Searchable as Numeric.")
  public Long getAmazonSubnetID() {
    return amazonSubnetID;
  }

   /**
   * Amazon Web Services WorkSpaces ID of the ComputerGroup. Set to &#x60;0&#x60; if the ComputerGroup does not represent an Amazon Web Services WorkSpace. Will be used instead of amazonRegionID if the ComputerGroup represents a WorkSpaces node under a region. Searchable as Numeric.
   * @return amazonWorkspacesID
  **/
  @ApiModelProperty(value = "Amazon Web Services WorkSpaces ID of the ComputerGroup. Set to `0` if the ComputerGroup does not represent an Amazon Web Services WorkSpace. Will be used instead of amazonRegionID if the ComputerGroup represents a WorkSpaces node under a region. Searchable as Numeric.")
  public Long getAmazonWorkspacesID() {
    return amazonWorkspacesID;
  }

   /**
   * Amazon Web Services directory ID of the ComputerGroup. Set to &#x60;0&#x60; if the ComputerGroup does not represent an Amazon Web Services directory. Searchable as Numeric.
   * @return amazonDirectoryID
  **/
  @ApiModelProperty(value = "Amazon Web Services directory ID of the ComputerGroup. Set to `0` if the ComputerGroup does not represent an Amazon Web Services directory. Searchable as Numeric.")
  public Long getAmazonDirectoryID() {
    return amazonDirectoryID;
  }

   /**
   * ID of the ComputerGroup. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the ComputerGroup. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ComputerGroup computerGroup = (ComputerGroup) o;
    return Objects.equals(this.type, computerGroup.type) &&
        Objects.equals(this.name, computerGroup.name) &&
        Objects.equals(this.description, computerGroup.description) &&
        Objects.equals(this.parentGroupID, computerGroup.parentGroupID) &&
        Objects.equals(this.directoryID, computerGroup.directoryID) &&
        Objects.equals(this.externalID, computerGroup.externalID) &&
        Objects.equals(this.virtualID, computerGroup.virtualID) &&
        Objects.equals(this.virtualType, computerGroup.virtualType) &&
        Objects.equals(this.virtualName, computerGroup.virtualName) &&
        Objects.equals(this.cloudType, computerGroup.cloudType) &&
        Objects.equals(this.cloudResourceType, computerGroup.cloudResourceType) &&
        Objects.equals(this.cloudID, computerGroup.cloudID) &&
        Objects.equals(this.amazonAccountID, computerGroup.amazonAccountID) &&
        Objects.equals(this.amazonRegionID, computerGroup.amazonRegionID) &&
        Objects.equals(this.amazonVPCID, computerGroup.amazonVPCID) &&
        Objects.equals(this.amazonSubnetID, computerGroup.amazonSubnetID) &&
        Objects.equals(this.amazonWorkspacesID, computerGroup.amazonWorkspacesID) &&
        Objects.equals(this.amazonDirectoryID, computerGroup.amazonDirectoryID) &&
        Objects.equals(this.ID, computerGroup.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, name, description, parentGroupID, directoryID, externalID, virtualID, virtualType, virtualName, cloudType, cloudResourceType, cloudID, amazonAccountID, amazonRegionID, amazonVPCID, amazonSubnetID, amazonWorkspacesID, amazonDirectoryID, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ComputerGroup {\n");
    
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    parentGroupID: ").append(toIndentedString(parentGroupID)).append("\n");
    sb.append("    directoryID: ").append(toIndentedString(directoryID)).append("\n");
    sb.append("    externalID: ").append(toIndentedString(externalID)).append("\n");
    sb.append("    virtualID: ").append(toIndentedString(virtualID)).append("\n");
    sb.append("    virtualType: ").append(toIndentedString(virtualType)).append("\n");
    sb.append("    virtualName: ").append(toIndentedString(virtualName)).append("\n");
    sb.append("    cloudType: ").append(toIndentedString(cloudType)).append("\n");
    sb.append("    cloudResourceType: ").append(toIndentedString(cloudResourceType)).append("\n");
    sb.append("    cloudID: ").append(toIndentedString(cloudID)).append("\n");
    sb.append("    amazonAccountID: ").append(toIndentedString(amazonAccountID)).append("\n");
    sb.append("    amazonRegionID: ").append(toIndentedString(amazonRegionID)).append("\n");
    sb.append("    amazonVPCID: ").append(toIndentedString(amazonVPCID)).append("\n");
    sb.append("    amazonSubnetID: ").append(toIndentedString(amazonSubnetID)).append("\n");
    sb.append("    amazonWorkspacesID: ").append(toIndentedString(amazonWorkspacesID)).append("\n");
    sb.append("    amazonDirectoryID: ").append(toIndentedString(amazonDirectoryID)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

