/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Computer Module status details.
 */
@ApiModel(description = "Computer Module status details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ComputerModuleStatus {
  /**
   * Agent status.
   */
  public enum AgentStatusEnum {
    INACTIVE("inactive"),
    
    ACTIVE("active"),
    
    WARNING("warning"),
    
    ERROR("error"),
    
    NOT_SUPPORTED("not-supported");

    private String value;

    AgentStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static AgentStatusEnum fromValue(String text) {
      for (AgentStatusEnum b : AgentStatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("agentStatus")
  private AgentStatusEnum agentStatus = null;

  @JsonProperty("agentStatusMessage")
  private String agentStatusMessage = null;

  /**
   * Appliance status.
   */
  public enum ApplianceStatusEnum {
    INACTIVE("inactive"),
    
    ACTIVE("active"),
    
    WARNING("warning"),
    
    ERROR("error"),
    
    NOT_SUPPORTED("not-supported");

    private String value;

    ApplianceStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ApplianceStatusEnum fromValue(String text) {
      for (ApplianceStatusEnum b : ApplianceStatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("applianceStatus")
  private ApplianceStatusEnum applianceStatus = null;

  @JsonProperty("applianceStatusMessage")
  private String applianceStatusMessage = null;

   /**
   * Agent status.
   * @return agentStatus
  **/
  @ApiModelProperty(value = "Agent status.")
  public AgentStatusEnum getAgentStatus() {
    return agentStatus;
  }

   /**
   * Agent status message.
   * @return agentStatusMessage
  **/
  @ApiModelProperty(value = "Agent status message.")
  public String getAgentStatusMessage() {
    return agentStatusMessage;
  }

   /**
   * Appliance status.
   * @return applianceStatus
  **/
  @ApiModelProperty(value = "Appliance status.")
  public ApplianceStatusEnum getApplianceStatus() {
    return applianceStatus;
  }

   /**
   * Appliance status message.
   * @return applianceStatusMessage
  **/
  @ApiModelProperty(value = "Appliance status message.")
  public String getApplianceStatusMessage() {
    return applianceStatusMessage;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ComputerModuleStatus computerModuleStatus = (ComputerModuleStatus) o;
    return Objects.equals(this.agentStatus, computerModuleStatus.agentStatus) &&
        Objects.equals(this.agentStatusMessage, computerModuleStatus.agentStatusMessage) &&
        Objects.equals(this.applianceStatus, computerModuleStatus.applianceStatus) &&
        Objects.equals(this.applianceStatusMessage, computerModuleStatus.applianceStatusMessage);
  }

  @Override
  public int hashCode() {
    return Objects.hash(agentStatus, agentStatusMessage, applianceStatus, applianceStatusMessage);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ComputerModuleStatus {\n");
    
    sb.append("    agentStatus: ").append(toIndentedString(agentStatus)).append("\n");
    sb.append("    agentStatusMessage: ").append(toIndentedString(agentStatusMessage)).append("\n");
    sb.append("    applianceStatus: ").append(toIndentedString(applianceStatus)).append("\n");
    sb.append("    applianceStatusMessage: ").append(toIndentedString(applianceStatusMessage)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

