/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Computer status details.
 */
@ApiModel(description = "Computer status details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ComputerStatus {
  /**
   * Agent status.
   */
  public enum AgentStatusEnum {
    INACTIVE("inactive"),
    
    ACTIVE("active"),
    
    WARNING("warning"),
    
    ERROR("error"),
    
    NOT_SUPPORTED("not-supported");

    private String value;

    AgentStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static AgentStatusEnum fromValue(String text) {
      for (AgentStatusEnum b : AgentStatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("agentStatus")
  private AgentStatusEnum agentStatus = null;

  @JsonProperty("agentStatusMessages")
  private List<String> agentStatusMessages = null;

  /**
   * Appliance status.
   */
  public enum ApplianceStatusEnum {
    INACTIVE("inactive"),
    
    ACTIVE("active"),
    
    WARNING("warning"),
    
    ERROR("error"),
    
    NOT_SUPPORTED("not-supported");

    private String value;

    ApplianceStatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ApplianceStatusEnum fromValue(String text) {
      for (ApplianceStatusEnum b : ApplianceStatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("applianceStatus")
  private ApplianceStatusEnum applianceStatus = null;

  @JsonProperty("applianceStatusMessages")
  private List<String> applianceStatusMessages = null;

   /**
   * Agent status.
   * @return agentStatus
  **/
  @ApiModelProperty(value = "Agent status.")
  public AgentStatusEnum getAgentStatus() {
    return agentStatus;
  }

   /**
   * Agent status messages.
   * @return agentStatusMessages
  **/
  @ApiModelProperty(value = "Agent status messages.")
  public List<String> getAgentStatusMessages() {
    return agentStatusMessages;
  }

   /**
   * Appliance status.
   * @return applianceStatus
  **/
  @ApiModelProperty(value = "Appliance status.")
  public ApplianceStatusEnum getApplianceStatus() {
    return applianceStatus;
  }

   /**
   * Appliance status messages.
   * @return applianceStatusMessages
  **/
  @ApiModelProperty(value = "Appliance status messages.")
  public List<String> getApplianceStatusMessages() {
    return applianceStatusMessages;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ComputerStatus computerStatus = (ComputerStatus) o;
    return Objects.equals(this.agentStatus, computerStatus.agentStatus) &&
        Objects.equals(this.agentStatusMessages, computerStatus.agentStatusMessages) &&
        Objects.equals(this.applianceStatus, computerStatus.applianceStatus) &&
        Objects.equals(this.applianceStatusMessages, computerStatus.applianceStatusMessages);
  }

  @Override
  public int hashCode() {
    return Objects.hash(agentStatus, agentStatusMessages, applianceStatus, applianceStatusMessages);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ComputerStatus {\n");
    
    sb.append("    agentStatus: ").append(toIndentedString(agentStatus)).append("\n");
    sb.append("    agentStatusMessages: ").append(toIndentedString(agentStatusMessages)).append("\n");
    sb.append("    applianceStatus: ").append(toIndentedString(applianceStatus)).append("\n");
    sb.append("    applianceStatusMessages: ").append(toIndentedString(applianceStatusMessages)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

