/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Controls the behavior of a scheduled task of type discover-computers.
 */
@ApiModel(description = "Controls the behavior of a scheduled task of type discover-computers.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class DiscoverComputersTaskParameters {
  /**
   * Discovery type. Default \&quot;masked-ip\&quot;.
   */
  public enum DiscoveryTypeEnum {
    RANGE("range"),
    
    MASKED_IP("masked-ip");

    private String value;

    DiscoveryTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DiscoveryTypeEnum fromValue(String text) {
      for (DiscoveryTypeEnum b : DiscoveryTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("discoveryType")
  private DiscoveryTypeEnum discoveryType = null;

  @JsonProperty("ip")
  private String ip = null;

  @JsonProperty("scanDiscoveredComputers")
  private Boolean scanDiscoveredComputers = null;

  @JsonProperty("resolveIPs")
  private Boolean resolveIPs = null;

  @JsonProperty("computerGroupID")
  private Integer computerGroupID = null;

  @JsonProperty("ipmask")
  private String ipmask = null;

  @JsonProperty("iprangeLow")
  private String iprangeLow = null;

  @JsonProperty("iprangeHigh")
  private String iprangeHigh = null;

  public DiscoverComputersTaskParameters discoveryType(DiscoveryTypeEnum discoveryType) {
    this.discoveryType = discoveryType;
    return this;
  }

   /**
   * Discovery type. Default \&quot;masked-ip\&quot;.
   * @return discoveryType
  **/
  @ApiModelProperty(value = "Discovery type. Default \"masked-ip\".")
  public DiscoveryTypeEnum getDiscoveryType() {
    return discoveryType;
  }

  public void setDiscoveryType(DiscoveryTypeEnum discoveryType) {
    this.discoveryType = discoveryType;
  }

  public DiscoverComputersTaskParameters ip(String ip) {
    this.ip = ip;
    return this;
  }

   /**
   * IP address for masked-ip search.
   * @return ip
  **/
  @ApiModelProperty(value = "IP address for masked-ip search.")
  public String getIp() {
    return ip;
  }

  public void setIp(String ip) {
    this.ip = ip;
  }

  public DiscoverComputersTaskParameters scanDiscoveredComputers(Boolean scanDiscoveredComputers) {
    this.scanDiscoveredComputers = scanDiscoveredComputers;
    return this;
  }

   /**
   * Automatically perform a port scan of discovered computers. Default false. Set true to enable.
   * @return scanDiscoveredComputers
  **/
  @ApiModelProperty(value = "Automatically perform a port scan of discovered computers. Default false. Set true to enable.")
  public Boolean isScanDiscoveredComputers() {
    return scanDiscoveredComputers;
  }

  public void setScanDiscoveredComputers(Boolean scanDiscoveredComputers) {
    this.scanDiscoveredComputers = scanDiscoveredComputers;
  }

  public DiscoverComputersTaskParameters resolveIPs(Boolean resolveIPs) {
    this.resolveIPs = resolveIPs;
    return this;
  }

   /**
   * Automatically resolve IPs to hostnames. Default true. Set false to disable.
   * @return resolveIPs
  **/
  @ApiModelProperty(value = "Automatically resolve IPs to hostnames. Default true. Set false to disable.")
  public Boolean isResolveIPs() {
    return resolveIPs;
  }

  public void setResolveIPs(Boolean resolveIPs) {
    this.resolveIPs = resolveIPs;
  }

  public DiscoverComputersTaskParameters computerGroupID(Integer computerGroupID) {
    this.computerGroupID = computerGroupID;
    return this;
  }

   /**
   * ID of computer group that discovered computers will be added to, or null for no group.
   * @return computerGroupID
  **/
  @ApiModelProperty(value = "ID of computer group that discovered computers will be added to, or null for no group.")
  public Integer getComputerGroupID() {
    return computerGroupID;
  }

  public void setComputerGroupID(Integer computerGroupID) {
    this.computerGroupID = computerGroupID;
  }

  public DiscoverComputersTaskParameters ipmask(String ipmask) {
    this.ipmask = ipmask;
    return this;
  }

   /**
   * Get ipmask
   * @return ipmask
  **/
  @ApiModelProperty(value = "")
  public String getIpmask() {
    return ipmask;
  }

  public void setIpmask(String ipmask) {
    this.ipmask = ipmask;
  }

  public DiscoverComputersTaskParameters iprangeLow(String iprangeLow) {
    this.iprangeLow = iprangeLow;
    return this;
  }

   /**
   * Get iprangeLow
   * @return iprangeLow
  **/
  @ApiModelProperty(value = "")
  public String getIprangeLow() {
    return iprangeLow;
  }

  public void setIprangeLow(String iprangeLow) {
    this.iprangeLow = iprangeLow;
  }

  public DiscoverComputersTaskParameters iprangeHigh(String iprangeHigh) {
    this.iprangeHigh = iprangeHigh;
    return this;
  }

   /**
   * Get iprangeHigh
   * @return iprangeHigh
  **/
  @ApiModelProperty(value = "")
  public String getIprangeHigh() {
    return iprangeHigh;
  }

  public void setIprangeHigh(String iprangeHigh) {
    this.iprangeHigh = iprangeHigh;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DiscoverComputersTaskParameters discoverComputersTaskParameters = (DiscoverComputersTaskParameters) o;
    return Objects.equals(this.discoveryType, discoverComputersTaskParameters.discoveryType) &&
        Objects.equals(this.ip, discoverComputersTaskParameters.ip) &&
        Objects.equals(this.scanDiscoveredComputers, discoverComputersTaskParameters.scanDiscoveredComputers) &&
        Objects.equals(this.resolveIPs, discoverComputersTaskParameters.resolveIPs) &&
        Objects.equals(this.computerGroupID, discoverComputersTaskParameters.computerGroupID) &&
        Objects.equals(this.ipmask, discoverComputersTaskParameters.ipmask) &&
        Objects.equals(this.iprangeLow, discoverComputersTaskParameters.iprangeLow) &&
        Objects.equals(this.iprangeHigh, discoverComputersTaskParameters.iprangeHigh);
  }

  @Override
  public int hashCode() {
    return Objects.hash(discoveryType, ip, scanDiscoveredComputers, resolveIPs, computerGroupID, ipmask, iprangeLow, iprangeHigh);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DiscoverComputersTaskParameters {\n");
    
    sb.append("    discoveryType: ").append(toIndentedString(discoveryType)).append("\n");
    sb.append("    ip: ").append(toIndentedString(ip)).append("\n");
    sb.append("    scanDiscoveredComputers: ").append(toIndentedString(scanDiscoveredComputers)).append("\n");
    sb.append("    resolveIPs: ").append(toIndentedString(resolveIPs)).append("\n");
    sb.append("    computerGroupID: ").append(toIndentedString(computerGroupID)).append("\n");
    sb.append("    ipmask: ").append(toIndentedString(ipmask)).append("\n");
    sb.append("    iprangeLow: ").append(toIndentedString(iprangeLow)).append("\n");
    sb.append("    iprangeHigh: ").append(toIndentedString(iprangeHigh)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

