/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.VirtualMachineMetadata;
import com.trendmicro.deepsecurity.model.VirtualMachineSecurityGroup;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of an AWS EC2 virtual machine.
 */
@ApiModel(description = "Details of an AWS EC2 virtual machine.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class Ec2VirtualMachineSummary {
  @JsonProperty("cloudProvider")
  private String cloudProvider = null;

  @JsonProperty("accountID")
  private String accountID = null;

  @JsonProperty("operatingSystem")
  private String operatingSystem = null;

  @JsonProperty("privateIPAddress")
  private String privateIPAddress = null;

  @JsonProperty("publicIPAddress")
  private String publicIPAddress = null;

  @JsonProperty("availabilityZone")
  private String availabilityZone = null;

  @JsonProperty("instanceID")
  private String instanceID = null;

  @JsonProperty("securityGroups")
  private List<VirtualMachineSecurityGroup> securityGroups = null;

  @JsonProperty("type")
  private String type = null;

  @JsonProperty("virtualizationType")
  private String virtualizationType = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("metadata")
  private List<VirtualMachineMetadata> metadata = null;

  @JsonProperty("amiID")
  private String amiID = null;

  @JsonProperty("DNSName")
  private String dnSName = null;

  public Ec2VirtualMachineSummary cloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
    return this;
  }

   /**
   * Cloud provider: \&quot;AWS\&quot;.
   * @return cloudProvider
  **/
  @ApiModelProperty(value = "Cloud provider: \"AWS\".")
  public String getCloudProvider() {
    return cloudProvider;
  }

  public void setCloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
  }

  public Ec2VirtualMachineSummary accountID(String accountID) {
    this.accountID = accountID;
    return this;
  }

   /**
   * Account ID. Searchable as String.
   * @return accountID
  **/
  @ApiModelProperty(value = "Account ID. Searchable as String.")
  public String getAccountID() {
    return accountID;
  }

  public void setAccountID(String accountID) {
    this.accountID = accountID;
  }

  public Ec2VirtualMachineSummary operatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
    return this;
  }

   /**
   * Operating system, for example: \&quot;Microsoft Windows (64 bit)\&quot;. Searchable as String.
   * @return operatingSystem
  **/
  @ApiModelProperty(value = "Operating system, for example: \"Microsoft Windows (64 bit)\". Searchable as String.")
  public String getOperatingSystem() {
    return operatingSystem;
  }

  public void setOperatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
  }

  public Ec2VirtualMachineSummary privateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
    return this;
  }

   /**
   * Private IP address. Searchable as String.
   * @return privateIPAddress
  **/
  @ApiModelProperty(value = "Private IP address. Searchable as String.")
  public String getPrivateIPAddress() {
    return privateIPAddress;
  }

  public void setPrivateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
  }

  public Ec2VirtualMachineSummary publicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
    return this;
  }

   /**
   * Public IP address. Searchable as String.
   * @return publicIPAddress
  **/
  @ApiModelProperty(value = "Public IP address. Searchable as String.")
  public String getPublicIPAddress() {
    return publicIPAddress;
  }

  public void setPublicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
  }

  public Ec2VirtualMachineSummary availabilityZone(String availabilityZone) {
    this.availabilityZone = availabilityZone;
    return this;
  }

   /**
   * Availability Zone, for example: \&quot;us-east-1a\&quot;. Searchable as String.
   * @return availabilityZone
  **/
  @ApiModelProperty(value = "Availability Zone, for example: \"us-east-1a\". Searchable as String.")
  public String getAvailabilityZone() {
    return availabilityZone;
  }

  public void setAvailabilityZone(String availabilityZone) {
    this.availabilityZone = availabilityZone;
  }

  public Ec2VirtualMachineSummary instanceID(String instanceID) {
    this.instanceID = instanceID;
    return this;
  }

   /**
   * Instance ID, for example: \&quot;i-0e80f75f9532ad1ba\&quot;. Searchable as String.
   * @return instanceID
  **/
  @ApiModelProperty(value = "Instance ID, for example: \"i-0e80f75f9532ad1ba\". Searchable as String.")
  public String getInstanceID() {
    return instanceID;
  }

  public void setInstanceID(String instanceID) {
    this.instanceID = instanceID;
  }

  public Ec2VirtualMachineSummary securityGroups(List<VirtualMachineSecurityGroup> securityGroups) {
    this.securityGroups = securityGroups;
    return this;
  }

  public Ec2VirtualMachineSummary addSecurityGroupsItem(VirtualMachineSecurityGroup securityGroupsItem) {
    if (this.securityGroups == null) {
      this.securityGroups = new ArrayList<>();
    }
    this.securityGroups.add(securityGroupsItem);
    return this;
  }

   /**
   * List of security groups.
   * @return securityGroups
  **/
  @ApiModelProperty(value = "List of security groups.")
  public List<VirtualMachineSecurityGroup> getSecurityGroups() {
    return securityGroups;
  }

  public void setSecurityGroups(List<VirtualMachineSecurityGroup> securityGroups) {
    this.securityGroups = securityGroups;
  }

  public Ec2VirtualMachineSummary type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Instance type, for example: \&quot;t2.micro\&quot;. Searchable as String.
   * @return type
  **/
  @ApiModelProperty(value = "Instance type, for example: \"t2.micro\". Searchable as String.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public Ec2VirtualMachineSummary virtualizationType(String virtualizationType) {
    this.virtualizationType = virtualizationType;
    return this;
  }

   /**
   * Virtualization type, for example: \&quot;hvm\&quot;. Searchable as String.
   * @return virtualizationType
  **/
  @ApiModelProperty(value = "Virtualization type, for example: \"hvm\". Searchable as String.")
  public String getVirtualizationType() {
    return virtualizationType;
  }

  public void setVirtualizationType(String virtualizationType) {
    this.virtualizationType = virtualizationType;
  }

  public Ec2VirtualMachineSummary state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Power state, for example, \&quot;POWER ON\&quot;.
   * @return state
  **/
  @ApiModelProperty(value = "Power state, for example, \"POWER ON\".")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public Ec2VirtualMachineSummary metadata(List<VirtualMachineMetadata> metadata) {
    this.metadata = metadata;
    return this;
  }

  public Ec2VirtualMachineSummary addMetadataItem(VirtualMachineMetadata metadataItem) {
    if (this.metadata == null) {
      this.metadata = new ArrayList<>();
    }
    this.metadata.add(metadataItem);
    return this;
  }

   /**
   * List of name/value metadata pairs.
   * @return metadata
  **/
  @ApiModelProperty(value = "List of name/value metadata pairs.")
  public List<VirtualMachineMetadata> getMetadata() {
    return metadata;
  }

  public void setMetadata(List<VirtualMachineMetadata> metadata) {
    this.metadata = metadata;
  }

  public Ec2VirtualMachineSummary amiID(String amiID) {
    this.amiID = amiID;
    return this;
  }

   /**
   * Get amiID
   * @return amiID
  **/
  @ApiModelProperty(value = "")
  public String getAmiID() {
    return amiID;
  }

  public void setAmiID(String amiID) {
    this.amiID = amiID;
  }

  public Ec2VirtualMachineSummary dnSName(String dnSName) {
    this.dnSName = dnSName;
    return this;
  }

   /**
   * Get dnSName
   * @return dnSName
  **/
  @ApiModelProperty(value = "")
  public String getDnSName() {
    return dnSName;
  }

  public void setDnSName(String dnSName) {
    this.dnSName = dnSName;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Ec2VirtualMachineSummary ec2VirtualMachineSummary = (Ec2VirtualMachineSummary) o;
    return Objects.equals(this.cloudProvider, ec2VirtualMachineSummary.cloudProvider) &&
        Objects.equals(this.accountID, ec2VirtualMachineSummary.accountID) &&
        Objects.equals(this.operatingSystem, ec2VirtualMachineSummary.operatingSystem) &&
        Objects.equals(this.privateIPAddress, ec2VirtualMachineSummary.privateIPAddress) &&
        Objects.equals(this.publicIPAddress, ec2VirtualMachineSummary.publicIPAddress) &&
        Objects.equals(this.availabilityZone, ec2VirtualMachineSummary.availabilityZone) &&
        Objects.equals(this.instanceID, ec2VirtualMachineSummary.instanceID) &&
        Objects.equals(this.securityGroups, ec2VirtualMachineSummary.securityGroups) &&
        Objects.equals(this.type, ec2VirtualMachineSummary.type) &&
        Objects.equals(this.virtualizationType, ec2VirtualMachineSummary.virtualizationType) &&
        Objects.equals(this.state, ec2VirtualMachineSummary.state) &&
        Objects.equals(this.metadata, ec2VirtualMachineSummary.metadata) &&
        Objects.equals(this.amiID, ec2VirtualMachineSummary.amiID) &&
        Objects.equals(this.dnSName, ec2VirtualMachineSummary.dnSName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cloudProvider, accountID, operatingSystem, privateIPAddress, publicIPAddress, availabilityZone, instanceID, securityGroups, type, virtualizationType, state, metadata, amiID, dnSName);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Ec2VirtualMachineSummary {\n");
    
    sb.append("    cloudProvider: ").append(toIndentedString(cloudProvider)).append("\n");
    sb.append("    accountID: ").append(toIndentedString(accountID)).append("\n");
    sb.append("    operatingSystem: ").append(toIndentedString(operatingSystem)).append("\n");
    sb.append("    privateIPAddress: ").append(toIndentedString(privateIPAddress)).append("\n");
    sb.append("    publicIPAddress: ").append(toIndentedString(publicIPAddress)).append("\n");
    sb.append("    availabilityZone: ").append(toIndentedString(availabilityZone)).append("\n");
    sb.append("    instanceID: ").append(toIndentedString(instanceID)).append("\n");
    sb.append("    securityGroups: ").append(toIndentedString(securityGroups)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    virtualizationType: ").append(toIndentedString(virtualizationType)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    amiID: ").append(toIndentedString(amiID)).append("\n");
    sb.append("    dnSName: ").append(toIndentedString(dnSName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

