/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.EventBasedTaskAction;
import com.trendmicro.deepsecurity.model.EventBasedTaskCondition;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Defines an event based task. Events based tasks automatically perform specific Deep Security Manager triggered by an event.
 */
@ApiModel(description = "Defines an event based task. Events based tasks automatically perform specific Deep Security Manager triggered by an event.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class EventBasedTask {
  @JsonProperty("name")
  private String name = null;

  /**
   * Type of scheduled task. Searchable as Choice.
   */
  public enum TypeEnum {
    COMPUTER_CREATED_BY_SYSTEM("computer-created-by-system"),
    
    COMPUTER_MOVED_BY_SYSTEM("computer-moved-by-system"),
    
    AGENT_INITIATED_ACTIVATION("agent-initiated-activation"),
    
    AGENT_IP_CHANGED("agent-ip-changed"),
    
    NSX_PROTECTION_CHANGED("nsx-protection-changed"),
    
    COMPUTER_POWERED_ON_BY_SYSTEM("computer-powered-on-by-system");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("enabled")
  private Boolean enabled = null;

  @JsonProperty("lastRunTime")
  private Long lastRunTime = null;

  @JsonProperty("actions")
  private List<EventBasedTaskAction> actions = null;

  @JsonProperty("conditions")
  private List<EventBasedTaskCondition> conditions = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public EventBasedTask name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of event based task. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of event based task. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public EventBasedTask type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Type of scheduled task. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(value = "Type of scheduled task. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public EventBasedTask enabled(Boolean enabled) {
    this.enabled = enabled;
    return this;
  }

   /**
   * Indicates whether or not the event based task is enabled. Searchable as Boolean.
   * @return enabled
  **/
  @ApiModelProperty(value = "Indicates whether or not the event based task is enabled. Searchable as Boolean.")
  public Boolean isEnabled() {
    return enabled;
  }

  public void setEnabled(Boolean enabled) {
    this.enabled = enabled;
  }

  public EventBasedTask lastRunTime(Long lastRunTime) {
    this.lastRunTime = lastRunTime;
    return this;
  }

   /**
   * The last time this event based task was run, or null if never run. Searchable as Date.
   * @return lastRunTime
  **/
  @ApiModelProperty(value = "The last time this event based task was run, or null if never run. Searchable as Date.")
  public Long getLastRunTime() {
    return lastRunTime;
  }

  public void setLastRunTime(Long lastRunTime) {
    this.lastRunTime = lastRunTime;
  }

  public EventBasedTask actions(List<EventBasedTaskAction> actions) {
    this.actions = actions;
    return this;
  }

  public EventBasedTask addActionsItem(EventBasedTaskAction actionsItem) {
    if (this.actions == null) {
      this.actions = new ArrayList<>();
    }
    this.actions.add(actionsItem);
    return this;
  }

   /**
   * List of actions to perform when an event based task condition is met.
   * @return actions
  **/
  @ApiModelProperty(value = "List of actions to perform when an event based task condition is met.")
  public List<EventBasedTaskAction> getActions() {
    return actions;
  }

  public void setActions(List<EventBasedTaskAction> actions) {
    this.actions = actions;
  }

  public EventBasedTask conditions(List<EventBasedTaskCondition> conditions) {
    this.conditions = conditions;
    return this;
  }

  public EventBasedTask addConditionsItem(EventBasedTaskCondition conditionsItem) {
    if (this.conditions == null) {
      this.conditions = new ArrayList<>();
    }
    this.conditions.add(conditionsItem);
    return this;
  }

   /**
   * List of conditions that must be met in order for an event based task to run its actions.
   * @return conditions
  **/
  @ApiModelProperty(value = "List of conditions that must be met in order for an event based task to run its actions.")
  public List<EventBasedTaskCondition> getConditions() {
    return conditions;
  }

  public void setConditions(List<EventBasedTaskCondition> conditions) {
    this.conditions = conditions;
  }

   /**
   * Event based task identifier. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "Event based task identifier. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EventBasedTask eventBasedTask = (EventBasedTask) o;
    return Objects.equals(this.name, eventBasedTask.name) &&
        Objects.equals(this.type, eventBasedTask.type) &&
        Objects.equals(this.enabled, eventBasedTask.enabled) &&
        Objects.equals(this.lastRunTime, eventBasedTask.lastRunTime) &&
        Objects.equals(this.actions, eventBasedTask.actions) &&
        Objects.equals(this.conditions, eventBasedTask.conditions) &&
        Objects.equals(this.ID, eventBasedTask.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type, enabled, lastRunTime, actions, conditions, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EventBasedTask {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    enabled: ").append(toIndentedString(enabled)).append("\n");
    sb.append("    lastRunTime: ").append(toIndentedString(lastRunTime)).append("\n");
    sb.append("    actions: ").append(toIndentedString(actions)).append("\n");
    sb.append("    conditions: ").append(toIndentedString(conditions)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

