/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ContextRights;
import com.trendmicro.deepsecurity.model.FirewallRuleRights;
import com.trendmicro.deepsecurity.model.MacListRights;
import com.trendmicro.deepsecurity.model.StatefulConfigurationRights;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Firewall rights details.
 */
@ApiModel(description = "Firewall rights details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class FirewallRights {
  @JsonProperty("contextRights")
  private ContextRights contextRights = null;

  @JsonProperty("firewallRuleRights")
  private FirewallRuleRights firewallRuleRights = null;

  @JsonProperty("statefulConfigurationRights")
  private StatefulConfigurationRights statefulConfigurationRights = null;

  @JsonProperty("macListRights")
  private MacListRights macListRights = null;

  public FirewallRights contextRights(ContextRights contextRights) {
    this.contextRights = contextRights;
    return this;
  }

   /**
   * Rights related to contexts.
   * @return contextRights
  **/
  @ApiModelProperty(value = "Rights related to contexts.")
  public ContextRights getContextRights() {
    return contextRights;
  }

  public void setContextRights(ContextRights contextRights) {
    this.contextRights = contextRights;
  }

  public FirewallRights firewallRuleRights(FirewallRuleRights firewallRuleRights) {
    this.firewallRuleRights = firewallRuleRights;
    return this;
  }

   /**
   * Rights related to firewall rules.
   * @return firewallRuleRights
  **/
  @ApiModelProperty(value = "Rights related to firewall rules.")
  public FirewallRuleRights getFirewallRuleRights() {
    return firewallRuleRights;
  }

  public void setFirewallRuleRights(FirewallRuleRights firewallRuleRights) {
    this.firewallRuleRights = firewallRuleRights;
  }

  public FirewallRights statefulConfigurationRights(StatefulConfigurationRights statefulConfigurationRights) {
    this.statefulConfigurationRights = statefulConfigurationRights;
    return this;
  }

   /**
   * Rights related to stateful configurations.
   * @return statefulConfigurationRights
  **/
  @ApiModelProperty(value = "Rights related to stateful configurations.")
  public StatefulConfigurationRights getStatefulConfigurationRights() {
    return statefulConfigurationRights;
  }

  public void setStatefulConfigurationRights(StatefulConfigurationRights statefulConfigurationRights) {
    this.statefulConfigurationRights = statefulConfigurationRights;
  }

  public FirewallRights macListRights(MacListRights macListRights) {
    this.macListRights = macListRights;
    return this;
  }

   /**
   * Get macListRights
   * @return macListRights
  **/
  @ApiModelProperty(value = "")
  public MacListRights getMacListRights() {
    return macListRights;
  }

  public void setMacListRights(MacListRights macListRights) {
    this.macListRights = macListRights;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FirewallRights firewallRights = (FirewallRights) o;
    return Objects.equals(this.contextRights, firewallRights.contextRights) &&
        Objects.equals(this.firewallRuleRights, firewallRights.firewallRuleRights) &&
        Objects.equals(this.statefulConfigurationRights, firewallRights.statefulConfigurationRights) &&
        Objects.equals(this.macListRights, firewallRights.macListRights);
  }

  @Override
  public int hashCode() {
    return Objects.hash(contextRights, firewallRuleRights, statefulConfigurationRights, macListRights);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FirewallRights {\n");
    
    sb.append("    contextRights: ").append(toIndentedString(contextRights)).append("\n");
    sb.append("    firewallRuleRights: ").append(toIndentedString(firewallRuleRights)).append("\n");
    sb.append("    statefulConfigurationRights: ").append(toIndentedString(statefulConfigurationRights)).append("\n");
    sb.append("    macListRights: ").append(toIndentedString(macListRights)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

