/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Everything about GCP connector.
 */
@ApiModel(description = "Everything about GCP connector.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class GCPConnector {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("serviceAccount")
  private String serviceAccount = null;

  @JsonProperty("ownerProjectID")
  private String ownerProjectID = null;

  @JsonProperty("privateKeyID")
  private String privateKeyID = null;

  @JsonProperty("clientEmail")
  private String clientEmail = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public GCPConnector name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Display name of the connector. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Display name of the connector. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public GCPConnector serviceAccount(String serviceAccount) {
    this.serviceAccount = serviceAccount;
    return this;
  }

   /**
   * Service account of the connector, base64-encoded.
   * @return serviceAccount
  **/
  @ApiModelProperty(value = "Service account of the connector, base64-encoded.")
  public String getServiceAccount() {
    return serviceAccount;
  }

  public void setServiceAccount(String serviceAccount) {
    this.serviceAccount = serviceAccount;
  }

   /**
   * The project ID which owns the service account. Searchable as String.
   * @return ownerProjectID
  **/
  @ApiModelProperty(value = "The project ID which owns the service account. Searchable as String.")
  public String getOwnerProjectID() {
    return ownerProjectID;
  }

   /**
   * Private key ID of the GCP service account. Searchable as String.
   * @return privateKeyID
  **/
  @ApiModelProperty(value = "Private key ID of the GCP service account. Searchable as String.")
  public String getPrivateKeyID() {
    return privateKeyID;
  }

   /**
   * Client email of the GCP service account. Searchable as String.
   * @return clientEmail
  **/
  @ApiModelProperty(value = "Client email of the GCP service account. Searchable as String.")
  public String getClientEmail() {
    return clientEmail;
  }

   /**
   * ID of the connector.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the connector.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GCPConnector gcPConnector = (GCPConnector) o;
    return Objects.equals(this.name, gcPConnector.name) &&
        Objects.equals(this.serviceAccount, gcPConnector.serviceAccount) &&
        Objects.equals(this.ownerProjectID, gcPConnector.ownerProjectID) &&
        Objects.equals(this.privateKeyID, gcPConnector.privateKeyID) &&
        Objects.equals(this.clientEmail, gcPConnector.clientEmail) &&
        Objects.equals(this.ID, gcPConnector.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, serviceAccount, ownerProjectID, privateKeyID, clientEmail, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GCPConnector {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    serviceAccount: ").append(toIndentedString(serviceAccount)).append("\n");
    sb.append("    ownerProjectID: ").append(toIndentedString(ownerProjectID)).append("\n");
    sb.append("    privateKeyID: ").append(toIndentedString(privateKeyID)).append("\n");
    sb.append("    clientEmail: ").append(toIndentedString(clientEmail)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

