/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.VirtualMachineGCPLabel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of a GCP virtual machine.
 */
@ApiModel(description = "Details of a GCP virtual machine.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class GcpVirtualMachineSummary {
  @JsonProperty("cloudProvider")
  private String cloudProvider = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("operatingSystem")
  private String operatingSystem = null;

  @JsonProperty("instanceID")
  private String instanceID = null;

  @JsonProperty("privateIPAddress")
  private String privateIPAddress = null;

  @JsonProperty("publicIPAddress")
  private String publicIPAddress = null;

  @JsonProperty("zone")
  private String zone = null;

  @JsonProperty("vCPUs")
  private Integer vCPUs = null;

  @JsonProperty("memory")
  private Integer memory = null;

  @JsonProperty("labels")
  private List<VirtualMachineGCPLabel> labels = null;

  @JsonProperty("networkTags")
  private List<String> networkTags = null;

  public GcpVirtualMachineSummary cloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
    return this;
  }

   /**
   * Cloud provider: \&quot;GCP\&quot;.
   * @return cloudProvider
  **/
  @ApiModelProperty(value = "Cloud provider: \"GCP\".")
  public String getCloudProvider() {
    return cloudProvider;
  }

  public void setCloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
  }

  public GcpVirtualMachineSummary state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Power state, for example, \&quot;POWER ON\&quot;.
   * @return state
  **/
  @ApiModelProperty(value = "Power state, for example, \"POWER ON\".")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public GcpVirtualMachineSummary operatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
    return this;
  }

   /**
   * Operating system, for example: \&quot;Microsoft Windows (64 bit)\&quot;. Searchable as String.
   * @return operatingSystem
  **/
  @ApiModelProperty(value = "Operating system, for example: \"Microsoft Windows (64 bit)\". Searchable as String.")
  public String getOperatingSystem() {
    return operatingSystem;
  }

  public void setOperatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
  }

  public GcpVirtualMachineSummary instanceID(String instanceID) {
    this.instanceID = instanceID;
    return this;
  }

   /**
   * Instance ID, for example: \&quot;1234567890123456789\&quot;. Searchable as String.
   * @return instanceID
  **/
  @ApiModelProperty(value = "Instance ID, for example: \"1234567890123456789\". Searchable as String.")
  public String getInstanceID() {
    return instanceID;
  }

  public void setInstanceID(String instanceID) {
    this.instanceID = instanceID;
  }

  public GcpVirtualMachineSummary privateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
    return this;
  }

   /**
   * Private IP address. Searchable as String.
   * @return privateIPAddress
  **/
  @ApiModelProperty(value = "Private IP address. Searchable as String.")
  public String getPrivateIPAddress() {
    return privateIPAddress;
  }

  public void setPrivateIPAddress(String privateIPAddress) {
    this.privateIPAddress = privateIPAddress;
  }

  public GcpVirtualMachineSummary publicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
    return this;
  }

   /**
   * Public IP address. Searchable as String.
   * @return publicIPAddress
  **/
  @ApiModelProperty(value = "Public IP address. Searchable as String.")
  public String getPublicIPAddress() {
    return publicIPAddress;
  }

  public void setPublicIPAddress(String publicIPAddress) {
    this.publicIPAddress = publicIPAddress;
  }

  public GcpVirtualMachineSummary zone(String zone) {
    this.zone = zone;
    return this;
  }

   /**
   * Zone is a deployment area, for example: \&quot;us-east1-d\&quot;. Searchable as String.
   * @return zone
  **/
  @ApiModelProperty(value = "Zone is a deployment area, for example: \"us-east1-d\". Searchable as String.")
  public String getZone() {
    return zone;
  }

  public void setZone(String zone) {
    this.zone = zone;
  }

  public GcpVirtualMachineSummary vCPUs(Integer vCPUs) {
    this.vCPUs = vCPUs;
    return this;
  }

   /**
   * Number of vCPU. Searchable as Numeric.
   * @return vCPUs
  **/
  @ApiModelProperty(value = "Number of vCPU. Searchable as Numeric.")
  public Integer getVCPUs() {
    return vCPUs;
  }

  public void setVCPUs(Integer vCPUs) {
    this.vCPUs = vCPUs;
  }

  public GcpVirtualMachineSummary memory(Integer memory) {
    this.memory = memory;
    return this;
  }

   /**
   * Memory size in megabyte. Searchable as Numeric.
   * @return memory
  **/
  @ApiModelProperty(value = "Memory size in megabyte. Searchable as Numeric.")
  public Integer getMemory() {
    return memory;
  }

  public void setMemory(Integer memory) {
    this.memory = memory;
  }

  public GcpVirtualMachineSummary labels(List<VirtualMachineGCPLabel> labels) {
    this.labels = labels;
    return this;
  }

  public GcpVirtualMachineSummary addLabelsItem(VirtualMachineGCPLabel labelsItem) {
    if (this.labels == null) {
      this.labels = new ArrayList<>();
    }
    this.labels.add(labelsItem);
    return this;
  }

   /**
   * List of key/value labels.
   * @return labels
  **/
  @ApiModelProperty(value = "List of key/value labels.")
  public List<VirtualMachineGCPLabel> getLabels() {
    return labels;
  }

  public void setLabels(List<VirtualMachineGCPLabel> labels) {
    this.labels = labels;
  }

  public GcpVirtualMachineSummary networkTags(List<String> networkTags) {
    this.networkTags = networkTags;
    return this;
  }

  public GcpVirtualMachineSummary addNetworkTagsItem(String networkTagsItem) {
    if (this.networkTags == null) {
      this.networkTags = new ArrayList<>();
    }
    this.networkTags.add(networkTagsItem);
    return this;
  }

   /**
   * List of network tags.
   * @return networkTags
  **/
  @ApiModelProperty(value = "List of network tags.")
  public List<String> getNetworkTags() {
    return networkTags;
  }

  public void setNetworkTags(List<String> networkTags) {
    this.networkTags = networkTags;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GcpVirtualMachineSummary gcpVirtualMachineSummary = (GcpVirtualMachineSummary) o;
    return Objects.equals(this.cloudProvider, gcpVirtualMachineSummary.cloudProvider) &&
        Objects.equals(this.state, gcpVirtualMachineSummary.state) &&
        Objects.equals(this.operatingSystem, gcpVirtualMachineSummary.operatingSystem) &&
        Objects.equals(this.instanceID, gcpVirtualMachineSummary.instanceID) &&
        Objects.equals(this.privateIPAddress, gcpVirtualMachineSummary.privateIPAddress) &&
        Objects.equals(this.publicIPAddress, gcpVirtualMachineSummary.publicIPAddress) &&
        Objects.equals(this.zone, gcpVirtualMachineSummary.zone) &&
        Objects.equals(this.vCPUs, gcpVirtualMachineSummary.vCPUs) &&
        Objects.equals(this.memory, gcpVirtualMachineSummary.memory) &&
        Objects.equals(this.labels, gcpVirtualMachineSummary.labels) &&
        Objects.equals(this.networkTags, gcpVirtualMachineSummary.networkTags);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cloudProvider, state, operatingSystem, instanceID, privateIPAddress, publicIPAddress, zone, vCPUs, memory, labels, networkTags);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GcpVirtualMachineSummary {\n");
    
    sb.append("    cloudProvider: ").append(toIndentedString(cloudProvider)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    operatingSystem: ").append(toIndentedString(operatingSystem)).append("\n");
    sb.append("    instanceID: ").append(toIndentedString(instanceID)).append("\n");
    sb.append("    privateIPAddress: ").append(toIndentedString(privateIPAddress)).append("\n");
    sb.append("    publicIPAddress: ").append(toIndentedString(publicIPAddress)).append("\n");
    sb.append("    zone: ").append(toIndentedString(zone)).append("\n");
    sb.append("    vCPUs: ").append(toIndentedString(vCPUs)).append("\n");
    sb.append("    memory: ").append(toIndentedString(memory)).append("\n");
    sb.append("    labels: ").append(toIndentedString(labels)).append("\n");
    sb.append("    networkTags: ").append(toIndentedString(networkTags)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

