/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.AccountRights;
import com.trendmicro.deepsecurity.model.FixRights;
import com.trendmicro.deepsecurity.model.HeapRights;
import com.trendmicro.deepsecurity.model.LicenseRateRights;
import com.trendmicro.deepsecurity.model.NetworkSecurityRights;
import com.trendmicro.deepsecurity.model.QueryRights;
import com.trendmicro.deepsecurity.model.QueryTracebackRights;
import com.trendmicro.deepsecurity.model.ServerLogRights;
import com.trendmicro.deepsecurity.model.StackTraceRights;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Hosted service rights details.
 */
@ApiModel(description = "Hosted service rights details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class HostedServiceRights {
  @JsonProperty("accountRights")
  private AccountRights accountRights = null;

  @JsonProperty("fixRights")
  private FixRights fixRights = null;

  @JsonProperty("heapRights")
  private HeapRights heapRights = null;

  @JsonProperty("licenseRateRights")
  private LicenseRateRights licenseRateRights = null;

  @JsonProperty("queryRights")
  private QueryRights queryRights = null;

  @JsonProperty("queryTracebackRights")
  private QueryTracebackRights queryTracebackRights = null;

  @JsonProperty("serverLogRights")
  private ServerLogRights serverLogRights = null;

  @JsonProperty("stackTraceRights")
  private StackTraceRights stackTraceRights = null;

  @JsonProperty("networkSecurityRights")
  private NetworkSecurityRights networkSecurityRights = null;

  public HostedServiceRights accountRights(AccountRights accountRights) {
    this.accountRights = accountRights;
    return this;
  }

   /**
   * Rights related to accounts.
   * @return accountRights
  **/
  @ApiModelProperty(value = "Rights related to accounts.")
  public AccountRights getAccountRights() {
    return accountRights;
  }

  public void setAccountRights(AccountRights accountRights) {
    this.accountRights = accountRights;
  }

  public HostedServiceRights fixRights(FixRights fixRights) {
    this.fixRights = fixRights;
    return this;
  }

   /**
   * Rights related to fixes.
   * @return fixRights
  **/
  @ApiModelProperty(value = "Rights related to fixes.")
  public FixRights getFixRights() {
    return fixRights;
  }

  public void setFixRights(FixRights fixRights) {
    this.fixRights = fixRights;
  }

  public HostedServiceRights heapRights(HeapRights heapRights) {
    this.heapRights = heapRights;
    return this;
  }

   /**
   * Rights related to the heap.
   * @return heapRights
  **/
  @ApiModelProperty(value = "Rights related to the heap.")
  public HeapRights getHeapRights() {
    return heapRights;
  }

  public void setHeapRights(HeapRights heapRights) {
    this.heapRights = heapRights;
  }

  public HostedServiceRights licenseRateRights(LicenseRateRights licenseRateRights) {
    this.licenseRateRights = licenseRateRights;
    return this;
  }

   /**
   * Rights related to license rates.
   * @return licenseRateRights
  **/
  @ApiModelProperty(value = "Rights related to license rates.")
  public LicenseRateRights getLicenseRateRights() {
    return licenseRateRights;
  }

  public void setLicenseRateRights(LicenseRateRights licenseRateRights) {
    this.licenseRateRights = licenseRateRights;
  }

  public HostedServiceRights queryRights(QueryRights queryRights) {
    this.queryRights = queryRights;
    return this;
  }

   /**
   * Rights related to queries.
   * @return queryRights
  **/
  @ApiModelProperty(value = "Rights related to queries.")
  public QueryRights getQueryRights() {
    return queryRights;
  }

  public void setQueryRights(QueryRights queryRights) {
    this.queryRights = queryRights;
  }

  public HostedServiceRights queryTracebackRights(QueryTracebackRights queryTracebackRights) {
    this.queryTracebackRights = queryTracebackRights;
    return this;
  }

   /**
   * Rights related to query traceback.
   * @return queryTracebackRights
  **/
  @ApiModelProperty(value = "Rights related to query traceback.")
  public QueryTracebackRights getQueryTracebackRights() {
    return queryTracebackRights;
  }

  public void setQueryTracebackRights(QueryTracebackRights queryTracebackRights) {
    this.queryTracebackRights = queryTracebackRights;
  }

  public HostedServiceRights serverLogRights(ServerLogRights serverLogRights) {
    this.serverLogRights = serverLogRights;
    return this;
  }

   /**
   * Rights related to server logs.
   * @return serverLogRights
  **/
  @ApiModelProperty(value = "Rights related to server logs.")
  public ServerLogRights getServerLogRights() {
    return serverLogRights;
  }

  public void setServerLogRights(ServerLogRights serverLogRights) {
    this.serverLogRights = serverLogRights;
  }

  public HostedServiceRights stackTraceRights(StackTraceRights stackTraceRights) {
    this.stackTraceRights = stackTraceRights;
    return this;
  }

   /**
   * Rights related to stack traces.
   * @return stackTraceRights
  **/
  @ApiModelProperty(value = "Rights related to stack traces.")
  public StackTraceRights getStackTraceRights() {
    return stackTraceRights;
  }

  public void setStackTraceRights(StackTraceRights stackTraceRights) {
    this.stackTraceRights = stackTraceRights;
  }

  public HostedServiceRights networkSecurityRights(NetworkSecurityRights networkSecurityRights) {
    this.networkSecurityRights = networkSecurityRights;
    return this;
  }

   /**
   * Rights related to Network Security.
   * @return networkSecurityRights
  **/
  @ApiModelProperty(value = "Rights related to Network Security.")
  public NetworkSecurityRights getNetworkSecurityRights() {
    return networkSecurityRights;
  }

  public void setNetworkSecurityRights(NetworkSecurityRights networkSecurityRights) {
    this.networkSecurityRights = networkSecurityRights;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HostedServiceRights hostedServiceRights = (HostedServiceRights) o;
    return Objects.equals(this.accountRights, hostedServiceRights.accountRights) &&
        Objects.equals(this.fixRights, hostedServiceRights.fixRights) &&
        Objects.equals(this.heapRights, hostedServiceRights.heapRights) &&
        Objects.equals(this.licenseRateRights, hostedServiceRights.licenseRateRights) &&
        Objects.equals(this.queryRights, hostedServiceRights.queryRights) &&
        Objects.equals(this.queryTracebackRights, hostedServiceRights.queryTracebackRights) &&
        Objects.equals(this.serverLogRights, hostedServiceRights.serverLogRights) &&
        Objects.equals(this.stackTraceRights, hostedServiceRights.stackTraceRights) &&
        Objects.equals(this.networkSecurityRights, hostedServiceRights.networkSecurityRights);
  }

  @Override
  public int hashCode() {
    return Objects.hash(accountRights, fixRights, heapRights, licenseRateRights, queryRights, queryTracebackRights, serverLogRights, stackTraceRights, networkSecurityRights);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HostedServiceRights {\n");
    
    sb.append("    accountRights: ").append(toIndentedString(accountRights)).append("\n");
    sb.append("    fixRights: ").append(toIndentedString(fixRights)).append("\n");
    sb.append("    heapRights: ").append(toIndentedString(heapRights)).append("\n");
    sb.append("    licenseRateRights: ").append(toIndentedString(licenseRateRights)).append("\n");
    sb.append("    queryRights: ").append(toIndentedString(queryRights)).append("\n");
    sb.append("    queryTracebackRights: ").append(toIndentedString(queryTracebackRights)).append("\n");
    sb.append("    serverLogRights: ").append(toIndentedString(serverLogRights)).append("\n");
    sb.append("    stackTraceRights: ").append(toIndentedString(stackTraceRights)).append("\n");
    sb.append("    networkSecurityRights: ").append(toIndentedString(networkSecurityRights)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

