/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Integrity monitoring rules describe how Deep Security Agents should scan for and detect changes to a computer&#39;s files, directories and registry keys and values as well as changes in installed software, processes, listening ports and running services. Integrity monitoring rules can be assigned directly to computers or can be made part of a policy.
 */
@ApiModel(description = "Integrity monitoring rules describe how Deep Security Agents should scan for and detect changes to a computer's files, directories and registry keys and values as well as changes in installed software, processes, listening ports and running services. Integrity monitoring rules can be assigned directly to computers or can be made part of a policy.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class IntegrityMonitoringRule {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("minimumAgentVersion")
  private String minimumAgentVersion = null;

  @JsonProperty("minimumManagerVersion")
  private String minimumManagerVersion = null;

  /**
   * Severity level of the event is multiplied by the computer&#39;s asset value to determine ranking. Ranking can be used to sort events with more business impact. Searchable as Choice.
   */
  public enum SeverityEnum {
    LOW("low"),
    
    MEDIUM("medium"),
    
    HIGH("high"),
    
    CRITICAL("critical");

    private String value;

    SeverityEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SeverityEnum fromValue(String text) {
      for (SeverityEnum b : SeverityEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("severity")
  private SeverityEnum severity = null;

  @JsonProperty("type")
  private String type = null;

  @JsonProperty("originalIssue")
  private Long originalIssue = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("identifier")
  private String identifier = null;

  /**
   * Template which the IntegrityMonitoringRule follows.
   */
  public enum TemplateEnum {
    REGISTRY("registry"),
    
    FILE("file"),
    
    CUSTOM("custom");

    private String value;

    TemplateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TemplateEnum fromValue(String text) {
      for (TemplateEnum b : TemplateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("template")
  private TemplateEnum template = null;

  @JsonProperty("registryKeyRoot")
  private String registryKeyRoot = null;

  @JsonProperty("registryKeyValue")
  private String registryKeyValue = null;

  @JsonProperty("registryIncludeSubKeys")
  private Boolean registryIncludeSubKeys = null;

  @JsonProperty("registryIncludedValues")
  private List<String> registryIncludedValues = null;

  @JsonProperty("registryIncludeDefaultValue")
  private Boolean registryIncludeDefaultValue = null;

  @JsonProperty("registryExcludedValues")
  private List<String> registryExcludedValues = null;

  @JsonProperty("registryAttributes")
  private List<String> registryAttributes = null;

  @JsonProperty("fileBaseDirectory")
  private String fileBaseDirectory = null;

  @JsonProperty("fileIncludeSubDirectories")
  private Boolean fileIncludeSubDirectories = null;

  @JsonProperty("fileIncludedValues")
  private List<String> fileIncludedValues = null;

  @JsonProperty("fileExcludedValues")
  private List<String> fileExcludedValues = null;

  @JsonProperty("fileAttributes")
  private List<String> fileAttributes = null;

  @JsonProperty("customXML")
  private String customXML = null;

  @JsonProperty("alertEnabled")
  private Boolean alertEnabled = null;

  @JsonProperty("realTimeMonitoringEnabled")
  private Boolean realTimeMonitoringEnabled = null;

  /**
   * Indicates whether recommendation scans consider the IntegrityMonitoringRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.
   */
  public enum RecommendationsModeEnum {
    ENABLED("enabled"),
    
    IGNORED("ignored"),
    
    UNKNOWN("unknown"),
    
    DISABLED("disabled");

    private String value;

    RecommendationsModeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RecommendationsModeEnum fromValue(String text) {
      for (RecommendationsModeEnum b : RecommendationsModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("recommendationsMode")
  private RecommendationsModeEnum recommendationsMode = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public IntegrityMonitoringRule name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the IntegrityMonitoringRule. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the IntegrityMonitoringRule. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public IntegrityMonitoringRule description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the IntegrityMonitoringRule. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the IntegrityMonitoringRule. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Minimum Deep Security Agent version that supports the IntegrityMonitoringRule. This value is provided in the X.X.X.X format. Defaults to &#x60;6.0.0.0&#x60;. If an agent is not the minimum required version, the manager does not send the rule to the agent, and generates an alert. Searchable as String.
   * @return minimumAgentVersion
  **/
  @ApiModelProperty(value = "Minimum Deep Security Agent version that supports the IntegrityMonitoringRule. This value is provided in the X.X.X.X format. Defaults to `6.0.0.0`. If an agent is not the minimum required version, the manager does not send the rule to the agent, and generates an alert. Searchable as String.")
  public String getMinimumAgentVersion() {
    return minimumAgentVersion;
  }

   /**
   * Minimum Deep Security Manager version that supports the IntegrityMonitoringRule. This value is provided in the X.X.X format. Defaults to &#x60;6.0.0&#x60;. An alert will be raised if a manager that fails to meet the minimum manager version value tries to assign this rule to a host or profile. Searchable as String.
   * @return minimumManagerVersion
  **/
  @ApiModelProperty(value = "Minimum Deep Security Manager version that supports the IntegrityMonitoringRule. This value is provided in the X.X.X format. Defaults to `6.0.0`. An alert will be raised if a manager that fails to meet the minimum manager version value tries to assign this rule to a host or profile. Searchable as String.")
  public String getMinimumManagerVersion() {
    return minimumManagerVersion;
  }

  public IntegrityMonitoringRule severity(SeverityEnum severity) {
    this.severity = severity;
    return this;
  }

   /**
   * Severity level of the event is multiplied by the computer&#39;s asset value to determine ranking. Ranking can be used to sort events with more business impact. Searchable as Choice.
   * @return severity
  **/
  @ApiModelProperty(value = "Severity level of the event is multiplied by the computer's asset value to determine ranking. Ranking can be used to sort events with more business impact. Searchable as Choice.")
  public SeverityEnum getSeverity() {
    return severity;
  }

  public void setSeverity(SeverityEnum severity) {
    this.severity = severity;
  }

   /**
   * Type of the IntegrityMonitoringRule. If the rule is predefined by Trend Micro, it is set to &#x60;2&#x60;. If it is user created, it is set to &#x60;1&#x60;. Searchable as String.
   * @return type
  **/
  @ApiModelProperty(value = "Type of the IntegrityMonitoringRule. If the rule is predefined by Trend Micro, it is set to `2`. If it is user created, it is set to `1`. Searchable as String.")
  public String getType() {
    return type;
  }

   /**
   * Timestamp when the IntegrityMonitoringRule was originally issued by Trend Micro, in milliseconds since epoch.  Empty if the IntegrityMonitoringRule is user created. Searchable as Date.
   * @return originalIssue
  **/
  @ApiModelProperty(value = "Timestamp when the IntegrityMonitoringRule was originally issued by Trend Micro, in milliseconds since epoch.  Empty if the IntegrityMonitoringRule is user created. Searchable as Date.")
  public Long getOriginalIssue() {
    return originalIssue;
  }

   /**
   * Timestamp when the IntegrityMonitoringRule was last updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp when the IntegrityMonitoringRule was last updated, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

   /**
   * Identifier of the IntegrityMonitoringRule from Trend Micro. Empty if the IntegrityMonitoringRule is user created. Searchable as String.
   * @return identifier
  **/
  @ApiModelProperty(value = "Identifier of the IntegrityMonitoringRule from Trend Micro. Empty if the IntegrityMonitoringRule is user created. Searchable as String.")
  public String getIdentifier() {
    return identifier;
  }

  public IntegrityMonitoringRule template(TemplateEnum template) {
    this.template = template;
    return this;
  }

   /**
   * Template which the IntegrityMonitoringRule follows.
   * @return template
  **/
  @ApiModelProperty(value = "Template which the IntegrityMonitoringRule follows.")
  public TemplateEnum getTemplate() {
    return template;
  }

  public void setTemplate(TemplateEnum template) {
    this.template = template;
  }

  public IntegrityMonitoringRule registryKeyRoot(String registryKeyRoot) {
    this.registryKeyRoot = registryKeyRoot;
    return this;
  }

   /**
   * Registry hive which is monitored by the IntegrityMonitoringRule. Empty if the IntegrityMonitoringRule does not monitor a registry key.
   * @return registryKeyRoot
  **/
  @ApiModelProperty(value = "Registry hive which is monitored by the IntegrityMonitoringRule. Empty if the IntegrityMonitoringRule does not monitor a registry key.")
  public String getRegistryKeyRoot() {
    return registryKeyRoot;
  }

  public void setRegistryKeyRoot(String registryKeyRoot) {
    this.registryKeyRoot = registryKeyRoot;
  }

  public IntegrityMonitoringRule registryKeyValue(String registryKeyValue) {
    this.registryKeyValue = registryKeyValue;
    return this;
  }

   /**
   * Registry key which is monitored by the IntegrityMonitoringRule. Empty if the IntegrityMonitoringRule does not monitor a registry key. Ignored if the IntegrityMonitoringRule does not monitor a registry key.
   * @return registryKeyValue
  **/
  @ApiModelProperty(value = "Registry key which is monitored by the IntegrityMonitoringRule. Empty if the IntegrityMonitoringRule does not monitor a registry key. Ignored if the IntegrityMonitoringRule does not monitor a registry key.")
  public String getRegistryKeyValue() {
    return registryKeyValue;
  }

  public void setRegistryKeyValue(String registryKeyValue) {
    this.registryKeyValue = registryKeyValue;
  }

  public IntegrityMonitoringRule registryIncludeSubKeys(Boolean registryIncludeSubKeys) {
    this.registryIncludeSubKeys = registryIncludeSubKeys;
    return this;
  }

   /**
   * Controls whether the IntegrityMonitoringRule should also include subkeys of the registry key it monitors. Defaults to &#x60;false&#x60;. Ignored if the IntegrityMonitoringRule does not monitor a registry key.
   * @return registryIncludeSubKeys
  **/
  @ApiModelProperty(value = "Controls whether the IntegrityMonitoringRule should also include subkeys of the registry key it monitors. Defaults to `false`. Ignored if the IntegrityMonitoringRule does not monitor a registry key.")
  public Boolean isRegistryIncludeSubKeys() {
    return registryIncludeSubKeys;
  }

  public void setRegistryIncludeSubKeys(Boolean registryIncludeSubKeys) {
    this.registryIncludeSubKeys = registryIncludeSubKeys;
  }

  public IntegrityMonitoringRule registryIncludedValues(List<String> registryIncludedValues) {
    this.registryIncludedValues = registryIncludedValues;
    return this;
  }

  public IntegrityMonitoringRule addRegistryIncludedValuesItem(String registryIncludedValuesItem) {
    if (this.registryIncludedValues == null) {
      this.registryIncludedValues = new ArrayList<>();
    }
    this.registryIncludedValues.add(registryIncludedValuesItem);
    return this;
  }

   /**
   * Registry key values to be monitored by the IntegrityMonitoringRule. JSON array or delimited by &#x60;\\n&#x60;. &#x60;?&#x60; matches a single character, while &#x60;*&#x60; matches zero or more characters. Ignored if the IntegrityMonitoringRule does not monitor a registry key.
   * @return registryIncludedValues
  **/
  @ApiModelProperty(value = "Registry key values to be monitored by the IntegrityMonitoringRule. JSON array or delimited by `\\n`. `?` matches a single character, while `*` matches zero or more characters. Ignored if the IntegrityMonitoringRule does not monitor a registry key.")
  public List<String> getRegistryIncludedValues() {
    return registryIncludedValues;
  }

  public void setRegistryIncludedValues(List<String> registryIncludedValues) {
    this.registryIncludedValues = registryIncludedValues;
  }

  public IntegrityMonitoringRule registryIncludeDefaultValue(Boolean registryIncludeDefaultValue) {
    this.registryIncludeDefaultValue = registryIncludeDefaultValue;
    return this;
  }

   /**
   * Controls whether the rule should monitor default registry key values. Defaults to &#x60;true&#x60;. Ignored if the IntegrityMonitoringRule does not monitor a registry key.
   * @return registryIncludeDefaultValue
  **/
  @ApiModelProperty(value = "Controls whether the rule should monitor default registry key values. Defaults to `true`. Ignored if the IntegrityMonitoringRule does not monitor a registry key.")
  public Boolean isRegistryIncludeDefaultValue() {
    return registryIncludeDefaultValue;
  }

  public void setRegistryIncludeDefaultValue(Boolean registryIncludeDefaultValue) {
    this.registryIncludeDefaultValue = registryIncludeDefaultValue;
  }

  public IntegrityMonitoringRule registryExcludedValues(List<String> registryExcludedValues) {
    this.registryExcludedValues = registryExcludedValues;
    return this;
  }

  public IntegrityMonitoringRule addRegistryExcludedValuesItem(String registryExcludedValuesItem) {
    if (this.registryExcludedValues == null) {
      this.registryExcludedValues = new ArrayList<>();
    }
    this.registryExcludedValues.add(registryExcludedValuesItem);
    return this;
  }

   /**
   * Registry key values to be ignored by the IntegrityMonitoringRule. JSON array or delimited by &#x60;\\n&#x60;. &#x60;?&#x60; matches a single character, while &#x60;*&#x60; matches zero or more characters. Ignored if the IntegrityMonitoringRule does not monitor a registry key.
   * @return registryExcludedValues
  **/
  @ApiModelProperty(value = "Registry key values to be ignored by the IntegrityMonitoringRule. JSON array or delimited by `\\n`. `?` matches a single character, while `*` matches zero or more characters. Ignored if the IntegrityMonitoringRule does not monitor a registry key.")
  public List<String> getRegistryExcludedValues() {
    return registryExcludedValues;
  }

  public void setRegistryExcludedValues(List<String> registryExcludedValues) {
    this.registryExcludedValues = registryExcludedValues;
  }

  public IntegrityMonitoringRule registryAttributes(List<String> registryAttributes) {
    this.registryAttributes = registryAttributes;
    return this;
  }

  public IntegrityMonitoringRule addRegistryAttributesItem(String registryAttributesItem) {
    if (this.registryAttributes == null) {
      this.registryAttributes = new ArrayList<>();
    }
    this.registryAttributes.add(registryAttributesItem);
    return this;
  }

   /**
   * Registry key attributes to be monitored by the IntegrityMonitoringRule. JSON array or delimited by &#x60;\\n&#x60;. Defaults to &#x60;STANDARD&#x60; which will monitor changes in registry size, content and type. Ignored if the IntegrityMonitoringRule does not monitor a registry key.
   * @return registryAttributes
  **/
  @ApiModelProperty(value = "Registry key attributes to be monitored by the IntegrityMonitoringRule. JSON array or delimited by `\\n`. Defaults to `STANDARD` which will monitor changes in registry size, content and type. Ignored if the IntegrityMonitoringRule does not monitor a registry key.")
  public List<String> getRegistryAttributes() {
    return registryAttributes;
  }

  public void setRegistryAttributes(List<String> registryAttributes) {
    this.registryAttributes = registryAttributes;
  }

  public IntegrityMonitoringRule fileBaseDirectory(String fileBaseDirectory) {
    this.fileBaseDirectory = fileBaseDirectory;
    return this;
  }

   /**
   * Base of the file directory to be monitored by the IntegrityMonitoringRule. Ignored if the IntegrityMonitoringRule does not monitor a file directory.
   * @return fileBaseDirectory
  **/
  @ApiModelProperty(value = "Base of the file directory to be monitored by the IntegrityMonitoringRule. Ignored if the IntegrityMonitoringRule does not monitor a file directory.")
  public String getFileBaseDirectory() {
    return fileBaseDirectory;
  }

  public void setFileBaseDirectory(String fileBaseDirectory) {
    this.fileBaseDirectory = fileBaseDirectory;
  }

  public IntegrityMonitoringRule fileIncludeSubDirectories(Boolean fileIncludeSubDirectories) {
    this.fileIncludeSubDirectories = fileIncludeSubDirectories;
    return this;
  }

   /**
   * Controls whether the IntegrityMonitoringRule should also monitor sub-directories of the base file directory that is associated with it. Defaults to &#x60;false&#x60;. Ignored if the IntegrityMonitoringRule does not monitor a file directory.
   * @return fileIncludeSubDirectories
  **/
  @ApiModelProperty(value = "Controls whether the IntegrityMonitoringRule should also monitor sub-directories of the base file directory that is associated with it. Defaults to `false`. Ignored if the IntegrityMonitoringRule does not monitor a file directory.")
  public Boolean isFileIncludeSubDirectories() {
    return fileIncludeSubDirectories;
  }

  public void setFileIncludeSubDirectories(Boolean fileIncludeSubDirectories) {
    this.fileIncludeSubDirectories = fileIncludeSubDirectories;
  }

  public IntegrityMonitoringRule fileIncludedValues(List<String> fileIncludedValues) {
    this.fileIncludedValues = fileIncludedValues;
    return this;
  }

  public IntegrityMonitoringRule addFileIncludedValuesItem(String fileIncludedValuesItem) {
    if (this.fileIncludedValues == null) {
      this.fileIncludedValues = new ArrayList<>();
    }
    this.fileIncludedValues.add(fileIncludedValuesItem);
    return this;
  }

   /**
   * File name values to be monitored by the IntegrityMonitoringRule. JSON array or delimited by &#x60;\\n&#x60;. &#x60;?&#x60; matches a single character, while &#x60;*&#x60; matches zero or more characters. Leaving this field blank when monitoring file directories will cause the IntegrityMonitoringRule to monitor all files in a directory. This can use significant system resources if the base directory contains numerous or large files. Ignored if the IntegrityMonitoringRule does not monitor a file directory.
   * @return fileIncludedValues
  **/
  @ApiModelProperty(value = "File name values to be monitored by the IntegrityMonitoringRule. JSON array or delimited by `\\n`. `?` matches a single character, while `*` matches zero or more characters. Leaving this field blank when monitoring file directories will cause the IntegrityMonitoringRule to monitor all files in a directory. This can use significant system resources if the base directory contains numerous or large files. Ignored if the IntegrityMonitoringRule does not monitor a file directory.")
  public List<String> getFileIncludedValues() {
    return fileIncludedValues;
  }

  public void setFileIncludedValues(List<String> fileIncludedValues) {
    this.fileIncludedValues = fileIncludedValues;
  }

  public IntegrityMonitoringRule fileExcludedValues(List<String> fileExcludedValues) {
    this.fileExcludedValues = fileExcludedValues;
    return this;
  }

  public IntegrityMonitoringRule addFileExcludedValuesItem(String fileExcludedValuesItem) {
    if (this.fileExcludedValues == null) {
      this.fileExcludedValues = new ArrayList<>();
    }
    this.fileExcludedValues.add(fileExcludedValuesItem);
    return this;
  }

   /**
   * File name values to be ignored by the IntegrityMonitoringRule. JSON array or delimited by &#x60;\\n&#x60;. &#x60;?&#x60; matches a single character, while &#x60;*&#x60; matches zero or more characters. Ignored if the IntegrityMonitoringRule does not monitor a file directory.
   * @return fileExcludedValues
  **/
  @ApiModelProperty(value = "File name values to be ignored by the IntegrityMonitoringRule. JSON array or delimited by `\\n`. `?` matches a single character, while `*` matches zero or more characters. Ignored if the IntegrityMonitoringRule does not monitor a file directory.")
  public List<String> getFileExcludedValues() {
    return fileExcludedValues;
  }

  public void setFileExcludedValues(List<String> fileExcludedValues) {
    this.fileExcludedValues = fileExcludedValues;
  }

  public IntegrityMonitoringRule fileAttributes(List<String> fileAttributes) {
    this.fileAttributes = fileAttributes;
    return this;
  }

  public IntegrityMonitoringRule addFileAttributesItem(String fileAttributesItem) {
    if (this.fileAttributes == null) {
      this.fileAttributes = new ArrayList<>();
    }
    this.fileAttributes.add(fileAttributesItem);
    return this;
  }

   /**
   * File attributes to be monitored by the IntegrityMonitoringRule. JSON array or delimited by &#x60;\\n&#x60;. Defaults to &#x60;STANDARD&#x60; which will monitor changes in file creation date, last modified date, permissions, owner, group, size, content, flags (Windows) and SymLinkPath (Linux). Ignored if the IntegrityMonitoringRule does not monitor a file directory.
   * @return fileAttributes
  **/
  @ApiModelProperty(value = "File attributes to be monitored by the IntegrityMonitoringRule. JSON array or delimited by `\\n`. Defaults to `STANDARD` which will monitor changes in file creation date, last modified date, permissions, owner, group, size, content, flags (Windows) and SymLinkPath (Linux). Ignored if the IntegrityMonitoringRule does not monitor a file directory.")
  public List<String> getFileAttributes() {
    return fileAttributes;
  }

  public void setFileAttributes(List<String> fileAttributes) {
    this.fileAttributes = fileAttributes;
  }

  public IntegrityMonitoringRule customXML(String customXML) {
    this.customXML = customXML;
    return this;
  }

   /**
   * Custom XML rules to be used by the IntegrityMonitoringRule. Custom XML rules must be encoded in the Base64 format. Ignored if the IntegrityMonitoringRule does not follow the &#x60;custom&#x60; template.
   * @return customXML
  **/
  @ApiModelProperty(value = "Custom XML rules to be used by the IntegrityMonitoringRule. Custom XML rules must be encoded in the Base64 format. Ignored if the IntegrityMonitoringRule does not follow the `custom` template.")
  public String getCustomXML() {
    return customXML;
  }

  public void setCustomXML(String customXML) {
    this.customXML = customXML;
  }

  public IntegrityMonitoringRule alertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
    return this;
  }

   /**
   * Controls whether an alert should be made if an event related to the IntegrityMonitoringRule is logged. Defaults to &#x60;false&#x60;. Searchable as Boolean.
   * @return alertEnabled
  **/
  @ApiModelProperty(value = "Controls whether an alert should be made if an event related to the IntegrityMonitoringRule is logged. Defaults to `false`. Searchable as Boolean.")
  public Boolean isAlertEnabled() {
    return alertEnabled;
  }

  public void setAlertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
  }

  public IntegrityMonitoringRule realTimeMonitoringEnabled(Boolean realTimeMonitoringEnabled) {
    this.realTimeMonitoringEnabled = realTimeMonitoringEnabled;
    return this;
  }

   /**
   * Controls whether the IntegrityMonitoringRule is monitored in real time or during every scan. Defaults to &#x60;true&#x60; which indicates that it is monitored in real time. A value of &#x60;false&#x60; indicates that it will only be checked during scans. Searchable as Boolean.
   * @return realTimeMonitoringEnabled
  **/
  @ApiModelProperty(value = "Controls whether the IntegrityMonitoringRule is monitored in real time or during every scan. Defaults to `true` which indicates that it is monitored in real time. A value of `false` indicates that it will only be checked during scans. Searchable as Boolean.")
  public Boolean isRealTimeMonitoringEnabled() {
    return realTimeMonitoringEnabled;
  }

  public void setRealTimeMonitoringEnabled(Boolean realTimeMonitoringEnabled) {
    this.realTimeMonitoringEnabled = realTimeMonitoringEnabled;
  }

  public IntegrityMonitoringRule recommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
    return this;
  }

   /**
   * Indicates whether recommendation scans consider the IntegrityMonitoringRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.
   * @return recommendationsMode
  **/
  @ApiModelProperty(value = "Indicates whether recommendation scans consider the IntegrityMonitoringRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.")
  public RecommendationsModeEnum getRecommendationsMode() {
    return recommendationsMode;
  }

  public void setRecommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
  }

   /**
   * ID of the IntegrityMonitoringRule. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the IntegrityMonitoringRule. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    IntegrityMonitoringRule integrityMonitoringRule = (IntegrityMonitoringRule) o;
    return Objects.equals(this.name, integrityMonitoringRule.name) &&
        Objects.equals(this.description, integrityMonitoringRule.description) &&
        Objects.equals(this.minimumAgentVersion, integrityMonitoringRule.minimumAgentVersion) &&
        Objects.equals(this.minimumManagerVersion, integrityMonitoringRule.minimumManagerVersion) &&
        Objects.equals(this.severity, integrityMonitoringRule.severity) &&
        Objects.equals(this.type, integrityMonitoringRule.type) &&
        Objects.equals(this.originalIssue, integrityMonitoringRule.originalIssue) &&
        Objects.equals(this.lastUpdated, integrityMonitoringRule.lastUpdated) &&
        Objects.equals(this.identifier, integrityMonitoringRule.identifier) &&
        Objects.equals(this.template, integrityMonitoringRule.template) &&
        Objects.equals(this.registryKeyRoot, integrityMonitoringRule.registryKeyRoot) &&
        Objects.equals(this.registryKeyValue, integrityMonitoringRule.registryKeyValue) &&
        Objects.equals(this.registryIncludeSubKeys, integrityMonitoringRule.registryIncludeSubKeys) &&
        Objects.equals(this.registryIncludedValues, integrityMonitoringRule.registryIncludedValues) &&
        Objects.equals(this.registryIncludeDefaultValue, integrityMonitoringRule.registryIncludeDefaultValue) &&
        Objects.equals(this.registryExcludedValues, integrityMonitoringRule.registryExcludedValues) &&
        Objects.equals(this.registryAttributes, integrityMonitoringRule.registryAttributes) &&
        Objects.equals(this.fileBaseDirectory, integrityMonitoringRule.fileBaseDirectory) &&
        Objects.equals(this.fileIncludeSubDirectories, integrityMonitoringRule.fileIncludeSubDirectories) &&
        Objects.equals(this.fileIncludedValues, integrityMonitoringRule.fileIncludedValues) &&
        Objects.equals(this.fileExcludedValues, integrityMonitoringRule.fileExcludedValues) &&
        Objects.equals(this.fileAttributes, integrityMonitoringRule.fileAttributes) &&
        Objects.equals(this.customXML, integrityMonitoringRule.customXML) &&
        Objects.equals(this.alertEnabled, integrityMonitoringRule.alertEnabled) &&
        Objects.equals(this.realTimeMonitoringEnabled, integrityMonitoringRule.realTimeMonitoringEnabled) &&
        Objects.equals(this.recommendationsMode, integrityMonitoringRule.recommendationsMode) &&
        Objects.equals(this.ID, integrityMonitoringRule.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, minimumAgentVersion, minimumManagerVersion, severity, type, originalIssue, lastUpdated, identifier, template, registryKeyRoot, registryKeyValue, registryIncludeSubKeys, registryIncludedValues, registryIncludeDefaultValue, registryExcludedValues, registryAttributes, fileBaseDirectory, fileIncludeSubDirectories, fileIncludedValues, fileExcludedValues, fileAttributes, customXML, alertEnabled, realTimeMonitoringEnabled, recommendationsMode, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class IntegrityMonitoringRule {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    minimumAgentVersion: ").append(toIndentedString(minimumAgentVersion)).append("\n");
    sb.append("    minimumManagerVersion: ").append(toIndentedString(minimumManagerVersion)).append("\n");
    sb.append("    severity: ").append(toIndentedString(severity)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    originalIssue: ").append(toIndentedString(originalIssue)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    identifier: ").append(toIndentedString(identifier)).append("\n");
    sb.append("    template: ").append(toIndentedString(template)).append("\n");
    sb.append("    registryKeyRoot: ").append(toIndentedString(registryKeyRoot)).append("\n");
    sb.append("    registryKeyValue: ").append(toIndentedString(registryKeyValue)).append("\n");
    sb.append("    registryIncludeSubKeys: ").append(toIndentedString(registryIncludeSubKeys)).append("\n");
    sb.append("    registryIncludedValues: ").append(toIndentedString(registryIncludedValues)).append("\n");
    sb.append("    registryIncludeDefaultValue: ").append(toIndentedString(registryIncludeDefaultValue)).append("\n");
    sb.append("    registryExcludedValues: ").append(toIndentedString(registryExcludedValues)).append("\n");
    sb.append("    registryAttributes: ").append(toIndentedString(registryAttributes)).append("\n");
    sb.append("    fileBaseDirectory: ").append(toIndentedString(fileBaseDirectory)).append("\n");
    sb.append("    fileIncludeSubDirectories: ").append(toIndentedString(fileIncludeSubDirectories)).append("\n");
    sb.append("    fileIncludedValues: ").append(toIndentedString(fileIncludedValues)).append("\n");
    sb.append("    fileExcludedValues: ").append(toIndentedString(fileExcludedValues)).append("\n");
    sb.append("    fileAttributes: ").append(toIndentedString(fileAttributes)).append("\n");
    sb.append("    customXML: ").append(toIndentedString(customXML)).append("\n");
    sb.append("    alertEnabled: ").append(toIndentedString(alertEnabled)).append("\n");
    sb.append("    realTimeMonitoringEnabled: ").append(toIndentedString(realTimeMonitoringEnabled)).append("\n");
    sb.append("    recommendationsMode: ").append(toIndentedString(recommendationsMode)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

