/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Use InterfaceTypes to apply Deep Security policies to specific network interfaces of managed computers.
 */
@ApiModel(description = "Use InterfaceTypes to apply Deep Security policies to specific network interfaces of managed computers.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class InterfaceType {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("matches")
  private List<String> matches = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public InterfaceType name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the InterfaceType. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the InterfaceType. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public InterfaceType description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the InterfaceType. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the InterfaceType. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public InterfaceType matches(List<String> matches) {
    this.matches = matches;
    return this;
  }

  public InterfaceType addMatchesItem(String matchesItem) {
    if (this.matches == null) {
      this.matches = new ArrayList<>();
    }
    this.matches.add(matchesItem);
    return this;
  }

   /**
   * String patterns to match with Interface names and display names. One pattern per line. The &#x60;*&#x60; character can be used for wildcard matches. Searchable as String.
   * @return matches
  **/
  @ApiModelProperty(value = "String patterns to match with Interface names and display names. One pattern per line. The `*` character can be used for wildcard matches. Searchable as String.")
  public List<String> getMatches() {
    return matches;
  }

  public void setMatches(List<String> matches) {
    this.matches = matches;
  }

   /**
   * ID of the InterfaceType. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the InterfaceType. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InterfaceType interfaceType = (InterfaceType) o;
    return Objects.equals(this.name, interfaceType.name) &&
        Objects.equals(this.description, interfaceType.description) &&
        Objects.equals(this.matches, interfaceType.matches) &&
        Objects.equals(this.ID, interfaceType.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, matches, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InterfaceType {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    matches: ").append(toIndentedString(matches)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

