/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.LogFiles;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Contains string matching and threshold to trigger alerts as well as group information for LogInspectionRules.
 */
@ApiModel(description = "Contains string matching and threshold to trigger alerts as well as group information for LogInspectionRules.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class LogInspectionRule {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("minimumAgentVersion")
  private String minimumAgentVersion = null;

  @JsonProperty("minimumManagerVersion")
  private String minimumManagerVersion = null;

  @JsonProperty("type")
  private String type = null;

  @JsonProperty("originalIssue")
  private Long originalIssue = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("identifier")
  private String identifier = null;

  /**
   * Template used to create this rule.
   */
  public enum TemplateEnum {
    BASIC_RULE("basic-rule"),
    
    CUSTOM("custom");

    private String value;

    TemplateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TemplateEnum fromValue(String text) {
      for (TemplateEnum b : TemplateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("template")
  private TemplateEnum template = null;

  @JsonProperty("ruleID")
  private Integer ruleID = null;

  @JsonProperty("level")
  private Integer level = null;

  @JsonProperty("groups")
  private List<String> groups = null;

  @JsonProperty("ruleDescription")
  private String ruleDescription = null;

  @JsonProperty("pattern")
  private String pattern = null;

  /**
   * Pattern the LogInspectionRule will look for in the logs. The string matching pattern is faster than the regex pattern.
   */
  public enum PatternTypeEnum {
    STRING("string"),
    
    REGEX("regex");

    private String value;

    PatternTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static PatternTypeEnum fromValue(String text) {
      for (PatternTypeEnum b : PatternTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("patternType")
  private PatternTypeEnum patternType = null;

  /**
   * Indicates if a dependant rule or dependency group is set or not. If set, the LogInspectionRule will only log an event if the dependency is triggered. Available for user-defined rules.
   */
  public enum DependencyEnum {
    NONE("none"),
    
    RULE("rule"),
    
    GROUP("group");

    private String value;

    DependencyEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DependencyEnum fromValue(String text) {
      for (DependencyEnum b : DependencyEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("dependency")
  private DependencyEnum dependency = null;

  @JsonProperty("dependencyRuleID")
  private Integer dependencyRuleID = null;

  @JsonProperty("dependencyGroup")
  private String dependencyGroup = null;

  @JsonProperty("frequency")
  private Integer frequency = null;

  @JsonProperty("timeFrame")
  private Integer timeFrame = null;

  @JsonProperty("ruleXML")
  private String ruleXML = null;

  @JsonProperty("logFiles")
  private LogFiles logFiles = null;

  @JsonProperty("alertEnabled")
  private Boolean alertEnabled = null;

  @JsonProperty("alertMinimumSeverity")
  private Integer alertMinimumSeverity = null;

  /**
   * Indicates whether recommendation scans consider the LogInspectionRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.
   */
  public enum RecommendationsModeEnum {
    ENABLED("enabled"),
    
    IGNORED("ignored"),
    
    UNKNOWN("unknown"),
    
    DISABLED("disabled");

    private String value;

    RecommendationsModeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RecommendationsModeEnum fromValue(String text) {
      for (RecommendationsModeEnum b : RecommendationsModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("recommendationsMode")
  private RecommendationsModeEnum recommendationsMode = null;

  @JsonProperty("sortOrder")
  private Integer sortOrder = null;

  @JsonProperty("canBeAssignedAlone")
  private Boolean canBeAssignedAlone = null;

  @JsonProperty("dependsOnRuleIDs")
  private List<Integer> dependsOnRuleIDs = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public LogInspectionRule name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the LogInspectionRule. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the LogInspectionRule. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public LogInspectionRule description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the LogInspectionRule that appears in search results, and on the General tab in the Deep Security Manager user interface. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the LogInspectionRule that appears in search results, and on the General tab in the Deep Security Manager user interface. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public LogInspectionRule minimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
    return this;
  }

   /**
   * Minimum Deep Security Agent version required by the LogInspectionRule. Searchable as String.
   * @return minimumAgentVersion
  **/
  @ApiModelProperty(value = "Minimum Deep Security Agent version required by the LogInspectionRule. Searchable as String.")
  public String getMinimumAgentVersion() {
    return minimumAgentVersion;
  }

  public void setMinimumAgentVersion(String minimumAgentVersion) {
    this.minimumAgentVersion = minimumAgentVersion;
  }

  public LogInspectionRule minimumManagerVersion(String minimumManagerVersion) {
    this.minimumManagerVersion = minimumManagerVersion;
    return this;
  }

   /**
   * Minimumn Deep Security Manager version required by the LogInspectionRule. Searchable as String.
   * @return minimumManagerVersion
  **/
  @ApiModelProperty(value = "Minimumn Deep Security Manager version required by the LogInspectionRule. Searchable as String.")
  public String getMinimumManagerVersion() {
    return minimumManagerVersion;
  }

  public void setMinimumManagerVersion(String minimumManagerVersion) {
    this.minimumManagerVersion = minimumManagerVersion;
  }

  public LogInspectionRule type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Type of the LogInspectionRule. The value &#39;Defined&#39; is used for LogInspectionRules provided by Trend Micro. Searchable as String.
   * @return type
  **/
  @ApiModelProperty(value = "Type of the LogInspectionRule. The value 'Defined' is used for LogInspectionRules provided by Trend Micro. Searchable as String.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public LogInspectionRule originalIssue(Long originalIssue) {
    this.originalIssue = originalIssue;
    return this;
  }

   /**
   * Creation timestamp of the LogInspectionRule, measured in milliseconds since epoch. Searchable as Date.
   * @return originalIssue
  **/
  @ApiModelProperty(value = "Creation timestamp of the LogInspectionRule, measured in milliseconds since epoch. Searchable as Date.")
  public Long getOriginalIssue() {
    return originalIssue;
  }

  public void setOriginalIssue(Long originalIssue) {
    this.originalIssue = originalIssue;
  }

  public LogInspectionRule lastUpdated(Long lastUpdated) {
    this.lastUpdated = lastUpdated;
    return this;
  }

   /**
   * Update timestamp of the LogInspectionRule, measured in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Update timestamp of the LogInspectionRule, measured in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

  public void setLastUpdated(Long lastUpdated) {
    this.lastUpdated = lastUpdated;
  }

  public LogInspectionRule identifier(String identifier) {
    this.identifier = identifier;
    return this;
  }

   /**
   * Indentifier of the LogInspectionRule used in the Deep Security Manager user interface. Searchable as String.
   * @return identifier
  **/
  @ApiModelProperty(value = "Indentifier of the LogInspectionRule used in the Deep Security Manager user interface. Searchable as String.")
  public String getIdentifier() {
    return identifier;
  }

  public void setIdentifier(String identifier) {
    this.identifier = identifier;
  }

  public LogInspectionRule template(TemplateEnum template) {
    this.template = template;
    return this;
  }

   /**
   * Template used to create this rule.
   * @return template
  **/
  @ApiModelProperty(value = "Template used to create this rule.")
  public TemplateEnum getTemplate() {
    return template;
  }

  public void setTemplate(TemplateEnum template) {
    this.template = template;
  }

  public LogInspectionRule ruleID(Integer ruleID) {
    this.ruleID = ruleID;
    return this;
  }

   /**
   * ID of the LogInspectionRule sent to the Deep Security Agent. The values 100000 - 109999 are reserved for user-definded rules.
   * @return ruleID
  **/
  @ApiModelProperty(value = "ID of the LogInspectionRule sent to the Deep Security Agent. The values 100000 - 109999 are reserved for user-definded rules.")
  public Integer getRuleID() {
    return ruleID;
  }

  public void setRuleID(Integer ruleID) {
    this.ruleID = ruleID;
  }

  public LogInspectionRule level(Integer level) {
    this.level = level;
    return this;
  }

   /**
   * Log level of the LogInspectionRule indicates severity of attack. Level 0 is the least severe and will not log an event. Level 15 is the most severe.
   * @return level
  **/
  @ApiModelProperty(value = "Log level of the LogInspectionRule indicates severity of attack. Level 0 is the least severe and will not log an event. Level 15 is the most severe.")
  public Integer getLevel() {
    return level;
  }

  public void setLevel(Integer level) {
    this.level = level;
  }

  public LogInspectionRule groups(List<String> groups) {
    this.groups = groups;
    return this;
  }

  public LogInspectionRule addGroupsItem(String groupsItem) {
    if (this.groups == null) {
      this.groups = new ArrayList<>();
    }
    this.groups.add(groupsItem);
    return this;
  }

   /**
   * Groups that the LogInspectionRule is assigned to, separated by commas. Useful when dependency is used as it&#39;s possible to create a LogInspectionRule that fires when another LogInspectionRule belonging to a specific group fires.
   * @return groups
  **/
  @ApiModelProperty(value = "Groups that the LogInspectionRule is assigned to, separated by commas. Useful when dependency is used as it's possible to create a LogInspectionRule that fires when another LogInspectionRule belonging to a specific group fires.")
  public List<String> getGroups() {
    return groups;
  }

  public void setGroups(List<String> groups) {
    this.groups = groups;
  }

  public LogInspectionRule ruleDescription(String ruleDescription) {
    this.ruleDescription = ruleDescription;
    return this;
  }

   /**
   * Description of the LogInspectionRule that appears on events and the Content tab in the Deep Security Manager user interface. Alternatively, you can configure this by inserting a description in &#39;ruleXML&#39;.
   * @return ruleDescription
  **/
  @ApiModelProperty(value = "Description of the LogInspectionRule that appears on events and the Content tab in the Deep Security Manager user interface. Alternatively, you can configure this by inserting a description in 'ruleXML'.")
  public String getRuleDescription() {
    return ruleDescription;
  }

  public void setRuleDescription(String ruleDescription) {
    this.ruleDescription = ruleDescription;
  }

  public LogInspectionRule pattern(String pattern) {
    this.pattern = pattern;
    return this;
  }

   /**
   * Regular expression pattern the LogInspectionRule will look for in the logs. The rule will be triggered on a match. Open Source HIDS SEcurity (OSSEC) regular expression syntax is supported, see http://www.ossec.net/docs/syntax/regex.html.
   * @return pattern
  **/
  @ApiModelProperty(value = "Regular expression pattern the LogInspectionRule will look for in the logs. The rule will be triggered on a match. Open Source HIDS SEcurity (OSSEC) regular expression syntax is supported, see http://www.ossec.net/docs/syntax/regex.html.")
  public String getPattern() {
    return pattern;
  }

  public void setPattern(String pattern) {
    this.pattern = pattern;
  }

  public LogInspectionRule patternType(PatternTypeEnum patternType) {
    this.patternType = patternType;
    return this;
  }

   /**
   * Pattern the LogInspectionRule will look for in the logs. The string matching pattern is faster than the regex pattern.
   * @return patternType
  **/
  @ApiModelProperty(value = "Pattern the LogInspectionRule will look for in the logs. The string matching pattern is faster than the regex pattern.")
  public PatternTypeEnum getPatternType() {
    return patternType;
  }

  public void setPatternType(PatternTypeEnum patternType) {
    this.patternType = patternType;
  }

  public LogInspectionRule dependency(DependencyEnum dependency) {
    this.dependency = dependency;
    return this;
  }

   /**
   * Indicates if a dependant rule or dependency group is set or not. If set, the LogInspectionRule will only log an event if the dependency is triggered. Available for user-defined rules.
   * @return dependency
  **/
  @ApiModelProperty(value = "Indicates if a dependant rule or dependency group is set or not. If set, the LogInspectionRule will only log an event if the dependency is triggered. Available for user-defined rules.")
  public DependencyEnum getDependency() {
    return dependency;
  }

  public void setDependency(DependencyEnum dependency) {
    this.dependency = dependency;
  }

  public LogInspectionRule dependencyRuleID(Integer dependencyRuleID) {
    this.dependencyRuleID = dependencyRuleID;
    return this;
  }

   /**
   * If dependency is configured, the ID of the rule that this rule is dependant on. Ignored if the rule is from Trend Micro, which uses &#x60;dependsOnRuleIDs&#x60; instead.
   * @return dependencyRuleID
  **/
  @ApiModelProperty(value = "If dependency is configured, the ID of the rule that this rule is dependant on. Ignored if the rule is from Trend Micro, which uses `dependsOnRuleIDs` instead.")
  public Integer getDependencyRuleID() {
    return dependencyRuleID;
  }

  public void setDependencyRuleID(Integer dependencyRuleID) {
    this.dependencyRuleID = dependencyRuleID;
  }

  public LogInspectionRule dependencyGroup(String dependencyGroup) {
    this.dependencyGroup = dependencyGroup;
    return this;
  }

   /**
   * If dependency is configured, the dependancy groups that this rule is dependant on.
   * @return dependencyGroup
  **/
  @ApiModelProperty(value = "If dependency is configured, the dependancy groups that this rule is dependant on.")
  public String getDependencyGroup() {
    return dependencyGroup;
  }

  public void setDependencyGroup(String dependencyGroup) {
    this.dependencyGroup = dependencyGroup;
  }

  public LogInspectionRule frequency(Integer frequency) {
    this.frequency = frequency;
    return this;
  }

   /**
   * Number of times the dependant rule has to match within a specific time frame before the rule is triggered.
   * @return frequency
  **/
  @ApiModelProperty(value = "Number of times the dependant rule has to match within a specific time frame before the rule is triggered.")
  public Integer getFrequency() {
    return frequency;
  }

  public void setFrequency(Integer frequency) {
    this.frequency = frequency;
  }

  public LogInspectionRule timeFrame(Integer timeFrame) {
    this.timeFrame = timeFrame;
    return this;
  }

   /**
   * Time period for the frequency of LogInspectionRule triggers that will generate an event, in seconds.
   * @return timeFrame
  **/
  @ApiModelProperty(value = "Time period for the frequency of LogInspectionRule triggers that will generate an event, in seconds.")
  public Integer getTimeFrame() {
    return timeFrame;
  }

  public void setTimeFrame(Integer timeFrame) {
    this.timeFrame = timeFrame;
  }

  public LogInspectionRule ruleXML(String ruleXML) {
    this.ruleXML = ruleXML;
    return this;
  }

   /**
   * LogInspectionRule in an XML format. For information on the XML format, see http://ossec-docs.readthedocs.io/en/latest/syntax/head_rules.html
   * @return ruleXML
  **/
  @ApiModelProperty(value = "LogInspectionRule in an XML format. For information on the XML format, see http://ossec-docs.readthedocs.io/en/latest/syntax/head_rules.html")
  public String getRuleXML() {
    return ruleXML;
  }

  public void setRuleXML(String ruleXML) {
    this.ruleXML = ruleXML;
  }

  public LogInspectionRule logFiles(LogFiles logFiles) {
    this.logFiles = logFiles;
    return this;
  }

   /**
   * Collection of log files monitored by the LogInspectionRule.
   * @return logFiles
  **/
  @ApiModelProperty(value = "Collection of log files monitored by the LogInspectionRule.")
  public LogFiles getLogFiles() {
    return logFiles;
  }

  public void setLogFiles(LogFiles logFiles) {
    this.logFiles = logFiles;
  }

  public LogInspectionRule alertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
    return this;
  }

   /**
   * Controls whether to raise an alert when a LogInspectionRule logs an event. Use true to raise an alert. Searchable as Boolean.
   * @return alertEnabled
  **/
  @ApiModelProperty(value = "Controls whether to raise an alert when a LogInspectionRule logs an event. Use true to raise an alert. Searchable as Boolean.")
  public Boolean isAlertEnabled() {
    return alertEnabled;
  }

  public void setAlertEnabled(Boolean alertEnabled) {
    this.alertEnabled = alertEnabled;
  }

  public LogInspectionRule alertMinimumSeverity(Integer alertMinimumSeverity) {
    this.alertMinimumSeverity = alertMinimumSeverity;
    return this;
  }

   /**
   * Severity level that will trigger an alert. Ignored unless &#x60;ruleXML&#x60; contains multiple rules with different severities, and so you must indicate which severity level to use. Searchable as Numeric.
   * @return alertMinimumSeverity
  **/
  @ApiModelProperty(value = "Severity level that will trigger an alert. Ignored unless `ruleXML` contains multiple rules with different severities, and so you must indicate which severity level to use. Searchable as Numeric.")
  public Integer getAlertMinimumSeverity() {
    return alertMinimumSeverity;
  }

  public void setAlertMinimumSeverity(Integer alertMinimumSeverity) {
    this.alertMinimumSeverity = alertMinimumSeverity;
  }

  public LogInspectionRule recommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
    return this;
  }

   /**
   * Indicates whether recommendation scans consider the LogInspectionRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.
   * @return recommendationsMode
  **/
  @ApiModelProperty(value = "Indicates whether recommendation scans consider the LogInspectionRule. Can be set to enabled or ignored. Custom rules cannot be recommended. Searchable as Choice.")
  public RecommendationsModeEnum getRecommendationsMode() {
    return recommendationsMode;
  }

  public void setRecommendationsMode(RecommendationsModeEnum recommendationsMode) {
    this.recommendationsMode = recommendationsMode;
  }

  public LogInspectionRule sortOrder(Integer sortOrder) {
    this.sortOrder = sortOrder;
    return this;
  }

   /**
   * Order in which LogInspectionRules are sent to the Deep Security Agent. Log inspeciton rules are sent in ascending order. Valid values are between 10000 and 20000.
   * @return sortOrder
  **/
  @ApiModelProperty(value = "Order in which LogInspectionRules are sent to the Deep Security Agent. Log inspeciton rules are sent in ascending order. Valid values are between 10000 and 20000.")
  public Integer getSortOrder() {
    return sortOrder;
  }

  public void setSortOrder(Integer sortOrder) {
    this.sortOrder = sortOrder;
  }

   /**
   * Indicates whether this LogInspectionRule can be allocated without allocating any additional LogInspectionRules. Ignored if the rule is user-defined, which uses &#x60;dependency&#x60; instead.
   * @return canBeAssignedAlone
  **/
  @ApiModelProperty(value = "Indicates whether this LogInspectionRule can be allocated without allocating any additional LogInspectionRules. Ignored if the rule is user-defined, which uses `dependency` instead.")
  public Boolean isCanBeAssignedAlone() {
    return canBeAssignedAlone;
  }

   /**
   * IDs of LogInspectionRules, separated by commas, that are required by this rule. Ignored if the rule is user-defined, which uses &#x60;dependencyRuleID&#x60; or &#x60;dependencyGroup&#x60; instead.
   * @return dependsOnRuleIDs
  **/
  @ApiModelProperty(value = "IDs of LogInspectionRules, separated by commas, that are required by this rule. Ignored if the rule is user-defined, which uses `dependencyRuleID` or `dependencyGroup` instead.")
  public List<Integer> getDependsOnRuleIDs() {
    return dependsOnRuleIDs;
  }

   /**
   * ID of the LogInspectionRule. This number is set automatically. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the LogInspectionRule. This number is set automatically. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LogInspectionRule logInspectionRule = (LogInspectionRule) o;
    return Objects.equals(this.name, logInspectionRule.name) &&
        Objects.equals(this.description, logInspectionRule.description) &&
        Objects.equals(this.minimumAgentVersion, logInspectionRule.minimumAgentVersion) &&
        Objects.equals(this.minimumManagerVersion, logInspectionRule.minimumManagerVersion) &&
        Objects.equals(this.type, logInspectionRule.type) &&
        Objects.equals(this.originalIssue, logInspectionRule.originalIssue) &&
        Objects.equals(this.lastUpdated, logInspectionRule.lastUpdated) &&
        Objects.equals(this.identifier, logInspectionRule.identifier) &&
        Objects.equals(this.template, logInspectionRule.template) &&
        Objects.equals(this.ruleID, logInspectionRule.ruleID) &&
        Objects.equals(this.level, logInspectionRule.level) &&
        Objects.equals(this.groups, logInspectionRule.groups) &&
        Objects.equals(this.ruleDescription, logInspectionRule.ruleDescription) &&
        Objects.equals(this.pattern, logInspectionRule.pattern) &&
        Objects.equals(this.patternType, logInspectionRule.patternType) &&
        Objects.equals(this.dependency, logInspectionRule.dependency) &&
        Objects.equals(this.dependencyRuleID, logInspectionRule.dependencyRuleID) &&
        Objects.equals(this.dependencyGroup, logInspectionRule.dependencyGroup) &&
        Objects.equals(this.frequency, logInspectionRule.frequency) &&
        Objects.equals(this.timeFrame, logInspectionRule.timeFrame) &&
        Objects.equals(this.ruleXML, logInspectionRule.ruleXML) &&
        Objects.equals(this.logFiles, logInspectionRule.logFiles) &&
        Objects.equals(this.alertEnabled, logInspectionRule.alertEnabled) &&
        Objects.equals(this.alertMinimumSeverity, logInspectionRule.alertMinimumSeverity) &&
        Objects.equals(this.recommendationsMode, logInspectionRule.recommendationsMode) &&
        Objects.equals(this.sortOrder, logInspectionRule.sortOrder) &&
        Objects.equals(this.canBeAssignedAlone, logInspectionRule.canBeAssignedAlone) &&
        Objects.equals(this.dependsOnRuleIDs, logInspectionRule.dependsOnRuleIDs) &&
        Objects.equals(this.ID, logInspectionRule.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, minimumAgentVersion, minimumManagerVersion, type, originalIssue, lastUpdated, identifier, template, ruleID, level, groups, ruleDescription, pattern, patternType, dependency, dependencyRuleID, dependencyGroup, frequency, timeFrame, ruleXML, logFiles, alertEnabled, alertMinimumSeverity, recommendationsMode, sortOrder, canBeAssignedAlone, dependsOnRuleIDs, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LogInspectionRule {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    minimumAgentVersion: ").append(toIndentedString(minimumAgentVersion)).append("\n");
    sb.append("    minimumManagerVersion: ").append(toIndentedString(minimumManagerVersion)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    originalIssue: ").append(toIndentedString(originalIssue)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    identifier: ").append(toIndentedString(identifier)).append("\n");
    sb.append("    template: ").append(toIndentedString(template)).append("\n");
    sb.append("    ruleID: ").append(toIndentedString(ruleID)).append("\n");
    sb.append("    level: ").append(toIndentedString(level)).append("\n");
    sb.append("    groups: ").append(toIndentedString(groups)).append("\n");
    sb.append("    ruleDescription: ").append(toIndentedString(ruleDescription)).append("\n");
    sb.append("    pattern: ").append(toIndentedString(pattern)).append("\n");
    sb.append("    patternType: ").append(toIndentedString(patternType)).append("\n");
    sb.append("    dependency: ").append(toIndentedString(dependency)).append("\n");
    sb.append("    dependencyRuleID: ").append(toIndentedString(dependencyRuleID)).append("\n");
    sb.append("    dependencyGroup: ").append(toIndentedString(dependencyGroup)).append("\n");
    sb.append("    frequency: ").append(toIndentedString(frequency)).append("\n");
    sb.append("    timeFrame: ").append(toIndentedString(timeFrame)).append("\n");
    sb.append("    ruleXML: ").append(toIndentedString(ruleXML)).append("\n");
    sb.append("    logFiles: ").append(toIndentedString(logFiles)).append("\n");
    sb.append("    alertEnabled: ").append(toIndentedString(alertEnabled)).append("\n");
    sb.append("    alertMinimumSeverity: ").append(toIndentedString(alertMinimumSeverity)).append("\n");
    sb.append("    recommendationsMode: ").append(toIndentedString(recommendationsMode)).append("\n");
    sb.append("    sortOrder: ").append(toIndentedString(sortOrder)).append("\n");
    sb.append("    canBeAssignedAlone: ").append(toIndentedString(canBeAssignedAlone)).append("\n");
    sb.append("    dependsOnRuleIDs: ").append(toIndentedString(dependsOnRuleIDs)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

