/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Network interface of a managed computer.
 */
@ApiModel(description = "Network interface of a managed computer.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ModelInterface {
  @JsonProperty("interfaceTypeID")
  private Integer interfaceTypeID = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("displayName")
  private String displayName = null;

  @JsonProperty("detected")
  private Boolean detected = null;

  @JsonProperty("ID")
  private Integer ID = null;

  @JsonProperty("MAC")
  private String MAC = null;

  @JsonProperty("DHCP")
  private Boolean DHCP = null;

  @JsonProperty("IPs")
  private List<String> ips = null;

  public ModelInterface interfaceTypeID(Integer interfaceTypeID) {
    this.interfaceTypeID = interfaceTypeID;
    return this;
  }

   /**
   * ID of the InterfaceType to which the Interface is mapped. Searchable as Numeric.
   * @return interfaceTypeID
  **/
  @ApiModelProperty(value = "ID of the InterfaceType to which the Interface is mapped. Searchable as Numeric.")
  public Integer getInterfaceTypeID() {
    return interfaceTypeID;
  }

  public void setInterfaceTypeID(Integer interfaceTypeID) {
    this.interfaceTypeID = interfaceTypeID;
  }

   /**
   * Name of the Interface. Set automatically by the DSM. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the Interface. Set automatically by the DSM. Searchable as String.")
  public String getName() {
    return name;
  }

  public ModelInterface displayName(String displayName) {
    this.displayName = displayName;
    return this;
  }

   /**
   * Display name of the Interface. Optionally set by the user. Searchable as String.
   * @return displayName
  **/
  @ApiModelProperty(value = "Display name of the Interface. Optionally set by the user. Searchable as String.")
  public String getDisplayName() {
    return displayName;
  }

  public void setDisplayName(String displayName) {
    this.displayName = displayName;
  }

   /**
   * Indicates whether or not the interface is currently detected. Searchable as Boolean.
   * @return detected
  **/
  @ApiModelProperty(value = "Indicates whether or not the interface is currently detected. Searchable as Boolean.")
  public Boolean isDetected() {
    return detected;
  }

   /**
   * ID of the Interface.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the Interface.")
  public Integer getID() {
    return ID;
  }

   /**
   * MAC Address of the interface. Searchable as String.
   * @return MAC
  **/
  @ApiModelProperty(value = "MAC Address of the interface. Searchable as String.")
  public String getMAC() {
    return MAC;
  }

   /**
   * Indicates whether the interface uses DHCP. The value is true if it uses DHCP. Searchable as Boolean.
   * @return DHCP
  **/
  @ApiModelProperty(value = "Indicates whether the interface uses DHCP. The value is true if it uses DHCP. Searchable as Boolean.")
  public Boolean isDHCP() {
    return DHCP;
  }

   /**
   * List of IPs used by the interface.
   * @return ips
  **/
  @ApiModelProperty(value = "List of IPs used by the interface.")
  public List<String> getIps() {
    return ips;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ModelInterface _interface = (ModelInterface) o;
    return Objects.equals(this.interfaceTypeID, _interface.interfaceTypeID) &&
        Objects.equals(this.name, _interface.name) &&
        Objects.equals(this.displayName, _interface.displayName) &&
        Objects.equals(this.detected, _interface.detected) &&
        Objects.equals(this.ID, _interface.ID) &&
        Objects.equals(this.MAC, _interface.MAC) &&
        Objects.equals(this.DHCP, _interface.DHCP) &&
        Objects.equals(this.ips, _interface.ips);
  }

  @Override
  public int hashCode() {
    return Objects.hash(interfaceTypeID, name, displayName, detected, ID, MAC, DHCP, ips);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ModelInterface {\n");
    
    sb.append("    interfaceTypeID: ").append(toIndentedString(interfaceTypeID)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    detected: ").append(toIndentedString(detected)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    MAC: ").append(toIndentedString(MAC)).append("\n");
    sb.append("    DHCP: ").append(toIndentedString(DHCP)).append("\n");
    sb.append("    ips: ").append(toIndentedString(ips)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

