/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details for a monthly schedule for a scheduled task.
 */
@ApiModel(description = "Details for a monthly schedule for a scheduled task.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class MonthlyScheduleParameters {
  @JsonProperty("startTime")
  private Long startTime = null;

  /**
   * Frequency type.
   */
  public enum FrequencyTypeEnum {
    DAY_OF_MONTH("day-of-month"),
    
    LAST_DAY_OF_MONTH("last-day-of-month"),
    
    CUSTOM("custom");

    private String value;

    FrequencyTypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static FrequencyTypeEnum fromValue(String text) {
      for (FrequencyTypeEnum b : FrequencyTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("frequencyType")
  private FrequencyTypeEnum frequencyType = null;

  @JsonProperty("dayOfMonth")
  private Integer dayOfMonth = null;

  /**
   * Specific week of month for frequency type: custom.
   */
  public enum WeekOfMonthEnum {
    FIRST("first"),
    
    SECOND("second"),
    
    THIRD("third"),
    
    FOURTH("fourth"),
    
    LAST("last");

    private String value;

    WeekOfMonthEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static WeekOfMonthEnum fromValue(String text) {
      for (WeekOfMonthEnum b : WeekOfMonthEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("weekOfMonth")
  private WeekOfMonthEnum weekOfMonth = null;

  /**
   * Specific day of week for frequency type: custom.
   */
  public enum DayOfWeekEnum {
    SUNDAY("sunday"),
    
    MONDAY("monday"),
    
    TUESDAY("tuesday"),
    
    WEDNESDAY("wednesday"),
    
    THURSDAY("thursday"),
    
    FRIDAY("friday"),
    
    SATURDAY("saturday");

    private String value;

    DayOfWeekEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DayOfWeekEnum fromValue(String text) {
      for (DayOfWeekEnum b : DayOfWeekEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("dayOfWeek")
  private DayOfWeekEnum dayOfWeek = null;

  /**
   * Gets or Sets months
   */
  public enum MonthsEnum {
    JANUARY("january"),
    
    FEBURARY("feburary"),
    
    MARCH("march"),
    
    APRIL("april"),
    
    MAY("may"),
    
    JUNE("june"),
    
    JULY("july"),
    
    AUGUST("august"),
    
    SEPTEMBER("september"),
    
    OCTOBER("october"),
    
    NOVEMBER("november"),
    
    DECEMBER("december");

    private String value;

    MonthsEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static MonthsEnum fromValue(String text) {
      for (MonthsEnum b : MonthsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("months")
  private List<MonthsEnum> months = null;

  public MonthlyScheduleParameters startTime(Long startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Date/Time when the task should run.
   * @return startTime
  **/
  @ApiModelProperty(value = "Date/Time when the task should run.")
  public Long getStartTime() {
    return startTime;
  }

  public void setStartTime(Long startTime) {
    this.startTime = startTime;
  }

  public MonthlyScheduleParameters frequencyType(FrequencyTypeEnum frequencyType) {
    this.frequencyType = frequencyType;
    return this;
  }

   /**
   * Frequency type.
   * @return frequencyType
  **/
  @ApiModelProperty(value = "Frequency type.")
  public FrequencyTypeEnum getFrequencyType() {
    return frequencyType;
  }

  public void setFrequencyType(FrequencyTypeEnum frequencyType) {
    this.frequencyType = frequencyType;
  }

  public MonthlyScheduleParameters dayOfMonth(Integer dayOfMonth) {
    this.dayOfMonth = dayOfMonth;
    return this;
  }

   /**
   * Specific day of month for frequency type: day-of-month.
   * @return dayOfMonth
  **/
  @ApiModelProperty(value = "Specific day of month for frequency type: day-of-month.")
  public Integer getDayOfMonth() {
    return dayOfMonth;
  }

  public void setDayOfMonth(Integer dayOfMonth) {
    this.dayOfMonth = dayOfMonth;
  }

  public MonthlyScheduleParameters weekOfMonth(WeekOfMonthEnum weekOfMonth) {
    this.weekOfMonth = weekOfMonth;
    return this;
  }

   /**
   * Specific week of month for frequency type: custom.
   * @return weekOfMonth
  **/
  @ApiModelProperty(value = "Specific week of month for frequency type: custom.")
  public WeekOfMonthEnum getWeekOfMonth() {
    return weekOfMonth;
  }

  public void setWeekOfMonth(WeekOfMonthEnum weekOfMonth) {
    this.weekOfMonth = weekOfMonth;
  }

  public MonthlyScheduleParameters dayOfWeek(DayOfWeekEnum dayOfWeek) {
    this.dayOfWeek = dayOfWeek;
    return this;
  }

   /**
   * Specific day of week for frequency type: custom.
   * @return dayOfWeek
  **/
  @ApiModelProperty(value = "Specific day of week for frequency type: custom.")
  public DayOfWeekEnum getDayOfWeek() {
    return dayOfWeek;
  }

  public void setDayOfWeek(DayOfWeekEnum dayOfWeek) {
    this.dayOfWeek = dayOfWeek;
  }

  public MonthlyScheduleParameters months(List<MonthsEnum> months) {
    this.months = months;
    return this;
  }

  public MonthlyScheduleParameters addMonthsItem(MonthsEnum monthsItem) {
    if (this.months == null) {
      this.months = new ArrayList<>();
    }
    this.months.add(monthsItem);
    return this;
  }

   /**
   * Months of the year when the scheduled task will run.
   * @return months
  **/
  @ApiModelProperty(value = "Months of the year when the scheduled task will run.")
  public List<MonthsEnum> getMonths() {
    return months;
  }

  public void setMonths(List<MonthsEnum> months) {
    this.months = months;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MonthlyScheduleParameters monthlyScheduleParameters = (MonthlyScheduleParameters) o;
    return Objects.equals(this.startTime, monthlyScheduleParameters.startTime) &&
        Objects.equals(this.frequencyType, monthlyScheduleParameters.frequencyType) &&
        Objects.equals(this.dayOfMonth, monthlyScheduleParameters.dayOfMonth) &&
        Objects.equals(this.weekOfMonth, monthlyScheduleParameters.weekOfMonth) &&
        Objects.equals(this.dayOfWeek, monthlyScheduleParameters.dayOfWeek) &&
        Objects.equals(this.months, monthlyScheduleParameters.months);
  }

  @Override
  public int hashCode() {
    return Objects.hash(startTime, frequencyType, dayOfMonth, weekOfMonth, dayOfWeek, months);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MonthlyScheduleParameters {\n");
    
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    frequencyType: ").append(toIndentedString(frequencyType)).append("\n");
    sb.append("    dayOfMonth: ").append(toIndentedString(dayOfMonth)).append("\n");
    sb.append("    weekOfMonth: ").append(toIndentedString(weekOfMonth)).append("\n");
    sb.append("    dayOfWeek: ").append(toIndentedString(dayOfWeek)).append("\n");
    sb.append("    months: ").append(toIndentedString(months)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

