/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ActivityMonitoringPolicyExtension;
import com.trendmicro.deepsecurity.model.AntiMalwarePolicyExtension;
import com.trendmicro.deepsecurity.model.ApplicationControlPolicyExtension;
import com.trendmicro.deepsecurity.model.FirewallPolicyExtension;
import com.trendmicro.deepsecurity.model.IntegrityMonitoringPolicyExtension;
import com.trendmicro.deepsecurity.model.InterfaceTypes;
import com.trendmicro.deepsecurity.model.IntrusionPreventionPolicyExtension;
import com.trendmicro.deepsecurity.model.LogInspectionPolicyExtension;
import com.trendmicro.deepsecurity.model.PolicySettings;
import com.trendmicro.deepsecurity.model.SAPPolicyExtension;
import com.trendmicro.deepsecurity.model.WebReputationPolicyExtension;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Policy details
 */
@ApiModel(description = "Policy details")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class Policy {
  @JsonProperty("parentID")
  private Integer parentID = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("policySettings")
  private PolicySettings policySettings = null;

  /**
   * Enable or disable ongoing recommendation scans for computers assigned this policy. Searchable as Choice.
   */
  public enum RecommendationScanModeEnum {
    OFF("off"),
    
    ONGOING("ongoing");

    private String value;

    RecommendationScanModeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static RecommendationScanModeEnum fromValue(String text) {
      for (RecommendationScanModeEnum b : RecommendationScanModeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("recommendationScanMode")
  private RecommendationScanModeEnum recommendationScanMode = null;

  /**
   * Automatically update computers assigned this policy when the configuration changes. Searchable as Choice.
   */
  public enum AutoRequiresUpdateEnum {
    OFF("off"),
    
    ON("on");

    private String value;

    AutoRequiresUpdateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static AutoRequiresUpdateEnum fromValue(String text) {
      for (AutoRequiresUpdateEnum b : AutoRequiresUpdateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("autoRequiresUpdate")
  private AutoRequiresUpdateEnum autoRequiresUpdate = null;

  @JsonProperty("interfaceTypes")
  private InterfaceTypes interfaceTypes = null;

  @JsonProperty("ID")
  private Integer ID = null;

  @JsonProperty("antiMalware")
  private AntiMalwarePolicyExtension antiMalware = null;

  @JsonProperty("webReputation")
  private WebReputationPolicyExtension webReputation = null;

  @JsonProperty("activityMonitoring")
  private ActivityMonitoringPolicyExtension activityMonitoring = null;

  @JsonProperty("firewall")
  private FirewallPolicyExtension firewall = null;

  @JsonProperty("intrusionPrevention")
  private IntrusionPreventionPolicyExtension intrusionPrevention = null;

  @JsonProperty("integrityMonitoring")
  private IntegrityMonitoringPolicyExtension integrityMonitoring = null;

  @JsonProperty("logInspection")
  private LogInspectionPolicyExtension logInspection = null;

  @JsonProperty("applicationControl")
  private ApplicationControlPolicyExtension applicationControl = null;

  @JsonProperty("SAP")
  private SAPPolicyExtension SAP = null;

  public Policy parentID(Integer parentID) {
    this.parentID = parentID;
    return this;
  }

   /**
   * ID of the parent policy. Searchable as Numeric.
   * @return parentID
  **/
  @ApiModelProperty(value = "ID of the parent policy. Searchable as Numeric.")
  public Integer getParentID() {
    return parentID;
  }

  public void setParentID(Integer parentID) {
    this.parentID = parentID;
  }

  public Policy name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the policy. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the policy. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Policy description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the policy. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the policy. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Policy policySettings(PolicySettings policySettings) {
    this.policySettings = policySettings;
    return this;
  }

   /**
   * All configurable policy settings.
   * @return policySettings
  **/
  @ApiModelProperty(value = "All configurable policy settings.")
  public PolicySettings getPolicySettings() {
    return policySettings;
  }

  public void setPolicySettings(PolicySettings policySettings) {
    this.policySettings = policySettings;
  }

  public Policy recommendationScanMode(RecommendationScanModeEnum recommendationScanMode) {
    this.recommendationScanMode = recommendationScanMode;
    return this;
  }

   /**
   * Enable or disable ongoing recommendation scans for computers assigned this policy. Searchable as Choice.
   * @return recommendationScanMode
  **/
  @ApiModelProperty(value = "Enable or disable ongoing recommendation scans for computers assigned this policy. Searchable as Choice.")
  public RecommendationScanModeEnum getRecommendationScanMode() {
    return recommendationScanMode;
  }

  public void setRecommendationScanMode(RecommendationScanModeEnum recommendationScanMode) {
    this.recommendationScanMode = recommendationScanMode;
  }

  public Policy autoRequiresUpdate(AutoRequiresUpdateEnum autoRequiresUpdate) {
    this.autoRequiresUpdate = autoRequiresUpdate;
    return this;
  }

   /**
   * Automatically update computers assigned this policy when the configuration changes. Searchable as Choice.
   * @return autoRequiresUpdate
  **/
  @ApiModelProperty(value = "Automatically update computers assigned this policy when the configuration changes. Searchable as Choice.")
  public AutoRequiresUpdateEnum getAutoRequiresUpdate() {
    return autoRequiresUpdate;
  }

  public void setAutoRequiresUpdate(AutoRequiresUpdateEnum autoRequiresUpdate) {
    this.autoRequiresUpdate = autoRequiresUpdate;
  }

  public Policy interfaceTypes(InterfaceTypes interfaceTypes) {
    this.interfaceTypes = interfaceTypes;
    return this;
  }

   /**
   * When \&quot;Rules can apply to specific interfaces\&quot; is selected, Deep Security will map the network interfaces detected on a computer to the types in this list.
   * @return interfaceTypes
  **/
  @ApiModelProperty(value = "When \"Rules can apply to specific interfaces\" is selected, Deep Security will map the network interfaces detected on a computer to the types in this list.")
  public InterfaceTypes getInterfaceTypes() {
    return interfaceTypes;
  }

  public void setInterfaceTypes(InterfaceTypes interfaceTypes) {
    this.interfaceTypes = interfaceTypes;
  }

   /**
   * ID of the policy. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the policy. Searchable as ID.")
  public Integer getID() {
    return ID;
  }

  public Policy antiMalware(AntiMalwarePolicyExtension antiMalware) {
    this.antiMalware = antiMalware;
    return this;
  }

   /**
   * Configuration for the Anti-Malware module.
   * @return antiMalware
  **/
  @ApiModelProperty(value = "Configuration for the Anti-Malware module.")
  public AntiMalwarePolicyExtension getAntiMalware() {
    return antiMalware;
  }

  public void setAntiMalware(AntiMalwarePolicyExtension antiMalware) {
    this.antiMalware = antiMalware;
  }

  public Policy webReputation(WebReputationPolicyExtension webReputation) {
    this.webReputation = webReputation;
    return this;
  }

   /**
   * Configuration for the Web Reputation module.
   * @return webReputation
  **/
  @ApiModelProperty(value = "Configuration for the Web Reputation module.")
  public WebReputationPolicyExtension getWebReputation() {
    return webReputation;
  }

  public void setWebReputation(WebReputationPolicyExtension webReputation) {
    this.webReputation = webReputation;
  }

  public Policy activityMonitoring(ActivityMonitoringPolicyExtension activityMonitoring) {
    this.activityMonitoring = activityMonitoring;
    return this;
  }

   /**
   * Configuration for the Activity Monitoring module.
   * @return activityMonitoring
  **/
  @ApiModelProperty(value = "Configuration for the Activity Monitoring module.")
  public ActivityMonitoringPolicyExtension getActivityMonitoring() {
    return activityMonitoring;
  }

  public void setActivityMonitoring(ActivityMonitoringPolicyExtension activityMonitoring) {
    this.activityMonitoring = activityMonitoring;
  }

  public Policy firewall(FirewallPolicyExtension firewall) {
    this.firewall = firewall;
    return this;
  }

   /**
   * Configuration for the Firewall module.
   * @return firewall
  **/
  @ApiModelProperty(value = "Configuration for the Firewall module.")
  public FirewallPolicyExtension getFirewall() {
    return firewall;
  }

  public void setFirewall(FirewallPolicyExtension firewall) {
    this.firewall = firewall;
  }

  public Policy intrusionPrevention(IntrusionPreventionPolicyExtension intrusionPrevention) {
    this.intrusionPrevention = intrusionPrevention;
    return this;
  }

   /**
   * Configuration for the Intrusion Prevention module.
   * @return intrusionPrevention
  **/
  @ApiModelProperty(value = "Configuration for the Intrusion Prevention module.")
  public IntrusionPreventionPolicyExtension getIntrusionPrevention() {
    return intrusionPrevention;
  }

  public void setIntrusionPrevention(IntrusionPreventionPolicyExtension intrusionPrevention) {
    this.intrusionPrevention = intrusionPrevention;
  }

  public Policy integrityMonitoring(IntegrityMonitoringPolicyExtension integrityMonitoring) {
    this.integrityMonitoring = integrityMonitoring;
    return this;
  }

   /**
   * Configuration for the Integrity Monitoring module.
   * @return integrityMonitoring
  **/
  @ApiModelProperty(value = "Configuration for the Integrity Monitoring module.")
  public IntegrityMonitoringPolicyExtension getIntegrityMonitoring() {
    return integrityMonitoring;
  }

  public void setIntegrityMonitoring(IntegrityMonitoringPolicyExtension integrityMonitoring) {
    this.integrityMonitoring = integrityMonitoring;
  }

  public Policy logInspection(LogInspectionPolicyExtension logInspection) {
    this.logInspection = logInspection;
    return this;
  }

   /**
   * Configuration for the Log Inspection module.
   * @return logInspection
  **/
  @ApiModelProperty(value = "Configuration for the Log Inspection module.")
  public LogInspectionPolicyExtension getLogInspection() {
    return logInspection;
  }

  public void setLogInspection(LogInspectionPolicyExtension logInspection) {
    this.logInspection = logInspection;
  }

  public Policy applicationControl(ApplicationControlPolicyExtension applicationControl) {
    this.applicationControl = applicationControl;
    return this;
  }

   /**
   * Configuration for the Application Control module.
   * @return applicationControl
  **/
  @ApiModelProperty(value = "Configuration for the Application Control module.")
  public ApplicationControlPolicyExtension getApplicationControl() {
    return applicationControl;
  }

  public void setApplicationControl(ApplicationControlPolicyExtension applicationControl) {
    this.applicationControl = applicationControl;
  }

  public Policy SAP(SAPPolicyExtension SAP) {
    this.SAP = SAP;
    return this;
  }

   /**
   * Get SAP
   * @return SAP
  **/
  @ApiModelProperty(value = "")
  public SAPPolicyExtension getSAP() {
    return SAP;
  }

  public void setSAP(SAPPolicyExtension SAP) {
    this.SAP = SAP;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Policy policy = (Policy) o;
    return Objects.equals(this.parentID, policy.parentID) &&
        Objects.equals(this.name, policy.name) &&
        Objects.equals(this.description, policy.description) &&
        Objects.equals(this.policySettings, policy.policySettings) &&
        Objects.equals(this.recommendationScanMode, policy.recommendationScanMode) &&
        Objects.equals(this.autoRequiresUpdate, policy.autoRequiresUpdate) &&
        Objects.equals(this.interfaceTypes, policy.interfaceTypes) &&
        Objects.equals(this.ID, policy.ID) &&
        Objects.equals(this.antiMalware, policy.antiMalware) &&
        Objects.equals(this.webReputation, policy.webReputation) &&
        Objects.equals(this.activityMonitoring, policy.activityMonitoring) &&
        Objects.equals(this.firewall, policy.firewall) &&
        Objects.equals(this.intrusionPrevention, policy.intrusionPrevention) &&
        Objects.equals(this.integrityMonitoring, policy.integrityMonitoring) &&
        Objects.equals(this.logInspection, policy.logInspection) &&
        Objects.equals(this.applicationControl, policy.applicationControl) &&
        Objects.equals(this.SAP, policy.SAP);
  }

  @Override
  public int hashCode() {
    return Objects.hash(parentID, name, description, policySettings, recommendationScanMode, autoRequiresUpdate, interfaceTypes, ID, antiMalware, webReputation, activityMonitoring, firewall, intrusionPrevention, integrityMonitoring, logInspection, applicationControl, SAP);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Policy {\n");
    
    sb.append("    parentID: ").append(toIndentedString(parentID)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    policySettings: ").append(toIndentedString(policySettings)).append("\n");
    sb.append("    recommendationScanMode: ").append(toIndentedString(recommendationScanMode)).append("\n");
    sb.append("    autoRequiresUpdate: ").append(toIndentedString(autoRequiresUpdate)).append("\n");
    sb.append("    interfaceTypes: ").append(toIndentedString(interfaceTypes)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("    antiMalware: ").append(toIndentedString(antiMalware)).append("\n");
    sb.append("    webReputation: ").append(toIndentedString(webReputation)).append("\n");
    sb.append("    activityMonitoring: ").append(toIndentedString(activityMonitoring)).append("\n");
    sb.append("    firewall: ").append(toIndentedString(firewall)).append("\n");
    sb.append("    intrusionPrevention: ").append(toIndentedString(intrusionPrevention)).append("\n");
    sb.append("    integrityMonitoring: ").append(toIndentedString(integrityMonitoring)).append("\n");
    sb.append("    logInspection: ").append(toIndentedString(logInspection)).append("\n");
    sb.append("    applicationControl: ").append(toIndentedString(applicationControl)).append("\n");
    sb.append("    SAP: ").append(toIndentedString(SAP)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

