/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Policy right details.
 */
@ApiModel(description = "Policy right details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class PolicyRights {
  @JsonProperty("canCreateNewPolicies")
  private Boolean canCreateNewPolicies = null;

  @JsonProperty("canDeletePolicies")
  private Boolean canDeletePolicies = null;

  @JsonProperty("canEditPolicyProperties")
  private Boolean canEditPolicyProperties = null;

  @JsonProperty("canImportPolicies")
  private Boolean canImportPolicies = null;

  @JsonProperty("canViewOtherPolicies")
  private Boolean canViewOtherPolicies = null;

  public PolicyRights canCreateNewPolicies(Boolean canCreateNewPolicies) {
    this.canCreateNewPolicies = canCreateNewPolicies;
    return this;
  }

   /**
   * Right to create new policies.
   * @return canCreateNewPolicies
  **/
  @ApiModelProperty(value = "Right to create new policies.")
  public Boolean isCanCreateNewPolicies() {
    return canCreateNewPolicies;
  }

  public void setCanCreateNewPolicies(Boolean canCreateNewPolicies) {
    this.canCreateNewPolicies = canCreateNewPolicies;
  }

  public PolicyRights canDeletePolicies(Boolean canDeletePolicies) {
    this.canDeletePolicies = canDeletePolicies;
    return this;
  }

   /**
   * Right to delete policies.
   * @return canDeletePolicies
  **/
  @ApiModelProperty(value = "Right to delete policies.")
  public Boolean isCanDeletePolicies() {
    return canDeletePolicies;
  }

  public void setCanDeletePolicies(Boolean canDeletePolicies) {
    this.canDeletePolicies = canDeletePolicies;
  }

  public PolicyRights canEditPolicyProperties(Boolean canEditPolicyProperties) {
    this.canEditPolicyProperties = canEditPolicyProperties;
    return this;
  }

   /**
   * Right to edit policy properties.
   * @return canEditPolicyProperties
  **/
  @ApiModelProperty(value = "Right to edit policy properties.")
  public Boolean isCanEditPolicyProperties() {
    return canEditPolicyProperties;
  }

  public void setCanEditPolicyProperties(Boolean canEditPolicyProperties) {
    this.canEditPolicyProperties = canEditPolicyProperties;
  }

  public PolicyRights canImportPolicies(Boolean canImportPolicies) {
    this.canImportPolicies = canImportPolicies;
    return this;
  }

   /**
   * Right to import policies.
   * @return canImportPolicies
  **/
  @ApiModelProperty(value = "Right to import policies.")
  public Boolean isCanImportPolicies() {
    return canImportPolicies;
  }

  public void setCanImportPolicies(Boolean canImportPolicies) {
    this.canImportPolicies = canImportPolicies;
  }

  public PolicyRights canViewOtherPolicies(Boolean canViewOtherPolicies) {
    this.canViewOtherPolicies = canViewOtherPolicies;
    return this;
  }

   /**
   * Right to view non-selected policies.
   * @return canViewOtherPolicies
  **/
  @ApiModelProperty(value = "Right to view non-selected policies.")
  public Boolean isCanViewOtherPolicies() {
    return canViewOtherPolicies;
  }

  public void setCanViewOtherPolicies(Boolean canViewOtherPolicies) {
    this.canViewOtherPolicies = canViewOtherPolicies;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PolicyRights policyRights = (PolicyRights) o;
    return Objects.equals(this.canCreateNewPolicies, policyRights.canCreateNewPolicies) &&
        Objects.equals(this.canDeletePolicies, policyRights.canDeletePolicies) &&
        Objects.equals(this.canEditPolicyProperties, policyRights.canEditPolicyProperties) &&
        Objects.equals(this.canImportPolicies, policyRights.canImportPolicies) &&
        Objects.equals(this.canViewOtherPolicies, policyRights.canViewOtherPolicies);
  }

  @Override
  public int hashCode() {
    return Objects.hash(canCreateNewPolicies, canDeletePolicies, canEditPolicyProperties, canImportPolicies, canViewOtherPolicies);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PolicyRights {\n");
    
    sb.append("    canCreateNewPolicies: ").append(toIndentedString(canCreateNewPolicies)).append("\n");
    sb.append("    canDeletePolicies: ").append(toIndentedString(canDeletePolicies)).append("\n");
    sb.append("    canEditPolicyProperties: ").append(toIndentedString(canEditPolicyProperties)).append("\n");
    sb.append("    canImportPolicies: ").append(toIndentedString(canImportPolicies)).append("\n");
    sb.append("    canViewOtherPolicies: ").append(toIndentedString(canViewOtherPolicies)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

