/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of a session of a registry scanner. Registry scanners, such as Deep Security Smart Check, scan Docker registries.
 */
@ApiModel(description = "Details of a session of a registry scanner. Registry scanners, such as Deep Security Smart Check, scan Docker registries.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class RegistryScannerSessionInfo {
  @JsonProperty("token")
  private String token = null;

  @JsonProperty("expires")
  private Long expires = null;

  @JsonProperty("url")
  private String url = null;

  @JsonProperty("sessionID")
  private String sessionID = null;

   /**
   * Session token of the registry scanner.
   * @return token
  **/
  @ApiModelProperty(value = "Session token of the registry scanner.")
  public String getToken() {
    return token;
  }

   /**
   * Timestamp of the expiration date of the session token, in numbers of milliseconds since epoch.
   * @return expires
  **/
  @ApiModelProperty(value = "Timestamp of the expiration date of the session token, in numbers of milliseconds since epoch.")
  public Long getExpires() {
    return expires;
  }

   /**
   * URL of the registry scanner.
   * @return url
  **/
  @ApiModelProperty(value = "URL of the registry scanner.")
  public String getUrl() {
    return url;
  }

   /**
   * ID of the registry scanner session.
   * @return sessionID
  **/
  @ApiModelProperty(value = "ID of the registry scanner session.")
  public String getSessionID() {
    return sessionID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RegistryScannerSessionInfo registryScannerSessionInfo = (RegistryScannerSessionInfo) o;
    return Objects.equals(this.token, registryScannerSessionInfo.token) &&
        Objects.equals(this.expires, registryScannerSessionInfo.expires) &&
        Objects.equals(this.url, registryScannerSessionInfo.url) &&
        Objects.equals(this.sessionID, registryScannerSessionInfo.sessionID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(token, expires, url, sessionID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RegistryScannerSessionInfo {\n");
    
    sb.append("    token: ").append(toIndentedString(token)).append("\n");
    sb.append("    expires: ").append(toIndentedString(expires)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    sessionID: ").append(toIndentedString(sessionID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

