/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of a report template.
 */
@ApiModel(description = "Details of a report template.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ReportTemplate {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("timeFilterSupported")
  private Boolean timeFilterSupported = null;

  @JsonProperty("computerFilterSupported")
  private Boolean computerFilterSupported = null;

  @JsonProperty("tagFilterSupported")
  private Boolean tagFilterSupported = null;

  /**
   * Gets or Sets supportedFormats
   */
  public enum SupportedFormatsEnum {
    PDF("pdf"),
    
    CSV("csv"),
    
    HTML("html"),
    
    PLAINTEXT("plaintext"),
    
    RTF("rtf"),
    
    XLS("xls"),
    
    XML("xml");

    private String value;

    SupportedFormatsEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static SupportedFormatsEnum fromValue(String text) {
      for (SupportedFormatsEnum b : SupportedFormatsEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("supportedFormats")
  private List<SupportedFormatsEnum> supportedFormats = null;

  @JsonProperty("ID")
  private Integer ID = null;

   /**
   * Name of the report template.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the report template.")
  public String getName() {
    return name;
  }

   /**
   * Description of the report template.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the report template.")
  public String getDescription() {
    return description;
  }

   /**
   * Flag indicating whether or not the report template supports a time filter. Searchable as Boolean.
   * @return timeFilterSupported
  **/
  @ApiModelProperty(value = "Flag indicating whether or not the report template supports a time filter. Searchable as Boolean.")
  public Boolean isTimeFilterSupported() {
    return timeFilterSupported;
  }

   /**
   * Flag indicating whether or not the report template supports a computer filter. Searchable as Boolean.
   * @return computerFilterSupported
  **/
  @ApiModelProperty(value = "Flag indicating whether or not the report template supports a computer filter. Searchable as Boolean.")
  public Boolean isComputerFilterSupported() {
    return computerFilterSupported;
  }

   /**
   * Flag indicating whether or not the report template supports a tag filter. Searchable as Boolean.
   * @return tagFilterSupported
  **/
  @ApiModelProperty(value = "Flag indicating whether or not the report template supports a tag filter. Searchable as Boolean.")
  public Boolean isTagFilterSupported() {
    return tagFilterSupported;
  }

   /**
   * List of supported report formats.
   * @return supportedFormats
  **/
  @ApiModelProperty(value = "List of supported report formats.")
  public List<SupportedFormatsEnum> getSupportedFormats() {
    return supportedFormats;
  }

   /**
   * ID of the report template. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the report template. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ReportTemplate reportTemplate = (ReportTemplate) o;
    return Objects.equals(this.name, reportTemplate.name) &&
        Objects.equals(this.description, reportTemplate.description) &&
        Objects.equals(this.timeFilterSupported, reportTemplate.timeFilterSupported) &&
        Objects.equals(this.computerFilterSupported, reportTemplate.computerFilterSupported) &&
        Objects.equals(this.tagFilterSupported, reportTemplate.tagFilterSupported) &&
        Objects.equals(this.supportedFormats, reportTemplate.supportedFormats) &&
        Objects.equals(this.ID, reportTemplate.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, timeFilterSupported, computerFilterSupported, tagFilterSupported, supportedFormats, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ReportTemplate {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    timeFilterSupported: ").append(toIndentedString(timeFilterSupported)).append("\n");
    sb.append("    computerFilterSupported: ").append(toIndentedString(computerFilterSupported)).append("\n");
    sb.append("    tagFilterSupported: ").append(toIndentedString(tagFilterSupported)).append("\n");
    sb.append("    supportedFormats: ").append(toIndentedString(supportedFormats)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

