/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Ruleset
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class Ruleset {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("version")
  private Integer version = null;

  /**
   * Type of the ruleset. Searchable as Choice.
   */
  public enum TypeEnum {
    LOCAL_FILE("local-file"),
    
    LOCAL_HASH("local-hash"),
    
    SHARED_FILE("shared-file"),
    
    SHARED_HASH("shared-hash");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("created")
  private Long created = null;

  @JsonProperty("lastUpdated")
  private Long lastUpdated = null;

  @JsonProperty("ID")
  private Long ID = null;

  public Ruleset name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of the ruleset. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of the ruleset. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Ruleset description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the ruleset. Searchable as String.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the ruleset. Searchable as String.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Version number of the ruleset. Incremented by one whenever the ruleset rules are modified. Searchable as Numeric.
   * @return version
  **/
  @ApiModelProperty(value = "Version number of the ruleset. Incremented by one whenever the ruleset rules are modified. Searchable as Numeric.")
  public Integer getVersion() {
    return version;
  }

   /**
   * Type of the ruleset. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(value = "Type of the ruleset. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

   /**
   * Timestamp of the ruleset&#39;s creation, in milliseconds since epoch. Searchable as Date.
   * @return created
  **/
  @ApiModelProperty(value = "Timestamp of the ruleset's creation, in milliseconds since epoch. Searchable as Date.")
  public Long getCreated() {
    return created;
  }

   /**
   * Timestamp of when the ruleset was last updated, in milliseconds since epoch. Searchable as Date.
   * @return lastUpdated
  **/
  @ApiModelProperty(value = "Timestamp of when the ruleset was last updated, in milliseconds since epoch. Searchable as Date.")
  public Long getLastUpdated() {
    return lastUpdated;
  }

   /**
   * ID of the ruleset. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of the ruleset. Searchable as ID.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Ruleset ruleset = (Ruleset) o;
    return Objects.equals(this.name, ruleset.name) &&
        Objects.equals(this.description, ruleset.description) &&
        Objects.equals(this.version, ruleset.version) &&
        Objects.equals(this.type, ruleset.type) &&
        Objects.equals(this.created, ruleset.created) &&
        Objects.equals(this.lastUpdated, ruleset.lastUpdated) &&
        Objects.equals(this.ID, ruleset.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, version, type, created, lastUpdated, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Ruleset {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastUpdated: ").append(toIndentedString(lastUpdated)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

