/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.CheckForSecurityUpdatesTaskParameters;
import com.trendmicro.deepsecurity.model.DiscoverComputersTaskParameters;
import com.trendmicro.deepsecurity.model.GenerateReportTaskParameters;
import com.trendmicro.deepsecurity.model.RunScriptTaskParameters;
import com.trendmicro.deepsecurity.model.ScanForIntegrityChangesTaskParameters;
import com.trendmicro.deepsecurity.model.ScanForMalwareTaskParameters;
import com.trendmicro.deepsecurity.model.ScanForOpenPortsTaskParameters;
import com.trendmicro.deepsecurity.model.ScanForRecommendationsTaskParameters;
import com.trendmicro.deepsecurity.model.ScheduleDetails;
import com.trendmicro.deepsecurity.model.SendAlertSummaryTaskParameters;
import com.trendmicro.deepsecurity.model.SendPolicyTaskParameters;
import com.trendmicro.deepsecurity.model.SynchronizeCloudAccountTaskParameters;
import com.trendmicro.deepsecurity.model.SynchronizeDirectoryTaskParameters;
import com.trendmicro.deepsecurity.model.SynchronizeVCenterTaskParameters;
import com.trendmicro.deepsecurity.model.UpdateSuspiciousObjectsListTaskParameters;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Defines a scheduled task. Scheduled tasks automatically perform specific Deep Security Manager tasks on a schedule.
 */
@ApiModel(description = "Defines a scheduled task. Scheduled tasks automatically perform specific Deep Security Manager tasks on a schedule.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class ScheduledTask {
  @JsonProperty("name")
  private String name = null;

  /**
   * Type of scheduled task. Searchable as Choice.
   */
  public enum TypeEnum {
    SCAN_FOR_OPEN_PORTS("scan-for-open-ports"),
    
    SEND_ALERT_SUMMARY("send-alert-summary"),
    
    DISCOVER_COMPUTERS("discover-computers"),
    
    RUN_SCRIPT("run-script"),
    
    SEND_POLICY("send-policy"),
    
    GENERATE_REPORT("generate-report"),
    
    SYNCHRONIZE_DIRECTORY("synchronize-directory"),
    
    SYNCHRONIZE_USERS("synchronize-users"),
    
    SCAN_FOR_RECOMMENDATIONS("scan-for-recommendations"),
    
    SYNCHRONIZE_VCENTER("synchronize-vcenter"),
    
    SCAN_FOR_INTEGRITY_CHANGES("scan-for-integrity-changes"),
    
    SCAN_FOR_MALWARE("scan-for-malware"),
    
    CHECK_FOR_SECURITY_UPDATES("check-for-security-updates"),
    
    SYNCHRONIZE_CLOUD_ACCOUNT("synchronize-cloud-account"),
    
    CHECK_FOR_SOFTWARE_UPDATES("check-for-software-updates"),
    
    UPDATE_SUSPICIOUS_OBJECTS_LIST("update-suspicious-objects-list");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("scheduleDetails")
  private ScheduleDetails scheduleDetails = null;

  @JsonProperty("enabled")
  private Boolean enabled = null;

  @JsonProperty("lastRunTime")
  private Long lastRunTime = null;

  @JsonProperty("nextRunTime")
  private Long nextRunTime = null;

  @JsonProperty("runNow")
  private Boolean runNow = null;

  @JsonProperty("scanForOpenPortsTaskParameters")
  private ScanForOpenPortsTaskParameters scanForOpenPortsTaskParameters = null;

  @JsonProperty("sendAlertSummaryTaskParameters")
  private SendAlertSummaryTaskParameters sendAlertSummaryTaskParameters = null;

  @JsonProperty("discoverComputersTaskParameters")
  private DiscoverComputersTaskParameters discoverComputersTaskParameters = null;

  @JsonProperty("runScriptTaskParameters")
  private RunScriptTaskParameters runScriptTaskParameters = null;

  @JsonProperty("sendPolicyTaskParameters")
  private SendPolicyTaskParameters sendPolicyTaskParameters = null;

  @JsonProperty("generateReportTaskParameters")
  private GenerateReportTaskParameters generateReportTaskParameters = null;

  @JsonProperty("synchronizeDirectoryTaskParameters")
  private SynchronizeDirectoryTaskParameters synchronizeDirectoryTaskParameters = null;

  @JsonProperty("scanForRecommendationsTaskParameters")
  private ScanForRecommendationsTaskParameters scanForRecommendationsTaskParameters = null;

  @JsonProperty("synchronizeVCenterTaskParameters")
  private SynchronizeVCenterTaskParameters synchronizeVCenterTaskParameters = null;

  @JsonProperty("scanForIntegrityChangesTaskParameters")
  private ScanForIntegrityChangesTaskParameters scanForIntegrityChangesTaskParameters = null;

  @JsonProperty("scanForMalwareTaskParameters")
  private ScanForMalwareTaskParameters scanForMalwareTaskParameters = null;

  @JsonProperty("checkForSecurityUpdatesTaskParameters")
  private CheckForSecurityUpdatesTaskParameters checkForSecurityUpdatesTaskParameters = null;

  @JsonProperty("synchronizeCloudAccountTaskParameters")
  private SynchronizeCloudAccountTaskParameters synchronizeCloudAccountTaskParameters = null;

  @JsonProperty("updateSuspiciousObjectsListTaskParameters")
  private UpdateSuspiciousObjectsListTaskParameters updateSuspiciousObjectsListTaskParameters = null;

  @JsonProperty("ID")
  private Integer ID = null;

  public ScheduledTask name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of scheduled task. Searchable as String.
   * @return name
  **/
  @ApiModelProperty(value = "Name of scheduled task. Searchable as String.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ScheduledTask type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Type of scheduled task. Searchable as Choice.
   * @return type
  **/
  @ApiModelProperty(value = "Type of scheduled task. Searchable as Choice.")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public ScheduledTask scheduleDetails(ScheduleDetails scheduleDetails) {
    this.scheduleDetails = scheduleDetails;
    return this;
  }

   /**
   * Get scheduleDetails
   * @return scheduleDetails
  **/
  @ApiModelProperty(value = "")
  public ScheduleDetails getScheduleDetails() {
    return scheduleDetails;
  }

  public void setScheduleDetails(ScheduleDetails scheduleDetails) {
    this.scheduleDetails = scheduleDetails;
  }

  public ScheduledTask enabled(Boolean enabled) {
    this.enabled = enabled;
    return this;
  }

   /**
   * Indicates whether or not the scheduled task is enabled. Searchable as Boolean.
   * @return enabled
  **/
  @ApiModelProperty(value = "Indicates whether or not the scheduled task is enabled. Searchable as Boolean.")
  public Boolean isEnabled() {
    return enabled;
  }

  public void setEnabled(Boolean enabled) {
    this.enabled = enabled;
  }

  public ScheduledTask lastRunTime(Long lastRunTime) {
    this.lastRunTime = lastRunTime;
    return this;
  }

   /**
   * The last time this scheduled task was run, or null if never run. Searchable as Date.
   * @return lastRunTime
  **/
  @ApiModelProperty(value = "The last time this scheduled task was run, or null if never run. Searchable as Date.")
  public Long getLastRunTime() {
    return lastRunTime;
  }

  public void setLastRunTime(Long lastRunTime) {
    this.lastRunTime = lastRunTime;
  }

  public ScheduledTask nextRunTime(Long nextRunTime) {
    this.nextRunTime = nextRunTime;
    return this;
  }

   /**
   * The next time this scheduled task is scheduled to run, or null if it not scheduled to run in the future. Searchable as Date.
   * @return nextRunTime
  **/
  @ApiModelProperty(value = "The next time this scheduled task is scheduled to run, or null if it not scheduled to run in the future. Searchable as Date.")
  public Long getNextRunTime() {
    return nextRunTime;
  }

  public void setNextRunTime(Long nextRunTime) {
    this.nextRunTime = nextRunTime;
  }

  public ScheduledTask runNow(Boolean runNow) {
    this.runNow = runNow;
    return this;
  }

   /**
   * Indicates that the scheduled task should execute immediately.
   * @return runNow
  **/
  @ApiModelProperty(value = "Indicates that the scheduled task should execute immediately.")
  public Boolean isRunNow() {
    return runNow;
  }

  public void setRunNow(Boolean runNow) {
    this.runNow = runNow;
  }

  public ScheduledTask scanForOpenPortsTaskParameters(ScanForOpenPortsTaskParameters scanForOpenPortsTaskParameters) {
    this.scanForOpenPortsTaskParameters = scanForOpenPortsTaskParameters;
    return this;
  }

   /**
   * Get scanForOpenPortsTaskParameters
   * @return scanForOpenPortsTaskParameters
  **/
  @ApiModelProperty(value = "")
  public ScanForOpenPortsTaskParameters getScanForOpenPortsTaskParameters() {
    return scanForOpenPortsTaskParameters;
  }

  public void setScanForOpenPortsTaskParameters(ScanForOpenPortsTaskParameters scanForOpenPortsTaskParameters) {
    this.scanForOpenPortsTaskParameters = scanForOpenPortsTaskParameters;
  }

  public ScheduledTask sendAlertSummaryTaskParameters(SendAlertSummaryTaskParameters sendAlertSummaryTaskParameters) {
    this.sendAlertSummaryTaskParameters = sendAlertSummaryTaskParameters;
    return this;
  }

   /**
   * Get sendAlertSummaryTaskParameters
   * @return sendAlertSummaryTaskParameters
  **/
  @ApiModelProperty(value = "")
  public SendAlertSummaryTaskParameters getSendAlertSummaryTaskParameters() {
    return sendAlertSummaryTaskParameters;
  }

  public void setSendAlertSummaryTaskParameters(SendAlertSummaryTaskParameters sendAlertSummaryTaskParameters) {
    this.sendAlertSummaryTaskParameters = sendAlertSummaryTaskParameters;
  }

  public ScheduledTask discoverComputersTaskParameters(DiscoverComputersTaskParameters discoverComputersTaskParameters) {
    this.discoverComputersTaskParameters = discoverComputersTaskParameters;
    return this;
  }

   /**
   * Get discoverComputersTaskParameters
   * @return discoverComputersTaskParameters
  **/
  @ApiModelProperty(value = "")
  public DiscoverComputersTaskParameters getDiscoverComputersTaskParameters() {
    return discoverComputersTaskParameters;
  }

  public void setDiscoverComputersTaskParameters(DiscoverComputersTaskParameters discoverComputersTaskParameters) {
    this.discoverComputersTaskParameters = discoverComputersTaskParameters;
  }

  public ScheduledTask runScriptTaskParameters(RunScriptTaskParameters runScriptTaskParameters) {
    this.runScriptTaskParameters = runScriptTaskParameters;
    return this;
  }

   /**
   * Get runScriptTaskParameters
   * @return runScriptTaskParameters
  **/
  @ApiModelProperty(value = "")
  public RunScriptTaskParameters getRunScriptTaskParameters() {
    return runScriptTaskParameters;
  }

  public void setRunScriptTaskParameters(RunScriptTaskParameters runScriptTaskParameters) {
    this.runScriptTaskParameters = runScriptTaskParameters;
  }

  public ScheduledTask sendPolicyTaskParameters(SendPolicyTaskParameters sendPolicyTaskParameters) {
    this.sendPolicyTaskParameters = sendPolicyTaskParameters;
    return this;
  }

   /**
   * Get sendPolicyTaskParameters
   * @return sendPolicyTaskParameters
  **/
  @ApiModelProperty(value = "")
  public SendPolicyTaskParameters getSendPolicyTaskParameters() {
    return sendPolicyTaskParameters;
  }

  public void setSendPolicyTaskParameters(SendPolicyTaskParameters sendPolicyTaskParameters) {
    this.sendPolicyTaskParameters = sendPolicyTaskParameters;
  }

  public ScheduledTask generateReportTaskParameters(GenerateReportTaskParameters generateReportTaskParameters) {
    this.generateReportTaskParameters = generateReportTaskParameters;
    return this;
  }

   /**
   * Get generateReportTaskParameters
   * @return generateReportTaskParameters
  **/
  @ApiModelProperty(value = "")
  public GenerateReportTaskParameters getGenerateReportTaskParameters() {
    return generateReportTaskParameters;
  }

  public void setGenerateReportTaskParameters(GenerateReportTaskParameters generateReportTaskParameters) {
    this.generateReportTaskParameters = generateReportTaskParameters;
  }

  public ScheduledTask synchronizeDirectoryTaskParameters(SynchronizeDirectoryTaskParameters synchronizeDirectoryTaskParameters) {
    this.synchronizeDirectoryTaskParameters = synchronizeDirectoryTaskParameters;
    return this;
  }

   /**
   * Get synchronizeDirectoryTaskParameters
   * @return synchronizeDirectoryTaskParameters
  **/
  @ApiModelProperty(value = "")
  public SynchronizeDirectoryTaskParameters getSynchronizeDirectoryTaskParameters() {
    return synchronizeDirectoryTaskParameters;
  }

  public void setSynchronizeDirectoryTaskParameters(SynchronizeDirectoryTaskParameters synchronizeDirectoryTaskParameters) {
    this.synchronizeDirectoryTaskParameters = synchronizeDirectoryTaskParameters;
  }

  public ScheduledTask scanForRecommendationsTaskParameters(ScanForRecommendationsTaskParameters scanForRecommendationsTaskParameters) {
    this.scanForRecommendationsTaskParameters = scanForRecommendationsTaskParameters;
    return this;
  }

   /**
   * Get scanForRecommendationsTaskParameters
   * @return scanForRecommendationsTaskParameters
  **/
  @ApiModelProperty(value = "")
  public ScanForRecommendationsTaskParameters getScanForRecommendationsTaskParameters() {
    return scanForRecommendationsTaskParameters;
  }

  public void setScanForRecommendationsTaskParameters(ScanForRecommendationsTaskParameters scanForRecommendationsTaskParameters) {
    this.scanForRecommendationsTaskParameters = scanForRecommendationsTaskParameters;
  }

  public ScheduledTask synchronizeVCenterTaskParameters(SynchronizeVCenterTaskParameters synchronizeVCenterTaskParameters) {
    this.synchronizeVCenterTaskParameters = synchronizeVCenterTaskParameters;
    return this;
  }

   /**
   * Get synchronizeVCenterTaskParameters
   * @return synchronizeVCenterTaskParameters
  **/
  @ApiModelProperty(value = "")
  public SynchronizeVCenterTaskParameters getSynchronizeVCenterTaskParameters() {
    return synchronizeVCenterTaskParameters;
  }

  public void setSynchronizeVCenterTaskParameters(SynchronizeVCenterTaskParameters synchronizeVCenterTaskParameters) {
    this.synchronizeVCenterTaskParameters = synchronizeVCenterTaskParameters;
  }

  public ScheduledTask scanForIntegrityChangesTaskParameters(ScanForIntegrityChangesTaskParameters scanForIntegrityChangesTaskParameters) {
    this.scanForIntegrityChangesTaskParameters = scanForIntegrityChangesTaskParameters;
    return this;
  }

   /**
   * Get scanForIntegrityChangesTaskParameters
   * @return scanForIntegrityChangesTaskParameters
  **/
  @ApiModelProperty(value = "")
  public ScanForIntegrityChangesTaskParameters getScanForIntegrityChangesTaskParameters() {
    return scanForIntegrityChangesTaskParameters;
  }

  public void setScanForIntegrityChangesTaskParameters(ScanForIntegrityChangesTaskParameters scanForIntegrityChangesTaskParameters) {
    this.scanForIntegrityChangesTaskParameters = scanForIntegrityChangesTaskParameters;
  }

  public ScheduledTask scanForMalwareTaskParameters(ScanForMalwareTaskParameters scanForMalwareTaskParameters) {
    this.scanForMalwareTaskParameters = scanForMalwareTaskParameters;
    return this;
  }

   /**
   * Get scanForMalwareTaskParameters
   * @return scanForMalwareTaskParameters
  **/
  @ApiModelProperty(value = "")
  public ScanForMalwareTaskParameters getScanForMalwareTaskParameters() {
    return scanForMalwareTaskParameters;
  }

  public void setScanForMalwareTaskParameters(ScanForMalwareTaskParameters scanForMalwareTaskParameters) {
    this.scanForMalwareTaskParameters = scanForMalwareTaskParameters;
  }

  public ScheduledTask checkForSecurityUpdatesTaskParameters(CheckForSecurityUpdatesTaskParameters checkForSecurityUpdatesTaskParameters) {
    this.checkForSecurityUpdatesTaskParameters = checkForSecurityUpdatesTaskParameters;
    return this;
  }

   /**
   * Get checkForSecurityUpdatesTaskParameters
   * @return checkForSecurityUpdatesTaskParameters
  **/
  @ApiModelProperty(value = "")
  public CheckForSecurityUpdatesTaskParameters getCheckForSecurityUpdatesTaskParameters() {
    return checkForSecurityUpdatesTaskParameters;
  }

  public void setCheckForSecurityUpdatesTaskParameters(CheckForSecurityUpdatesTaskParameters checkForSecurityUpdatesTaskParameters) {
    this.checkForSecurityUpdatesTaskParameters = checkForSecurityUpdatesTaskParameters;
  }

  public ScheduledTask synchronizeCloudAccountTaskParameters(SynchronizeCloudAccountTaskParameters synchronizeCloudAccountTaskParameters) {
    this.synchronizeCloudAccountTaskParameters = synchronizeCloudAccountTaskParameters;
    return this;
  }

   /**
   * Get synchronizeCloudAccountTaskParameters
   * @return synchronizeCloudAccountTaskParameters
  **/
  @ApiModelProperty(value = "")
  public SynchronizeCloudAccountTaskParameters getSynchronizeCloudAccountTaskParameters() {
    return synchronizeCloudAccountTaskParameters;
  }

  public void setSynchronizeCloudAccountTaskParameters(SynchronizeCloudAccountTaskParameters synchronizeCloudAccountTaskParameters) {
    this.synchronizeCloudAccountTaskParameters = synchronizeCloudAccountTaskParameters;
  }

  public ScheduledTask updateSuspiciousObjectsListTaskParameters(UpdateSuspiciousObjectsListTaskParameters updateSuspiciousObjectsListTaskParameters) {
    this.updateSuspiciousObjectsListTaskParameters = updateSuspiciousObjectsListTaskParameters;
    return this;
  }

   /**
   * Get updateSuspiciousObjectsListTaskParameters
   * @return updateSuspiciousObjectsListTaskParameters
  **/
  @ApiModelProperty(value = "")
  public UpdateSuspiciousObjectsListTaskParameters getUpdateSuspiciousObjectsListTaskParameters() {
    return updateSuspiciousObjectsListTaskParameters;
  }

  public void setUpdateSuspiciousObjectsListTaskParameters(UpdateSuspiciousObjectsListTaskParameters updateSuspiciousObjectsListTaskParameters) {
    this.updateSuspiciousObjectsListTaskParameters = updateSuspiciousObjectsListTaskParameters;
  }

   /**
   * Scheduled task identifier. Searchable as ID.
   * @return ID
  **/
  @ApiModelProperty(value = "Scheduled task identifier. Searchable as ID.")
  public Integer getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ScheduledTask scheduledTask = (ScheduledTask) o;
    return Objects.equals(this.name, scheduledTask.name) &&
        Objects.equals(this.type, scheduledTask.type) &&
        Objects.equals(this.scheduleDetails, scheduledTask.scheduleDetails) &&
        Objects.equals(this.enabled, scheduledTask.enabled) &&
        Objects.equals(this.lastRunTime, scheduledTask.lastRunTime) &&
        Objects.equals(this.nextRunTime, scheduledTask.nextRunTime) &&
        Objects.equals(this.runNow, scheduledTask.runNow) &&
        Objects.equals(this.scanForOpenPortsTaskParameters, scheduledTask.scanForOpenPortsTaskParameters) &&
        Objects.equals(this.sendAlertSummaryTaskParameters, scheduledTask.sendAlertSummaryTaskParameters) &&
        Objects.equals(this.discoverComputersTaskParameters, scheduledTask.discoverComputersTaskParameters) &&
        Objects.equals(this.runScriptTaskParameters, scheduledTask.runScriptTaskParameters) &&
        Objects.equals(this.sendPolicyTaskParameters, scheduledTask.sendPolicyTaskParameters) &&
        Objects.equals(this.generateReportTaskParameters, scheduledTask.generateReportTaskParameters) &&
        Objects.equals(this.synchronizeDirectoryTaskParameters, scheduledTask.synchronizeDirectoryTaskParameters) &&
        Objects.equals(this.scanForRecommendationsTaskParameters, scheduledTask.scanForRecommendationsTaskParameters) &&
        Objects.equals(this.synchronizeVCenterTaskParameters, scheduledTask.synchronizeVCenterTaskParameters) &&
        Objects.equals(this.scanForIntegrityChangesTaskParameters, scheduledTask.scanForIntegrityChangesTaskParameters) &&
        Objects.equals(this.scanForMalwareTaskParameters, scheduledTask.scanForMalwareTaskParameters) &&
        Objects.equals(this.checkForSecurityUpdatesTaskParameters, scheduledTask.checkForSecurityUpdatesTaskParameters) &&
        Objects.equals(this.synchronizeCloudAccountTaskParameters, scheduledTask.synchronizeCloudAccountTaskParameters) &&
        Objects.equals(this.updateSuspiciousObjectsListTaskParameters, scheduledTask.updateSuspiciousObjectsListTaskParameters) &&
        Objects.equals(this.ID, scheduledTask.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type, scheduleDetails, enabled, lastRunTime, nextRunTime, runNow, scanForOpenPortsTaskParameters, sendAlertSummaryTaskParameters, discoverComputersTaskParameters, runScriptTaskParameters, sendPolicyTaskParameters, generateReportTaskParameters, synchronizeDirectoryTaskParameters, scanForRecommendationsTaskParameters, synchronizeVCenterTaskParameters, scanForIntegrityChangesTaskParameters, scanForMalwareTaskParameters, checkForSecurityUpdatesTaskParameters, synchronizeCloudAccountTaskParameters, updateSuspiciousObjectsListTaskParameters, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ScheduledTask {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    scheduleDetails: ").append(toIndentedString(scheduleDetails)).append("\n");
    sb.append("    enabled: ").append(toIndentedString(enabled)).append("\n");
    sb.append("    lastRunTime: ").append(toIndentedString(lastRunTime)).append("\n");
    sb.append("    nextRunTime: ").append(toIndentedString(nextRunTime)).append("\n");
    sb.append("    runNow: ").append(toIndentedString(runNow)).append("\n");
    sb.append("    scanForOpenPortsTaskParameters: ").append(toIndentedString(scanForOpenPortsTaskParameters)).append("\n");
    sb.append("    sendAlertSummaryTaskParameters: ").append(toIndentedString(sendAlertSummaryTaskParameters)).append("\n");
    sb.append("    discoverComputersTaskParameters: ").append(toIndentedString(discoverComputersTaskParameters)).append("\n");
    sb.append("    runScriptTaskParameters: ").append(toIndentedString(runScriptTaskParameters)).append("\n");
    sb.append("    sendPolicyTaskParameters: ").append(toIndentedString(sendPolicyTaskParameters)).append("\n");
    sb.append("    generateReportTaskParameters: ").append(toIndentedString(generateReportTaskParameters)).append("\n");
    sb.append("    synchronizeDirectoryTaskParameters: ").append(toIndentedString(synchronizeDirectoryTaskParameters)).append("\n");
    sb.append("    scanForRecommendationsTaskParameters: ").append(toIndentedString(scanForRecommendationsTaskParameters)).append("\n");
    sb.append("    synchronizeVCenterTaskParameters: ").append(toIndentedString(synchronizeVCenterTaskParameters)).append("\n");
    sb.append("    scanForIntegrityChangesTaskParameters: ").append(toIndentedString(scanForIntegrityChangesTaskParameters)).append("\n");
    sb.append("    scanForMalwareTaskParameters: ").append(toIndentedString(scanForMalwareTaskParameters)).append("\n");
    sb.append("    checkForSecurityUpdatesTaskParameters: ").append(toIndentedString(checkForSecurityUpdatesTaskParameters)).append("\n");
    sb.append("    synchronizeCloudAccountTaskParameters: ").append(toIndentedString(synchronizeCloudAccountTaskParameters)).append("\n");
    sb.append("    updateSuspiciousObjectsListTaskParameters: ").append(toIndentedString(updateSuspiciousObjectsListTaskParameters)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

