/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Defines search criteria for use within a SearchFilter. Identifies the field of an object to test, the value to test against, and the type of test to perform, such as \\\&quot;equal\&quot;\\ or \\\&quot;greater-than\&quot;\\.
 */
@ApiModel(description = "Defines search criteria for use within a SearchFilter. Identifies the field of an object to test, the value to test against, and the type of test to perform, such as \\\"equal\"\\ or \\\"greater-than\"\\.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class SearchCriteria {
  @JsonProperty("fieldName")
  private String fieldName = null;

  @JsonProperty("booleanTest")
  private Boolean booleanTest = null;

  /**
   * Numeric test, suitable for numeric fields, used in conjuction with the numericValue. Default \&quot;equal\&quot;.
   */
  public enum NumericTestEnum {
    LESS_THAN("less-than"),
    
    LESS_THAN_OR_EQUAL("less-than-or-equal"),
    
    EQUAL("equal"),
    
    GREATER_THAN_OR_EQUAL("greater-than-or-equal"),
    
    GREATER_THAN("greater-than"),
    
    NOT_EQUAL("not-equal");

    private String value;

    NumericTestEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static NumericTestEnum fromValue(String text) {
      for (NumericTestEnum b : NumericTestEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("numericTest")
  private NumericTestEnum numericTest = null;

  @JsonProperty("numericValue")
  private Double numericValue = null;

  /**
   * String test, suitable for string fields, used in conjuction with the stringValue and stringWildcards. Default \&quot;equal\&quot;.
   */
  public enum StringTestEnum {
    EQUAL("equal"),
    
    NOT_EQUAL("not-equal");

    private String value;

    StringTestEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StringTestEnum fromValue(String text) {
      for (StringTestEnum b : StringTestEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("stringTest")
  private StringTestEnum stringTest = null;

  @JsonProperty("stringValue")
  private String stringValue = null;

  @JsonProperty("stringWildcards")
  private Boolean stringWildcards = null;

  /**
   * Choice test, suitable for enum fields, used in conjuction with the choiceValue. Default \&quot;equal\&quot;.
   */
  public enum ChoiceTestEnum {
    EQUAL("equal"),
    
    NOT_EQUAL("not-equal");

    private String value;

    ChoiceTestEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ChoiceTestEnum fromValue(String text) {
      for (ChoiceTestEnum b : ChoiceTestEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("choiceTest")
  private ChoiceTestEnum choiceTest = null;

  @JsonProperty("choiceValue")
  private String choiceValue = null;

  @JsonProperty("firstDateValue")
  private Long firstDateValue = null;

  @JsonProperty("firstDateInclusive")
  private Boolean firstDateInclusive = null;

  @JsonProperty("lastDateValue")
  private Long lastDateValue = null;

  @JsonProperty("lastDateInclusive")
  private Boolean lastDateInclusive = null;

  @JsonProperty("nullTest")
  private Boolean nullTest = null;

  /**
   * Version test, suitable for version fields, used in conjuction with the versionValue. Default \&quot;equal\&quot;.
   */
  public enum VersionTestEnum {
    LESS_THAN("less-than"),
    
    LESS_THAN_OR_EQUAL("less-than-or-equal"),
    
    EQUAL("equal"),
    
    GREATER_THAN_OR_EQUAL("greater-than-or-equal"),
    
    GREATER_THAN("greater-than"),
    
    NOT_EQUAL("not-equal");

    private String value;

    VersionTestEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static VersionTestEnum fromValue(String text) {
      for (VersionTestEnum b : VersionTestEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("versionTest")
  private VersionTestEnum versionTest = null;

  @JsonProperty("versionValue")
  private String versionValue = null;

  @JsonProperty("idValue")
  private Long idValue = null;

  /**
   * Gets or Sets idTest
   */
  public enum IdTestEnum {
    LESS_THAN("less-than"),
    
    LESS_THAN_OR_EQUAL("less-than-or-equal"),
    
    EQUAL("equal"),
    
    GREATER_THAN_OR_EQUAL("greater-than-or-equal"),
    
    GREATER_THAN("greater-than"),
    
    NOT_EQUAL("not-equal");

    private String value;

    IdTestEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static IdTestEnum fromValue(String text) {
      for (IdTestEnum b : IdTestEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("idTest")
  private IdTestEnum idTest = null;

  public SearchCriteria fieldName(String fieldName) {
    this.fieldName = fieldName;
    return this;
  }

   /**
   * Name of the field to be tested. Required for all tests except idTest.
   * @return fieldName
  **/
  @ApiModelProperty(value = "Name of the field to be tested. Required for all tests except idTest.")
  public String getFieldName() {
    return fieldName;
  }

  public void setFieldName(String fieldName) {
    this.fieldName = fieldName;
  }

  public SearchCriteria booleanTest(Boolean booleanTest) {
    this.booleanTest = booleanTest;
    return this;
  }

   /**
   * Boolean test, suitable for boolean fields. Default \&quot;true\&quot;.
   * @return booleanTest
  **/
  @ApiModelProperty(value = "Boolean test, suitable for boolean fields. Default \"true\".")
  public Boolean isBooleanTest() {
    return booleanTest;
  }

  public void setBooleanTest(Boolean booleanTest) {
    this.booleanTest = booleanTest;
  }

  public SearchCriteria numericTest(NumericTestEnum numericTest) {
    this.numericTest = numericTest;
    return this;
  }

   /**
   * Numeric test, suitable for numeric fields, used in conjuction with the numericValue. Default \&quot;equal\&quot;.
   * @return numericTest
  **/
  @ApiModelProperty(value = "Numeric test, suitable for numeric fields, used in conjuction with the numericValue. Default \"equal\".")
  public NumericTestEnum getNumericTest() {
    return numericTest;
  }

  public void setNumericTest(NumericTestEnum numericTest) {
    this.numericTest = numericTest;
  }

  public SearchCriteria numericValue(Double numericValue) {
    this.numericValue = numericValue;
    return this;
  }

   /**
   * Value used by the numericTest. Required when performing a numericTest.
   * @return numericValue
  **/
  @ApiModelProperty(value = "Value used by the numericTest. Required when performing a numericTest.")
  public Double getNumericValue() {
    return numericValue;
  }

  public void setNumericValue(Double numericValue) {
    this.numericValue = numericValue;
  }

  public SearchCriteria stringTest(StringTestEnum stringTest) {
    this.stringTest = stringTest;
    return this;
  }

   /**
   * String test, suitable for string fields, used in conjuction with the stringValue and stringWildcards. Default \&quot;equal\&quot;.
   * @return stringTest
  **/
  @ApiModelProperty(value = "String test, suitable for string fields, used in conjuction with the stringValue and stringWildcards. Default \"equal\".")
  public StringTestEnum getStringTest() {
    return stringTest;
  }

  public void setStringTest(StringTestEnum stringTest) {
    this.stringTest = stringTest;
  }

  public SearchCriteria stringValue(String stringValue) {
    this.stringValue = stringValue;
    return this;
  }

   /**
   * Value used by the stringTest. Required when performing a stringTest.
   * @return stringValue
  **/
  @ApiModelProperty(value = "Value used by the stringTest. Required when performing a stringTest.")
  public String getStringValue() {
    return stringValue;
  }

  public void setStringValue(String stringValue) {
    this.stringValue = stringValue;
  }

  public SearchCriteria stringWildcards(Boolean stringWildcards) {
    this.stringWildcards = stringWildcards;
    return this;
  }

   /**
   * Controls whether or not wildcard characters (&#x60;%&#x60; and &#x60;_&#x60;) are treated as wildcards (true) or regular characters (false). Default \&quot;true\&quot;.
   * @return stringWildcards
  **/
  @ApiModelProperty(value = "Controls whether or not wildcard characters (`%` and `_`) are treated as wildcards (true) or regular characters (false). Default \"true\".")
  public Boolean isStringWildcards() {
    return stringWildcards;
  }

  public void setStringWildcards(Boolean stringWildcards) {
    this.stringWildcards = stringWildcards;
  }

  public SearchCriteria choiceTest(ChoiceTestEnum choiceTest) {
    this.choiceTest = choiceTest;
    return this;
  }

   /**
   * Choice test, suitable for enum fields, used in conjuction with the choiceValue. Default \&quot;equal\&quot;.
   * @return choiceTest
  **/
  @ApiModelProperty(value = "Choice test, suitable for enum fields, used in conjuction with the choiceValue. Default \"equal\".")
  public ChoiceTestEnum getChoiceTest() {
    return choiceTest;
  }

  public void setChoiceTest(ChoiceTestEnum choiceTest) {
    this.choiceTest = choiceTest;
  }

  public SearchCriteria choiceValue(String choiceValue) {
    this.choiceValue = choiceValue;
    return this;
  }

   /**
   * Value used by the choiceTest. Required when performing a choiceTest.
   * @return choiceValue
  **/
  @ApiModelProperty(value = "Value used by the choiceTest. Required when performing a choiceTest.")
  public String getChoiceValue() {
    return choiceValue;
  }

  public void setChoiceValue(String choiceValue) {
    this.choiceValue = choiceValue;
  }

  public SearchCriteria firstDateValue(Long firstDateValue) {
    this.firstDateValue = firstDateValue;
    return this;
  }

   /**
   * First (low) date used to find objects within a date range.  Null (the default) implies no lower limit on the date range.
   * @return firstDateValue
  **/
  @ApiModelProperty(value = "First (low) date used to find objects within a date range.  Null (the default) implies no lower limit on the date range.")
  public Long getFirstDateValue() {
    return firstDateValue;
  }

  public void setFirstDateValue(Long firstDateValue) {
    this.firstDateValue = firstDateValue;
  }

  public SearchCriteria firstDateInclusive(Boolean firstDateInclusive) {
    this.firstDateInclusive = firstDateInclusive;
    return this;
  }

   /**
   * Indicates whether the results should include (true) or exclude (false) an exact match for the firstDateValue. Default \&quot;true\&quot;.
   * @return firstDateInclusive
  **/
  @ApiModelProperty(value = "Indicates whether the results should include (true) or exclude (false) an exact match for the firstDateValue. Default \"true\".")
  public Boolean isFirstDateInclusive() {
    return firstDateInclusive;
  }

  public void setFirstDateInclusive(Boolean firstDateInclusive) {
    this.firstDateInclusive = firstDateInclusive;
  }

  public SearchCriteria lastDateValue(Long lastDateValue) {
    this.lastDateValue = lastDateValue;
    return this;
  }

   /**
   * Last (high) date used to find objects within a date range.  Null (the default) implies no upper limit on the date range.
   * @return lastDateValue
  **/
  @ApiModelProperty(value = "Last (high) date used to find objects within a date range.  Null (the default) implies no upper limit on the date range.")
  public Long getLastDateValue() {
    return lastDateValue;
  }

  public void setLastDateValue(Long lastDateValue) {
    this.lastDateValue = lastDateValue;
  }

  public SearchCriteria lastDateInclusive(Boolean lastDateInclusive) {
    this.lastDateInclusive = lastDateInclusive;
    return this;
  }

   /**
   * Indicates whether the results should include (true) or exclude (false) an exact match for the lastDateValue. Default \&quot;true\&quot;.
   * @return lastDateInclusive
  **/
  @ApiModelProperty(value = "Indicates whether the results should include (true) or exclude (false) an exact match for the lastDateValue. Default \"true\".")
  public Boolean isLastDateInclusive() {
    return lastDateInclusive;
  }

  public void setLastDateInclusive(Boolean lastDateInclusive) {
    this.lastDateInclusive = lastDateInclusive;
  }

  public SearchCriteria nullTest(Boolean nullTest) {
    this.nullTest = nullTest;
    return this;
  }

   /**
   * Null test, suitable for finding fields containing a null value.
   * @return nullTest
  **/
  @ApiModelProperty(value = "Null test, suitable for finding fields containing a null value.")
  public Boolean isNullTest() {
    return nullTest;
  }

  public void setNullTest(Boolean nullTest) {
    this.nullTest = nullTest;
  }

  public SearchCriteria versionTest(VersionTestEnum versionTest) {
    this.versionTest = versionTest;
    return this;
  }

   /**
   * Version test, suitable for version fields, used in conjuction with the versionValue. Default \&quot;equal\&quot;.
   * @return versionTest
  **/
  @ApiModelProperty(value = "Version test, suitable for version fields, used in conjuction with the versionValue. Default \"equal\".")
  public VersionTestEnum getVersionTest() {
    return versionTest;
  }

  public void setVersionTest(VersionTestEnum versionTest) {
    this.versionTest = versionTest;
  }

  public SearchCriteria versionValue(String versionValue) {
    this.versionValue = versionValue;
    return this;
  }

   /**
   * Value used by the versionTest. Required when performing a versionTest.
   * @return versionValue
  **/
  @ApiModelProperty(value = "Value used by the versionTest. Required when performing a versionTest.")
  public String getVersionValue() {
    return versionValue;
  }

  public void setVersionValue(String versionValue) {
    this.versionValue = versionValue;
  }

  public SearchCriteria idValue(Long idValue) {
    this.idValue = idValue;
    return this;
  }

   /**
   * Get idValue
   * @return idValue
  **/
  @ApiModelProperty(value = "")
  public Long getIdValue() {
    return idValue;
  }

  public void setIdValue(Long idValue) {
    this.idValue = idValue;
  }

  public SearchCriteria idTest(IdTestEnum idTest) {
    this.idTest = idTest;
    return this;
  }

   /**
   * Get idTest
   * @return idTest
  **/
  @ApiModelProperty(value = "")
  public IdTestEnum getIdTest() {
    return idTest;
  }

  public void setIdTest(IdTestEnum idTest) {
    this.idTest = idTest;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchCriteria searchCriteria = (SearchCriteria) o;
    return Objects.equals(this.fieldName, searchCriteria.fieldName) &&
        Objects.equals(this.booleanTest, searchCriteria.booleanTest) &&
        Objects.equals(this.numericTest, searchCriteria.numericTest) &&
        Objects.equals(this.numericValue, searchCriteria.numericValue) &&
        Objects.equals(this.stringTest, searchCriteria.stringTest) &&
        Objects.equals(this.stringValue, searchCriteria.stringValue) &&
        Objects.equals(this.stringWildcards, searchCriteria.stringWildcards) &&
        Objects.equals(this.choiceTest, searchCriteria.choiceTest) &&
        Objects.equals(this.choiceValue, searchCriteria.choiceValue) &&
        Objects.equals(this.firstDateValue, searchCriteria.firstDateValue) &&
        Objects.equals(this.firstDateInclusive, searchCriteria.firstDateInclusive) &&
        Objects.equals(this.lastDateValue, searchCriteria.lastDateValue) &&
        Objects.equals(this.lastDateInclusive, searchCriteria.lastDateInclusive) &&
        Objects.equals(this.nullTest, searchCriteria.nullTest) &&
        Objects.equals(this.versionTest, searchCriteria.versionTest) &&
        Objects.equals(this.versionValue, searchCriteria.versionValue) &&
        Objects.equals(this.idValue, searchCriteria.idValue) &&
        Objects.equals(this.idTest, searchCriteria.idTest);
  }

  @Override
  public int hashCode() {
    return Objects.hash(fieldName, booleanTest, numericTest, numericValue, stringTest, stringValue, stringWildcards, choiceTest, choiceValue, firstDateValue, firstDateInclusive, lastDateValue, lastDateInclusive, nullTest, versionTest, versionValue, idValue, idTest);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchCriteria {\n");
    
    sb.append("    fieldName: ").append(toIndentedString(fieldName)).append("\n");
    sb.append("    booleanTest: ").append(toIndentedString(booleanTest)).append("\n");
    sb.append("    numericTest: ").append(toIndentedString(numericTest)).append("\n");
    sb.append("    numericValue: ").append(toIndentedString(numericValue)).append("\n");
    sb.append("    stringTest: ").append(toIndentedString(stringTest)).append("\n");
    sb.append("    stringValue: ").append(toIndentedString(stringValue)).append("\n");
    sb.append("    stringWildcards: ").append(toIndentedString(stringWildcards)).append("\n");
    sb.append("    choiceTest: ").append(toIndentedString(choiceTest)).append("\n");
    sb.append("    choiceValue: ").append(toIndentedString(choiceValue)).append("\n");
    sb.append("    firstDateValue: ").append(toIndentedString(firstDateValue)).append("\n");
    sb.append("    firstDateInclusive: ").append(toIndentedString(firstDateInclusive)).append("\n");
    sb.append("    lastDateValue: ").append(toIndentedString(lastDateValue)).append("\n");
    sb.append("    lastDateInclusive: ").append(toIndentedString(lastDateInclusive)).append("\n");
    sb.append("    nullTest: ").append(toIndentedString(nullTest)).append("\n");
    sb.append("    versionTest: ").append(toIndentedString(versionTest)).append("\n");
    sb.append("    versionValue: ").append(toIndentedString(versionValue)).append("\n");
    sb.append("    idValue: ").append(toIndentedString(idValue)).append("\n");
    sb.append("    idTest: ").append(toIndentedString(idTest)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

