/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.Component;
import com.trendmicro.deepsecurity.model.UpdateStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Security update details.
 */
@ApiModel(description = "Security update details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class SecurityUpdates {
  @JsonProperty("updateStatus")
  private UpdateStatus updateStatus = null;

  @JsonProperty("lastChanged")
  private Long lastChanged = null;

  @JsonProperty("rules")
  private List<Component> rules = null;

  @JsonProperty("antiMalware")
  private List<Component> antiMalware = null;

  @JsonProperty("webReputationService")
  private List<Component> webReputationService = null;

  @JsonProperty("manifests")
  private List<Component> manifests = null;

  @JsonProperty("other")
  private List<Component> other = null;

  public SecurityUpdates updateStatus(UpdateStatus updateStatus) {
    this.updateStatus = updateStatus;
    return this;
  }

   /**
   * Get updateStatus
   * @return updateStatus
  **/
  @ApiModelProperty(value = "")
  public UpdateStatus getUpdateStatus() {
    return updateStatus;
  }

  public void setUpdateStatus(UpdateStatus updateStatus) {
    this.updateStatus = updateStatus;
  }

   /**
   * Date when components were last updated, in milliseconds since epoch.
   * @return lastChanged
  **/
  @ApiModelProperty(value = "Date when components were last updated, in milliseconds since epoch.")
  public Long getLastChanged() {
    return lastChanged;
  }

   /**
   * Security update components: rules.
   * @return rules
  **/
  @ApiModelProperty(value = "Security update components: rules.")
  public List<Component> getRules() {
    return rules;
  }

   /**
   * Security update components: anti-malware.
   * @return antiMalware
  **/
  @ApiModelProperty(value = "Security update components: anti-malware.")
  public List<Component> getAntiMalware() {
    return antiMalware;
  }

   /**
   * Security update components: web reputation service.
   * @return webReputationService
  **/
  @ApiModelProperty(value = "Security update components: web reputation service.")
  public List<Component> getWebReputationService() {
    return webReputationService;
  }

   /**
   * Security update components: manifests.
   * @return manifests
  **/
  @ApiModelProperty(value = "Security update components: manifests.")
  public List<Component> getManifests() {
    return manifests;
  }

   /**
   * Security update components: other.
   * @return other
  **/
  @ApiModelProperty(value = "Security update components: other.")
  public List<Component> getOther() {
    return other;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SecurityUpdates securityUpdates = (SecurityUpdates) o;
    return Objects.equals(this.updateStatus, securityUpdates.updateStatus) &&
        Objects.equals(this.lastChanged, securityUpdates.lastChanged) &&
        Objects.equals(this.rules, securityUpdates.rules) &&
        Objects.equals(this.antiMalware, securityUpdates.antiMalware) &&
        Objects.equals(this.webReputationService, securityUpdates.webReputationService) &&
        Objects.equals(this.manifests, securityUpdates.manifests) &&
        Objects.equals(this.other, securityUpdates.other);
  }

  @Override
  public int hashCode() {
    return Objects.hash(updateStatus, lastChanged, rules, antiMalware, webReputationService, manifests, other);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SecurityUpdates {\n");
    
    sb.append("    updateStatus: ").append(toIndentedString(updateStatus)).append("\n");
    sb.append("    lastChanged: ").append(toIndentedString(lastChanged)).append("\n");
    sb.append("    rules: ").append(toIndentedString(rules)).append("\n");
    sb.append("    antiMalware: ").append(toIndentedString(antiMalware)).append("\n");
    sb.append("    webReputationService: ").append(toIndentedString(webReputationService)).append("\n");
    sb.append("    manifests: ").append(toIndentedString(manifests)).append("\n");
    sb.append("    other: ").append(toIndentedString(other)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

