/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;


/**
 * Details of SNS configuration. The configuration is used by the SNS forwarder to send events to a customer/tenant designated SNS topic.
 */
@ApiModel(description = "Details of SNS configuration. The configuration is used by the SNS forwarder to send events to a customer/tenant designated SNS topic.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class SnsConfiguration {
  @JsonProperty("accessKey")
  private String accessKey = null;

  @JsonProperty("secretKey")
  private String secretKey = null;

  @JsonProperty("topicARN")
  private String topicARN = null;

  @JsonProperty("advancedConfiguration")
  private String advancedConfiguration = null;

  @JsonProperty("forwardingEnabled")
  private Boolean forwardingEnabled = null;

  @JsonProperty("forwarderSnsStartSendDate")
  private LocalDateTime forwarderSnsStartSendDate = null;

  @JsonProperty("forwarderSnsEndSendDate")
  private LocalDateTime forwarderSnsEndSendDate = null;

  public SnsConfiguration accessKey(String accessKey) {
    this.accessKey = accessKey;
    return this;
  }

   /**
   * AWS access key that has permissions to write to the SNS topic.
   * @return accessKey
  **/
  @ApiModelProperty(value = "AWS access key that has permissions to write to the SNS topic.")
  public String getAccessKey() {
    return accessKey;
  }

  public void setAccessKey(String accessKey) {
    this.accessKey = accessKey;
  }

  public SnsConfiguration secretKey(String secretKey) {
    this.secretKey = secretKey;
    return this;
  }

   /**
   * AWS secret key.
   * @return secretKey
  **/
  @ApiModelProperty(value = "AWS secret key.")
  public String getSecretKey() {
    return secretKey;
  }

  public void setSecretKey(String secretKey) {
    this.secretKey = secretKey;
  }

  public SnsConfiguration topicARN(String topicARN) {
    this.topicARN = topicARN;
    return this;
  }

   /**
   * SNS topic to forward to. This should be provided by the customer/tenant.
   * @return topicARN
  **/
  @ApiModelProperty(value = "SNS topic to forward to. This should be provided by the customer/tenant.")
  public String getTopicARN() {
    return topicARN;
  }

  public void setTopicARN(String topicARN) {
    this.topicARN = topicARN;
  }

  public SnsConfiguration advancedConfiguration(String advancedConfiguration) {
    this.advancedConfiguration = advancedConfiguration;
    return this;
  }

   /**
   * JSON Configuration specifying customized forwarding rules.
   * @return advancedConfiguration
  **/
  @ApiModelProperty(value = "JSON Configuration specifying customized forwarding rules.")
  public String getAdvancedConfiguration() {
    return advancedConfiguration;
  }

  public void setAdvancedConfiguration(String advancedConfiguration) {
    this.advancedConfiguration = advancedConfiguration;
  }

  public SnsConfiguration forwardingEnabled(Boolean forwardingEnabled) {
    this.forwardingEnabled = forwardingEnabled;
    return this;
  }

   /**
   * Is SNS forwarding enabled for this tenant.
   * @return forwardingEnabled
  **/
  @ApiModelProperty(value = "Is SNS forwarding enabled for this tenant.")
  public Boolean isForwardingEnabled() {
    return forwardingEnabled;
  }

  public void setForwardingEnabled(Boolean forwardingEnabled) {
    this.forwardingEnabled = forwardingEnabled;
  }

  public SnsConfiguration forwarderSnsStartSendDate(LocalDateTime forwarderSnsStartSendDate) {
    this.forwarderSnsStartSendDate = forwarderSnsStartSendDate;
    return this;
  }

   /**
   * Feature flag to tell the SNS forwarder service when (event date) it should start event forwarding for the tenant
   * @return forwarderSnsStartSendDate
  **/
  @ApiModelProperty(value = "Feature flag to tell the SNS forwarder service when (event date) it should start event forwarding for the tenant")
  public LocalDateTime getForwarderSnsStartSendDate() {
    return forwarderSnsStartSendDate;
  }

  public void setForwarderSnsStartSendDate(LocalDateTime forwarderSnsStartSendDate) {
    this.forwarderSnsStartSendDate = forwarderSnsStartSendDate;
  }

  public SnsConfiguration forwarderSnsEndSendDate(LocalDateTime forwarderSnsEndSendDate) {
    this.forwarderSnsEndSendDate = forwarderSnsEndSendDate;
    return this;
  }

   /**
   * Feature flag to tell the SNS forwarder service when (event date) it should stop event forwarding for the tenant
   * @return forwarderSnsEndSendDate
  **/
  @ApiModelProperty(value = "Feature flag to tell the SNS forwarder service when (event date) it should stop event forwarding for the tenant")
  public LocalDateTime getForwarderSnsEndSendDate() {
    return forwarderSnsEndSendDate;
  }

  public void setForwarderSnsEndSendDate(LocalDateTime forwarderSnsEndSendDate) {
    this.forwarderSnsEndSendDate = forwarderSnsEndSendDate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SnsConfiguration snsConfiguration = (SnsConfiguration) o;
    return Objects.equals(this.accessKey, snsConfiguration.accessKey) &&
        Objects.equals(this.secretKey, snsConfiguration.secretKey) &&
        Objects.equals(this.topicARN, snsConfiguration.topicARN) &&
        Objects.equals(this.advancedConfiguration, snsConfiguration.advancedConfiguration) &&
        Objects.equals(this.forwardingEnabled, snsConfiguration.forwardingEnabled) &&
        Objects.equals(this.forwarderSnsStartSendDate, snsConfiguration.forwarderSnsStartSendDate) &&
        Objects.equals(this.forwarderSnsEndSendDate, snsConfiguration.forwarderSnsEndSendDate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(accessKey, secretKey, topicARN, advancedConfiguration, forwardingEnabled, forwarderSnsStartSendDate, forwarderSnsEndSendDate);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SnsConfiguration {\n");
    
    sb.append("    accessKey: ").append(toIndentedString(accessKey)).append("\n");
    sb.append("    secretKey: ").append(toIndentedString(secretKey)).append("\n");
    sb.append("    topicARN: ").append(toIndentedString(topicARN)).append("\n");
    sb.append("    advancedConfiguration: ").append(toIndentedString(advancedConfiguration)).append("\n");
    sb.append("    forwardingEnabled: ").append(toIndentedString(forwardingEnabled)).append("\n");
    sb.append("    forwarderSnsStartSendDate: ").append(toIndentedString(forwarderSnsStartSendDate)).append("\n");
    sb.append("    forwarderSnsEndSendDate: ").append(toIndentedString(forwarderSnsEndSendDate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

