/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Status of a SNS forward attempt. SNS forward attempt is updated by the SNS forwarder in order to return feedback to the user.
 */
@ApiModel(description = "Status of a SNS forward attempt. SNS forward attempt is updated by the SNS forwarder in order to return feedback to the user.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class Snsstatus {
  @JsonProperty("lastAttemptTime")
  private Long lastAttemptTime = null;

  @JsonProperty("message")
  private String message = null;

  /**
   * Result of last attemp to forward to the tenant designated SNS topic.
   */
  public enum StatusEnum {
    FAILURE("failure"),
    
    SUCCESS("success");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StatusEnum fromValue(String text) {
      for (StatusEnum b : StatusEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("status")
  private StatusEnum status = null;

  @JsonProperty("failureReason")
  private String failureReason = null;

  @JsonProperty("topicArn")
  private String topicArn = null;

  public Snsstatus lastAttemptTime(Long lastAttemptTime) {
    this.lastAttemptTime = lastAttemptTime;
    return this;
  }

   /**
   * Last time whem an attemp to forward to the tenant designated SNS topic was made.
   * @return lastAttemptTime
  **/
  @ApiModelProperty(value = "Last time whem an attemp to forward to the tenant designated SNS topic was made.")
  public Long getLastAttemptTime() {
    return lastAttemptTime;
  }

  public void setLastAttemptTime(Long lastAttemptTime) {
    this.lastAttemptTime = lastAttemptTime;
  }

  public Snsstatus message(String message) {
    this.message = message;
    return this;
  }

   /**
   * Failed event message to reflect in the DSM alert.
   * @return message
  **/
  @ApiModelProperty(value = "Failed event message to reflect in the DSM alert.")
  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public Snsstatus status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * Result of last attemp to forward to the tenant designated SNS topic.
   * @return status
  **/
  @ApiModelProperty(value = "Result of last attemp to forward to the tenant designated SNS topic.")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public Snsstatus failureReason(String failureReason) {
    this.failureReason = failureReason;
    return this;
  }

   /**
   * Reported reason for forwarding failure.
   * @return failureReason
  **/
  @ApiModelProperty(value = "Reported reason for forwarding failure.")
  public String getFailureReason() {
    return failureReason;
  }

  public void setFailureReason(String failureReason) {
    this.failureReason = failureReason;
  }

  public Snsstatus topicArn(String topicArn) {
    this.topicArn = topicArn;
    return this;
  }

   /**
   * ARN of SNS topic that the event was intended to.
   * @return topicArn
  **/
  @ApiModelProperty(value = "ARN of SNS topic that the event was intended to.")
  public String getTopicArn() {
    return topicArn;
  }

  public void setTopicArn(String topicArn) {
    this.topicArn = topicArn;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Snsstatus snsstatus = (Snsstatus) o;
    return Objects.equals(this.lastAttemptTime, snsstatus.lastAttemptTime) &&
        Objects.equals(this.message, snsstatus.message) &&
        Objects.equals(this.status, snsstatus.status) &&
        Objects.equals(this.failureReason, snsstatus.failureReason) &&
        Objects.equals(this.topicArn, snsstatus.topicArn);
  }

  @Override
  public int hashCode() {
    return Objects.hash(lastAttemptTime, message, status, failureReason, topicArn);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Snsstatus {\n");
    
    sb.append("    lastAttemptTime: ").append(toIndentedString(lastAttemptTime)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    failureReason: ").append(toIndentedString(failureReason)).append("\n");
    sb.append("    topicArn: ").append(toIndentedString(topicArn)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

