/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Software change details.
 */
@ApiModel(description = "Software change details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class SoftwareChange {
  @JsonProperty("computerID")
  private Integer computerID = null;

  @JsonProperty("computerGroupID")
  private Integer computerGroupID = null;

  @JsonProperty("vendorName")
  private String vendorName = null;

  @JsonProperty("productName")
  private String productName = null;

  @JsonProperty("productVersion")
  private String productVersion = null;

  @JsonProperty("fileVersion")
  private String fileVersion = null;

  @JsonProperty("fileDescription")
  private String fileDescription = null;

  @JsonProperty("sha1")
  private String sha1 = null;

  @JsonProperty("sha256")
  private String sha256 = null;

  @JsonProperty("md5")
  private String md5 = null;

  @JsonProperty("fileName")
  private String fileName = null;

  @JsonProperty("installPath")
  private String installPath = null;

  @JsonProperty("fileSize")
  private Long fileSize = null;

  @JsonProperty("changeEventTime")
  private Long changeEventTime = null;

  @JsonProperty("changeByUser")
  private String changeByUser = null;

  @JsonProperty("changeByUserID")
  private String changeByUserID = null;

  @JsonProperty("changeByProcess")
  private String changeByProcess = null;

  @JsonProperty("changeByProcessID")
  private String changeByProcessID = null;

  @JsonProperty("ID")
  private Long ID = null;

   /**
   * ID of the computer on which the software change was found. Searchable as Numeric.
   * @return computerID
  **/
  @ApiModelProperty(value = "ID of the computer on which the software change was found. Searchable as Numeric.")
  public Integer getComputerID() {
    return computerID;
  }

   /**
   * ID of the computer group where the software change was found. Searchable as Numeric.
   * @return computerGroupID
  **/
  @ApiModelProperty(value = "ID of the computer group where the software change was found. Searchable as Numeric.")
  public Integer getComputerGroupID() {
    return computerGroupID;
  }

   /**
   * Vendor name associated with the changed software. Searchable as String.
   * @return vendorName
  **/
  @ApiModelProperty(value = "Vendor name associated with the changed software. Searchable as String.")
  public String getVendorName() {
    return vendorName;
  }

   /**
   * Product name associated with the changed software. Searchable as String.
   * @return productName
  **/
  @ApiModelProperty(value = "Product name associated with the changed software. Searchable as String.")
  public String getProductName() {
    return productName;
  }

   /**
   * Product version associated with the changed software. Searchable as String.
   * @return productVersion
  **/
  @ApiModelProperty(value = "Product version associated with the changed software. Searchable as String.")
  public String getProductVersion() {
    return productVersion;
  }

   /**
   * File version associated with the changed software. Searchable as String.
   * @return fileVersion
  **/
  @ApiModelProperty(value = "File version associated with the changed software. Searchable as String.")
  public String getFileVersion() {
    return fileVersion;
  }

   /**
   * File description associated with the changed software. Searchable as String.
   * @return fileDescription
  **/
  @ApiModelProperty(value = "File description associated with the changed software. Searchable as String.")
  public String getFileDescription() {
    return fileDescription;
  }

   /**
   * SHA1 hash calculated from the changed software. Searchable as String.
   * @return sha1
  **/
  @ApiModelProperty(value = "SHA1 hash calculated from the changed software. Searchable as String.")
  public String getSha1() {
    return sha1;
  }

   /**
   * SHA256 hash calculated from the changed software. Searchable as String.
   * @return sha256
  **/
  @ApiModelProperty(value = "SHA256 hash calculated from the changed software. Searchable as String.")
  public String getSha256() {
    return sha256;
  }

   /**
   * MD5 hash calculated from the changed software. Searchable as String.
   * @return md5
  **/
  @ApiModelProperty(value = "MD5 hash calculated from the changed software. Searchable as String.")
  public String getMd5() {
    return md5;
  }

   /**
   * File name of the changed software. Searchable as String.
   * @return fileName
  **/
  @ApiModelProperty(value = "File name of the changed software. Searchable as String.")
  public String getFileName() {
    return fileName;
  }

   /**
   * Path on which the software change was found. Searchable as String.
   * @return installPath
  **/
  @ApiModelProperty(value = "Path on which the software change was found. Searchable as String.")
  public String getInstallPath() {
    return installPath;
  }

   /**
   * File size of the changed software in bytes. Searchable as Numeric.
   * @return fileSize
  **/
  @ApiModelProperty(value = "File size of the changed software in bytes. Searchable as Numeric.")
  public Long getFileSize() {
    return fileSize;
  }

   /**
   * Time the software change was discovered, in milliseconds since epoch. Searchable as Date.
   * @return changeEventTime
  **/
  @ApiModelProperty(value = "Time the software change was discovered, in milliseconds since epoch. Searchable as Date.")
  public Long getChangeEventTime() {
    return changeEventTime;
  }

   /**
   * Username of the user that introduced the software change. Searchable as String.
   * @return changeByUser
  **/
  @ApiModelProperty(value = "Username of the user that introduced the software change. Searchable as String.")
  public String getChangeByUser() {
    return changeByUser;
  }

   /**
   * User ID of the user that introduced the software change. Searchable as String.
   * @return changeByUserID
  **/
  @ApiModelProperty(value = "User ID of the user that introduced the software change. Searchable as String.")
  public String getChangeByUserID() {
    return changeByUserID;
  }

   /**
   * Name of the process that introduced the software change. Searchable as String.
   * @return changeByProcess
  **/
  @ApiModelProperty(value = "Name of the process that introduced the software change. Searchable as String.")
  public String getChangeByProcess() {
    return changeByProcess;
  }

   /**
   * Process ID of the process that introduced the software change. Searchable as String.
   * @return changeByProcessID
  **/
  @ApiModelProperty(value = "Process ID of the process that introduced the software change. Searchable as String.")
  public String getChangeByProcessID() {
    return changeByProcessID;
  }

   /**
   * ID of software change. Searchable as Numeric.
   * @return ID
  **/
  @ApiModelProperty(value = "ID of software change. Searchable as Numeric.")
  public Long getID() {
    return ID;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SoftwareChange softwareChange = (SoftwareChange) o;
    return Objects.equals(this.computerID, softwareChange.computerID) &&
        Objects.equals(this.computerGroupID, softwareChange.computerGroupID) &&
        Objects.equals(this.vendorName, softwareChange.vendorName) &&
        Objects.equals(this.productName, softwareChange.productName) &&
        Objects.equals(this.productVersion, softwareChange.productVersion) &&
        Objects.equals(this.fileVersion, softwareChange.fileVersion) &&
        Objects.equals(this.fileDescription, softwareChange.fileDescription) &&
        Objects.equals(this.sha1, softwareChange.sha1) &&
        Objects.equals(this.sha256, softwareChange.sha256) &&
        Objects.equals(this.md5, softwareChange.md5) &&
        Objects.equals(this.fileName, softwareChange.fileName) &&
        Objects.equals(this.installPath, softwareChange.installPath) &&
        Objects.equals(this.fileSize, softwareChange.fileSize) &&
        Objects.equals(this.changeEventTime, softwareChange.changeEventTime) &&
        Objects.equals(this.changeByUser, softwareChange.changeByUser) &&
        Objects.equals(this.changeByUserID, softwareChange.changeByUserID) &&
        Objects.equals(this.changeByProcess, softwareChange.changeByProcess) &&
        Objects.equals(this.changeByProcessID, softwareChange.changeByProcessID) &&
        Objects.equals(this.ID, softwareChange.ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(computerID, computerGroupID, vendorName, productName, productVersion, fileVersion, fileDescription, sha1, sha256, md5, fileName, installPath, fileSize, changeEventTime, changeByUser, changeByUserID, changeByProcess, changeByProcessID, ID);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SoftwareChange {\n");
    
    sb.append("    computerID: ").append(toIndentedString(computerID)).append("\n");
    sb.append("    computerGroupID: ").append(toIndentedString(computerGroupID)).append("\n");
    sb.append("    vendorName: ").append(toIndentedString(vendorName)).append("\n");
    sb.append("    productName: ").append(toIndentedString(productName)).append("\n");
    sb.append("    productVersion: ").append(toIndentedString(productVersion)).append("\n");
    sb.append("    fileVersion: ").append(toIndentedString(fileVersion)).append("\n");
    sb.append("    fileDescription: ").append(toIndentedString(fileDescription)).append("\n");
    sb.append("    sha1: ").append(toIndentedString(sha1)).append("\n");
    sb.append("    sha256: ").append(toIndentedString(sha256)).append("\n");
    sb.append("    md5: ").append(toIndentedString(md5)).append("\n");
    sb.append("    fileName: ").append(toIndentedString(fileName)).append("\n");
    sb.append("    installPath: ").append(toIndentedString(installPath)).append("\n");
    sb.append("    fileSize: ").append(toIndentedString(fileSize)).append("\n");
    sb.append("    changeEventTime: ").append(toIndentedString(changeEventTime)).append("\n");
    sb.append("    changeByUser: ").append(toIndentedString(changeByUser)).append("\n");
    sb.append("    changeByUserID: ").append(toIndentedString(changeByUserID)).append("\n");
    sb.append("    changeByProcess: ").append(toIndentedString(changeByProcess)).append("\n");
    sb.append("    changeByProcessID: ").append(toIndentedString(changeByProcessID)).append("\n");
    sb.append("    ID: ").append(toIndentedString(ID)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

