/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.SoftwareChangeReviewResult;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Software change review details.
 */
@ApiModel(description = "Software change review details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class SoftwareChangeReview {
  @JsonProperty("softwareChangeIDs")
  private List<Long> softwareChangeIDs = null;

  /**
   * Action to perform on the software changes.
   */
  public enum ActionEnum {
    ALLOW("allow"),
    
    BLOCK("block");

    private String value;

    ActionEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ActionEnum fromValue(String text) {
      for (ActionEnum b : ActionEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("action")
  private ActionEnum action = null;

  @JsonProperty("softwareChangeReviewResults")
  private List<SoftwareChangeReviewResult> softwareChangeReviewResults = null;

  public SoftwareChangeReview softwareChangeIDs(List<Long> softwareChangeIDs) {
    this.softwareChangeIDs = softwareChangeIDs;
    return this;
  }

  public SoftwareChangeReview addSoftwareChangeIDsItem(Long softwareChangeIDsItem) {
    if (this.softwareChangeIDs == null) {
      this.softwareChangeIDs = new ArrayList<>();
    }
    this.softwareChangeIDs.add(softwareChangeIDsItem);
    return this;
  }

   /**
   * List of software change IDs.
   * @return softwareChangeIDs
  **/
  @ApiModelProperty(value = "List of software change IDs.")
  public List<Long> getSoftwareChangeIDs() {
    return softwareChangeIDs;
  }

  public void setSoftwareChangeIDs(List<Long> softwareChangeIDs) {
    this.softwareChangeIDs = softwareChangeIDs;
  }

  public SoftwareChangeReview action(ActionEnum action) {
    this.action = action;
    return this;
  }

   /**
   * Action to perform on the software changes.
   * @return action
  **/
  @ApiModelProperty(value = "Action to perform on the software changes.")
  public ActionEnum getAction() {
    return action;
  }

  public void setAction(ActionEnum action) {
    this.action = action;
  }

   /**
   * Results of software changes.
   * @return softwareChangeReviewResults
  **/
  @ApiModelProperty(value = "Results of software changes.")
  public List<SoftwareChangeReviewResult> getSoftwareChangeReviewResults() {
    return softwareChangeReviewResults;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SoftwareChangeReview softwareChangeReview = (SoftwareChangeReview) o;
    return Objects.equals(this.softwareChangeIDs, softwareChangeReview.softwareChangeIDs) &&
        Objects.equals(this.action, softwareChangeReview.action) &&
        Objects.equals(this.softwareChangeReviewResults, softwareChangeReview.softwareChangeReviewResults);
  }

  @Override
  public int hashCode() {
    return Objects.hash(softwareChangeIDs, action, softwareChangeReviewResults);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SoftwareChangeReview {\n");
    
    sb.append("    softwareChangeIDs: ").append(toIndentedString(softwareChangeIDs)).append("\n");
    sb.append("    action: ").append(toIndentedString(action)).append("\n");
    sb.append("    softwareChangeReviewResults: ").append(toIndentedString(softwareChangeReviewResults)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

