/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Details of a vCloud virtual machine.
 */
@ApiModel(description = "Details of a vCloud virtual machine.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class VcloudVMVirtualMachineSummary {
  @JsonProperty("cloudProvider")
  private String cloudProvider = null;

  @JsonProperty("operatingSystem")
  private String operatingSystem = null;

  @JsonProperty("instanceID")
  private String instanceID = null;

  @JsonProperty("type")
  private String type = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("IPAddress")
  private String ipAddress = null;

  @JsonProperty("DNSName")
  private String dnSName = null;

  public VcloudVMVirtualMachineSummary cloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
    return this;
  }

   /**
   * Cloud provider: \&quot;vCloud\&quot;.
   * @return cloudProvider
  **/
  @ApiModelProperty(value = "Cloud provider: \"vCloud\".")
  public String getCloudProvider() {
    return cloudProvider;
  }

  public void setCloudProvider(String cloudProvider) {
    this.cloudProvider = cloudProvider;
  }

  public VcloudVMVirtualMachineSummary operatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
    return this;
  }

   /**
   * Operating system, for example: \&quot;Microsoft Windows Server 2012 (64-bit)\&quot;. Searchable as String.
   * @return operatingSystem
  **/
  @ApiModelProperty(value = "Operating system, for example: \"Microsoft Windows Server 2012 (64-bit)\". Searchable as String.")
  public String getOperatingSystem() {
    return operatingSystem;
  }

  public void setOperatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
  }

  public VcloudVMVirtualMachineSummary instanceID(String instanceID) {
    this.instanceID = instanceID;
    return this;
  }

   /**
   * Instance ID. Searchable as String.
   * @return instanceID
  **/
  @ApiModelProperty(value = "Instance ID. Searchable as String.")
  public String getInstanceID() {
    return instanceID;
  }

  public void setInstanceID(String instanceID) {
    this.instanceID = instanceID;
  }

  public VcloudVMVirtualMachineSummary type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Hardware type. Searchable as String.
   * @return type
  **/
  @ApiModelProperty(value = "Hardware type. Searchable as String.")
  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }

  public VcloudVMVirtualMachineSummary state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Power state, for example: \&quot;Powered On\&quot;.
   * @return state
  **/
  @ApiModelProperty(value = "Power state, for example: \"Powered On\".")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public VcloudVMVirtualMachineSummary ipAddress(String ipAddress) {
    this.ipAddress = ipAddress;
    return this;
  }

   /**
   * Get ipAddress
   * @return ipAddress
  **/
  @ApiModelProperty(value = "")
  public String getIpAddress() {
    return ipAddress;
  }

  public void setIpAddress(String ipAddress) {
    this.ipAddress = ipAddress;
  }

  public VcloudVMVirtualMachineSummary dnSName(String dnSName) {
    this.dnSName = dnSName;
    return this;
  }

   /**
   * Get dnSName
   * @return dnSName
  **/
  @ApiModelProperty(value = "")
  public String getDnSName() {
    return dnSName;
  }

  public void setDnSName(String dnSName) {
    this.dnSName = dnSName;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VcloudVMVirtualMachineSummary vcloudVMVirtualMachineSummary = (VcloudVMVirtualMachineSummary) o;
    return Objects.equals(this.cloudProvider, vcloudVMVirtualMachineSummary.cloudProvider) &&
        Objects.equals(this.operatingSystem, vcloudVMVirtualMachineSummary.operatingSystem) &&
        Objects.equals(this.instanceID, vcloudVMVirtualMachineSummary.instanceID) &&
        Objects.equals(this.type, vcloudVMVirtualMachineSummary.type) &&
        Objects.equals(this.state, vcloudVMVirtualMachineSummary.state) &&
        Objects.equals(this.ipAddress, vcloudVMVirtualMachineSummary.ipAddress) &&
        Objects.equals(this.dnSName, vcloudVMVirtualMachineSummary.dnSName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(cloudProvider, operatingSystem, instanceID, type, state, ipAddress, dnSName);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VcloudVMVirtualMachineSummary {\n");
    
    sb.append("    cloudProvider: ").append(toIndentedString(cloudProvider)).append("\n");
    sb.append("    operatingSystem: ").append(toIndentedString(operatingSystem)).append("\n");
    sb.append("    instanceID: ").append(toIndentedString(instanceID)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    ipAddress: ").append(toIndentedString(ipAddress)).append("\n");
    sb.append("    dnSName: ").append(toIndentedString(dnSName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

