/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details of a VMWare virtual machine.
 */
@ApiModel(description = "Details of a VMWare virtual machine.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class VmwareVMVirtualMachineSummary {
  @JsonProperty("operatingSystem")
  private String operatingSystem = null;

  @JsonProperty("memory")
  private String memory = null;

  @JsonProperty("vmwareTools")
  private String vmwareTools = null;

  @JsonProperty("biosUUID")
  private String biosUUID = null;

  @JsonProperty("state")
  private String state = null;

  @JsonProperty("notes")
  private List<String> notes = null;

  @JsonProperty("CPU")
  private String CPU = null;

  @JsonProperty("vCenterUUID")
  private String vCenterUUID = null;

  @JsonProperty("NSXSecurityGroups")
  private List<String> nsXSecurityGroups = null;

  @JsonProperty("IPAddress")
  private String ipAddress = null;

  @JsonProperty("DNSName")
  private String dnSName = null;

  public VmwareVMVirtualMachineSummary operatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
    return this;
  }

   /**
   * Operating system, for example: \&quot;Microsoft Windows Server 2012 (64-bit)\&quot;. Searchable as String.
   * @return operatingSystem
  **/
  @ApiModelProperty(value = "Operating system, for example: \"Microsoft Windows Server 2012 (64-bit)\". Searchable as String.")
  public String getOperatingSystem() {
    return operatingSystem;
  }

  public void setOperatingSystem(String operatingSystem) {
    this.operatingSystem = operatingSystem;
  }

  public VmwareVMVirtualMachineSummary memory(String memory) {
    this.memory = memory;
    return this;
  }

   /**
   * Memory allocation, for example: \&quot;12,288 MB\&quot;.
   * @return memory
  **/
  @ApiModelProperty(value = "Memory allocation, for example: \"12,288 MB\".")
  public String getMemory() {
    return memory;
  }

  public void setMemory(String memory) {
    this.memory = memory;
  }

  public VmwareVMVirtualMachineSummary vmwareTools(String vmwareTools) {
    this.vmwareTools = vmwareTools;
    return this;
  }

   /**
   * VMware tools status, for example: \&quot;OK\&quot;.
   * @return vmwareTools
  **/
  @ApiModelProperty(value = "VMware tools status, for example: \"OK\".")
  public String getVmwareTools() {
    return vmwareTools;
  }

  public void setVmwareTools(String vmwareTools) {
    this.vmwareTools = vmwareTools;
  }

  public VmwareVMVirtualMachineSummary biosUUID(String biosUUID) {
    this.biosUUID = biosUUID;
    return this;
  }

   /**
   * BIOS UUID, for example: \&quot;421e1137-5c49-56e4-246d-9bf7637e69f5\&quot;. Searchable as String.
   * @return biosUUID
  **/
  @ApiModelProperty(value = "BIOS UUID, for example: \"421e1137-5c49-56e4-246d-9bf7637e69f5\". Searchable as String.")
  public String getBiosUUID() {
    return biosUUID;
  }

  public void setBiosUUID(String biosUUID) {
    this.biosUUID = biosUUID;
  }

  public VmwareVMVirtualMachineSummary state(String state) {
    this.state = state;
    return this;
  }

   /**
   * Power state, for example: \&quot;Powered On\&quot;.
   * @return state
  **/
  @ApiModelProperty(value = "Power state, for example: \"Powered On\".")
  public String getState() {
    return state;
  }

  public void setState(String state) {
    this.state = state;
  }

  public VmwareVMVirtualMachineSummary notes(List<String> notes) {
    this.notes = notes;
    return this;
  }

  public VmwareVMVirtualMachineSummary addNotesItem(String notesItem) {
    if (this.notes == null) {
      this.notes = new ArrayList<>();
    }
    this.notes.add(notesItem);
    return this;
  }

   /**
   * Notes associated with the VM.
   * @return notes
  **/
  @ApiModelProperty(value = "Notes associated with the VM.")
  public List<String> getNotes() {
    return notes;
  }

  public void setNotes(List<String> notes) {
    this.notes = notes;
  }

  public VmwareVMVirtualMachineSummary CPU(String CPU) {
    this.CPU = CPU;
    return this;
  }

   /**
   * Number and type of CPUs, for example: \&quot;4 vCPU\&quot;. Searchable as Numeric.
   * @return CPU
  **/
  @ApiModelProperty(value = "Number and type of CPUs, for example: \"4 vCPU\". Searchable as Numeric.")
  public String getCPU() {
    return CPU;
  }

  public void setCPU(String CPU) {
    this.CPU = CPU;
  }

  public VmwareVMVirtualMachineSummary vCenterUUID(String vCenterUUID) {
    this.vCenterUUID = vCenterUUID;
    return this;
  }

   /**
   * Get vCenterUUID
   * @return vCenterUUID
  **/
  @ApiModelProperty(value = "")
  public String getVCenterUUID() {
    return vCenterUUID;
  }

  public void setVCenterUUID(String vCenterUUID) {
    this.vCenterUUID = vCenterUUID;
  }

  public VmwareVMVirtualMachineSummary nsXSecurityGroups(List<String> nsXSecurityGroups) {
    this.nsXSecurityGroups = nsXSecurityGroups;
    return this;
  }

  public VmwareVMVirtualMachineSummary addNsXSecurityGroupsItem(String nsXSecurityGroupsItem) {
    if (this.nsXSecurityGroups == null) {
      this.nsXSecurityGroups = new ArrayList<>();
    }
    this.nsXSecurityGroups.add(nsXSecurityGroupsItem);
    return this;
  }

   /**
   * Get nsXSecurityGroups
   * @return nsXSecurityGroups
  **/
  @ApiModelProperty(value = "")
  public List<String> getNsXSecurityGroups() {
    return nsXSecurityGroups;
  }

  public void setNsXSecurityGroups(List<String> nsXSecurityGroups) {
    this.nsXSecurityGroups = nsXSecurityGroups;
  }

  public VmwareVMVirtualMachineSummary ipAddress(String ipAddress) {
    this.ipAddress = ipAddress;
    return this;
  }

   /**
   * Get ipAddress
   * @return ipAddress
  **/
  @ApiModelProperty(value = "")
  public String getIpAddress() {
    return ipAddress;
  }

  public void setIpAddress(String ipAddress) {
    this.ipAddress = ipAddress;
  }

  public VmwareVMVirtualMachineSummary dnSName(String dnSName) {
    this.dnSName = dnSName;
    return this;
  }

   /**
   * Get dnSName
   * @return dnSName
  **/
  @ApiModelProperty(value = "")
  public String getDnSName() {
    return dnSName;
  }

  public void setDnSName(String dnSName) {
    this.dnSName = dnSName;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VmwareVMVirtualMachineSummary vmwareVMVirtualMachineSummary = (VmwareVMVirtualMachineSummary) o;
    return Objects.equals(this.operatingSystem, vmwareVMVirtualMachineSummary.operatingSystem) &&
        Objects.equals(this.memory, vmwareVMVirtualMachineSummary.memory) &&
        Objects.equals(this.vmwareTools, vmwareVMVirtualMachineSummary.vmwareTools) &&
        Objects.equals(this.biosUUID, vmwareVMVirtualMachineSummary.biosUUID) &&
        Objects.equals(this.state, vmwareVMVirtualMachineSummary.state) &&
        Objects.equals(this.notes, vmwareVMVirtualMachineSummary.notes) &&
        Objects.equals(this.CPU, vmwareVMVirtualMachineSummary.CPU) &&
        Objects.equals(this.vCenterUUID, vmwareVMVirtualMachineSummary.vCenterUUID) &&
        Objects.equals(this.nsXSecurityGroups, vmwareVMVirtualMachineSummary.nsXSecurityGroups) &&
        Objects.equals(this.ipAddress, vmwareVMVirtualMachineSummary.ipAddress) &&
        Objects.equals(this.dnSName, vmwareVMVirtualMachineSummary.dnSName);
  }

  @Override
  public int hashCode() {
    return Objects.hash(operatingSystem, memory, vmwareTools, biosUUID, state, notes, CPU, vCenterUUID, nsXSecurityGroups, ipAddress, dnSName);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VmwareVMVirtualMachineSummary {\n");
    
    sb.append("    operatingSystem: ").append(toIndentedString(operatingSystem)).append("\n");
    sb.append("    memory: ").append(toIndentedString(memory)).append("\n");
    sb.append("    vmwareTools: ").append(toIndentedString(vmwareTools)).append("\n");
    sb.append("    biosUUID: ").append(toIndentedString(biosUUID)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    notes: ").append(toIndentedString(notes)).append("\n");
    sb.append("    CPU: ").append(toIndentedString(CPU)).append("\n");
    sb.append("    vCenterUUID: ").append(toIndentedString(vCenterUUID)).append("\n");
    sb.append("    nsXSecurityGroups: ").append(toIndentedString(nsXSecurityGroups)).append("\n");
    sb.append("    ipAddress: ").append(toIndentedString(ipAddress)).append("\n");
    sb.append("    dnSName: ").append(toIndentedString(dnSName)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

