/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;


/**
 * Details for the weekly schedule of a scheduled task.
 */
@ApiModel(description = "Details for the weekly schedule of a scheduled task.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class WeeklyScheduleParameters {
  @JsonProperty("startTime")
  private Long startTime = null;

  @JsonProperty("interval")
  private Integer interval = null;

  /**
   * Gets or Sets days
   */
  public enum DaysEnum {
    SUNDAY("sunday"),
    
    MONDAY("monday"),
    
    TUESDAY("tuesday"),
    
    WEDNESDAY("wednesday"),
    
    THURSDAY("thursday"),
    
    FRIDAY("friday"),
    
    SATURDAY("saturday");

    private String value;

    DaysEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static DaysEnum fromValue(String text) {
      for (DaysEnum b : DaysEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("days")
  private List<DaysEnum> days = null;

  public WeeklyScheduleParameters startTime(Long startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Date/Time when the task should run.
   * @return startTime
  **/
  @ApiModelProperty(value = "Date/Time when the task should run.")
  public Long getStartTime() {
    return startTime;
  }

  public void setStartTime(Long startTime) {
    this.startTime = startTime;
  }

  public WeeklyScheduleParameters interval(Integer interval) {
    this.interval = interval;
    return this;
  }

   /**
   * Number of weeks between recurrences.
   * @return interval
  **/
  @ApiModelProperty(value = "Number of weeks between recurrences.")
  public Integer getInterval() {
    return interval;
  }

  public void setInterval(Integer interval) {
    this.interval = interval;
  }

  public WeeklyScheduleParameters days(List<DaysEnum> days) {
    this.days = days;
    return this;
  }

  public WeeklyScheduleParameters addDaysItem(DaysEnum daysItem) {
    if (this.days == null) {
      this.days = new ArrayList<>();
    }
    this.days.add(daysItem);
    return this;
  }

   /**
   * Days of the week when the scheduled task will run.
   * @return days
  **/
  @ApiModelProperty(value = "Days of the week when the scheduled task will run.")
  public List<DaysEnum> getDays() {
    return days;
  }

  public void setDays(List<DaysEnum> days) {
    this.days = days;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WeeklyScheduleParameters weeklyScheduleParameters = (WeeklyScheduleParameters) o;
    return Objects.equals(this.startTime, weeklyScheduleParameters.startTime) &&
        Objects.equals(this.interval, weeklyScheduleParameters.interval) &&
        Objects.equals(this.days, weeklyScheduleParameters.days);
  }

  @Override
  public int hashCode() {
    return Objects.hash(startTime, interval, days);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WeeklyScheduleParameters {\n");
    
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    interval: ").append(toIndentedString(interval)).append("\n");
    sb.append("    days: ").append(toIndentedString(days)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

