package com.trendmicro.deepsecurity.api;

import com.trendmicro.deepsecurity.ApiException;
import com.trendmicro.deepsecurity.ApiClient;
import com.trendmicro.deepsecurity.Configuration;
import com.trendmicro.deepsecurity.Pair;

import javax.ws.rs.core.GenericType;

import com.trendmicro.deepsecurity.model.AntiMalwareConfiguration;
import com.trendmicro.deepsecurity.model.AntiMalwareConfigurations;
import com.trendmicro.deepsecurity.model.SearchFilter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class AntiMalwareConfigurationsApi {
  private ApiClient apiClient;

  public AntiMalwareConfigurationsApi() {
    this(Configuration.getDefaultApiClient());
  }

  public AntiMalwareConfigurationsApi(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  public ApiClient getApiClient() {
    return apiClient;
  }

  public void setApiClient(ApiClient apiClient) {
    this.apiClient = apiClient;
  }

  /**
   * Create an Anti-Malware Configuration
   * Create a new anti-malware configuration.
   * @param antiMalwareConfiguration The settings of the new anti-malware configuration. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return AntiMalwareConfiguration
   * @throws ApiException if fails to make API call
   */
  public AntiMalwareConfiguration createAntiMalware(AntiMalwareConfiguration antiMalwareConfiguration, String apiVersion) throws ApiException {
    Object localVarPostBody = antiMalwareConfiguration;
    
    // verify the required parameter 'antiMalwareConfiguration' is set
    if (antiMalwareConfiguration == null) {
      throw new ApiException(400, "Missing the required parameter 'antiMalwareConfiguration' when calling createAntiMalware");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling createAntiMalware");
    }
    
    // create path and map variables
    String localVarPath = "/antimalwareconfigurations".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AntiMalwareConfiguration> localVarReturnType = new GenericType<AntiMalwareConfiguration>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Delete an Anti-Malware Configuration
   * Delete an anti-malware configuration by ID.
   * @param antiMalwareID The ID number of the anti-malware configuration to delete. (required)
   * @param apiVersion The version of the api being called. (required)
   * @throws ApiException if fails to make API call
   */
  public void deleteAntiMalware(Integer antiMalwareID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'antiMalwareID' is set
    if (antiMalwareID == null) {
      throw new ApiException(400, "Missing the required parameter 'antiMalwareID' when calling deleteAntiMalware");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling deleteAntiMalware");
    }
    
    // create path and map variables
    String localVarPath = "/antimalwareconfigurations/{antiMalwareID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "antiMalwareID" + "\\}", apiClient.escapeString(antiMalwareID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };


    apiClient.invokeAPI(localVarPath, "DELETE", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, null);
  }
  /**
   * Describe an Anti-Malware Configuration
   * Describe an anti-malware configuration by ID.
   * @param antiMalwareID The ID number of the anti-malware configuration to describe. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return AntiMalwareConfiguration
   * @throws ApiException if fails to make API call
   */
  public AntiMalwareConfiguration describeAntiMalware(Integer antiMalwareID, String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'antiMalwareID' is set
    if (antiMalwareID == null) {
      throw new ApiException(400, "Missing the required parameter 'antiMalwareID' when calling describeAntiMalware");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling describeAntiMalware");
    }
    
    // create path and map variables
    String localVarPath = "/antimalwareconfigurations/{antiMalwareID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "antiMalwareID" + "\\}", apiClient.escapeString(antiMalwareID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AntiMalwareConfiguration> localVarReturnType = new GenericType<AntiMalwareConfiguration>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * List Anti-Malware Configurations
   * Lists all anti-malware configurations.
   * @param apiVersion The version of the api being called. (required)
   * @return AntiMalwareConfigurations
   * @throws ApiException if fails to make API call
   */
  public AntiMalwareConfigurations listAntiMalwares(String apiVersion) throws ApiException {
    Object localVarPostBody = null;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling listAntiMalwares");
    }
    
    // create path and map variables
    String localVarPath = "/antimalwareconfigurations".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AntiMalwareConfigurations> localVarReturnType = new GenericType<AntiMalwareConfigurations>() {};
    return apiClient.invokeAPI(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Modify an Anti-Malware Configuration
   * Modify an anti-malware configuration by ID. Any unset elements will be left unchanged.
   * @param antiMalwareID The ID number of the anti-malware configuration to modify. (required)
   * @param antiMalwareConfiguration The settings of the anti-malware configuration to modify. (required)
   * @param apiVersion The version of the api being called. (required)
   * @return AntiMalwareConfiguration
   * @throws ApiException if fails to make API call
   */
  public AntiMalwareConfiguration modifyAntiMalware(Integer antiMalwareID, AntiMalwareConfiguration antiMalwareConfiguration, String apiVersion) throws ApiException {
    Object localVarPostBody = antiMalwareConfiguration;
    
    // verify the required parameter 'antiMalwareID' is set
    if (antiMalwareID == null) {
      throw new ApiException(400, "Missing the required parameter 'antiMalwareID' when calling modifyAntiMalware");
    }
    
    // verify the required parameter 'antiMalwareConfiguration' is set
    if (antiMalwareConfiguration == null) {
      throw new ApiException(400, "Missing the required parameter 'antiMalwareConfiguration' when calling modifyAntiMalware");
    }
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling modifyAntiMalware");
    }
    
    // create path and map variables
    String localVarPath = "/antimalwareconfigurations/{antiMalwareID}".replaceAll("\\{format\\}","json")
      .replaceAll("\\{" + "antiMalwareID" + "\\}", apiClient.escapeString(antiMalwareID.toString()));

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AntiMalwareConfiguration> localVarReturnType = new GenericType<AntiMalwareConfiguration>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
  /**
   * Search Anti-Malware Configurations
   * Search for anti-malware configurations using optional filters.
   * @param searchFilter A collection of options used to filter the search results. (optional)
   * @param apiVersion The version of the api being called. (required)
   * @return AntiMalwareConfigurations
   * @throws ApiException if fails to make API call
   */
  public AntiMalwareConfigurations searchAntiMalwares(SearchFilter searchFilter, String apiVersion) throws ApiException {
    Object localVarPostBody = searchFilter;
    
    // verify the required parameter 'apiVersion' is set
    if (apiVersion == null) {
      throw new ApiException(400, "Missing the required parameter 'apiVersion' when calling searchAntiMalwares");
    }
    
    // create path and map variables
    String localVarPath = "/antimalwareconfigurations/search".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> localVarQueryParams = new ArrayList<Pair>();
    Map<String, String> localVarHeaderParams = new HashMap<String, String>();
    Map<String, Object> localVarFormParams = new HashMap<String, Object>();


    if (apiVersion != null)
      localVarHeaderParams.put("api-version", apiClient.parameterToString(apiVersion));

    
    final String[] localVarAccepts = {
      "application/json"
    };
    final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);

    final String[] localVarContentTypes = {
      "application/json"
    };
    final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);

    String[] localVarAuthNames = new String[] { "DefaultAuthentication" };

    GenericType<AntiMalwareConfigurations> localVarReturnType = new GenericType<AntiMalwareConfigurations>() {};
    return apiClient.invokeAPI(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAccept, localVarContentType, localVarAuthNames, localVarReturnType);
      }
}
