/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.ComputerModuleStatus;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Computer-level configuration for the Anti-Malware module. Null for tenants for whom Anti-Malware is hidden.
 */
@ApiModel(description = "Computer-level configuration for the Anti-Malware module. Null for tenants for whom Anti-Malware is hidden.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class AntiMalwareComputerExtension {
  /**
   * Module state.
   */
  public enum StateEnum {
    INHERITED("inherited"),
    
    ON("on"),
    
    OFF("off");

    private String value;

    StateEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static StateEnum fromValue(String text) {
      for (StateEnum b : StateEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("state")
  private StateEnum state = null;

  @JsonProperty("moduleStatus")
  private ComputerModuleStatus moduleStatus = null;

  @JsonProperty("realTimeScanConfigurationID")
  private Integer realTimeScanConfigurationID = null;

  @JsonProperty("realTimeScanScheduleID")
  private Integer realTimeScanScheduleID = null;

  @JsonProperty("manualScanConfigurationID")
  private Integer manualScanConfigurationID = null;

  @JsonProperty("scheduledScanConfigurationID")
  private Integer scheduledScanConfigurationID = null;

  @JsonProperty("lastManualScan")
  private Long lastManualScan = null;

  @JsonProperty("lastScheduledScan")
  private Long lastScheduledScan = null;

  public AntiMalwareComputerExtension state(StateEnum state) {
    this.state = state;
    return this;
  }

   /**
   * Module state.
   * @return state
  **/
  @ApiModelProperty(value = "Module state.")
  public StateEnum getState() {
    return state;
  }

  public void setState(StateEnum state) {
    this.state = state;
  }

  public AntiMalwareComputerExtension moduleStatus(ComputerModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
    return this;
  }

   /**
   * Get moduleStatus
   * @return moduleStatus
  **/
  @ApiModelProperty(value = "")
  public ComputerModuleStatus getModuleStatus() {
    return moduleStatus;
  }

  public void setModuleStatus(ComputerModuleStatus moduleStatus) {
    this.moduleStatus = moduleStatus;
  }

  public AntiMalwareComputerExtension realTimeScanConfigurationID(Integer realTimeScanConfigurationID) {
    this.realTimeScanConfigurationID = realTimeScanConfigurationID;
    return this;
  }

   /**
   * ID of the Real Time Scan Configuration.
   * @return realTimeScanConfigurationID
  **/
  @ApiModelProperty(value = "ID of the Real Time Scan Configuration.")
  public Integer getRealTimeScanConfigurationID() {
    return realTimeScanConfigurationID;
  }

  public void setRealTimeScanConfigurationID(Integer realTimeScanConfigurationID) {
    this.realTimeScanConfigurationID = realTimeScanConfigurationID;
  }

  public AntiMalwareComputerExtension realTimeScanScheduleID(Integer realTimeScanScheduleID) {
    this.realTimeScanScheduleID = realTimeScanScheduleID;
    return this;
  }

   /**
   * ID of the Real Time Schedule.
   * @return realTimeScanScheduleID
  **/
  @ApiModelProperty(value = "ID of the Real Time Schedule.")
  public Integer getRealTimeScanScheduleID() {
    return realTimeScanScheduleID;
  }

  public void setRealTimeScanScheduleID(Integer realTimeScanScheduleID) {
    this.realTimeScanScheduleID = realTimeScanScheduleID;
  }

  public AntiMalwareComputerExtension manualScanConfigurationID(Integer manualScanConfigurationID) {
    this.manualScanConfigurationID = manualScanConfigurationID;
    return this;
  }

   /**
   * ID of the Manual Scan Configuration.
   * @return manualScanConfigurationID
  **/
  @ApiModelProperty(value = "ID of the Manual Scan Configuration.")
  public Integer getManualScanConfigurationID() {
    return manualScanConfigurationID;
  }

  public void setManualScanConfigurationID(Integer manualScanConfigurationID) {
    this.manualScanConfigurationID = manualScanConfigurationID;
  }

  public AntiMalwareComputerExtension scheduledScanConfigurationID(Integer scheduledScanConfigurationID) {
    this.scheduledScanConfigurationID = scheduledScanConfigurationID;
    return this;
  }

   /**
   * ID of the Scheduled Scan Configuration.
   * @return scheduledScanConfigurationID
  **/
  @ApiModelProperty(value = "ID of the Scheduled Scan Configuration.")
  public Integer getScheduledScanConfigurationID() {
    return scheduledScanConfigurationID;
  }

  public void setScheduledScanConfigurationID(Integer scheduledScanConfigurationID) {
    this.scheduledScanConfigurationID = scheduledScanConfigurationID;
  }

   /**
   * Timestamp of the last manual scan for malware, in milliseconds since epoch.
   * @return lastManualScan
  **/
  @ApiModelProperty(value = "Timestamp of the last manual scan for malware, in milliseconds since epoch.")
  public Long getLastManualScan() {
    return lastManualScan;
  }

   /**
   * Timestamp of the last scheduled scan for malware, in milliseconds since epoch.
   * @return lastScheduledScan
  **/
  @ApiModelProperty(value = "Timestamp of the last scheduled scan for malware, in milliseconds since epoch.")
  public Long getLastScheduledScan() {
    return lastScheduledScan;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AntiMalwareComputerExtension antiMalwareComputerExtension = (AntiMalwareComputerExtension) o;
    return Objects.equals(this.state, antiMalwareComputerExtension.state) &&
        Objects.equals(this.moduleStatus, antiMalwareComputerExtension.moduleStatus) &&
        Objects.equals(this.realTimeScanConfigurationID, antiMalwareComputerExtension.realTimeScanConfigurationID) &&
        Objects.equals(this.realTimeScanScheduleID, antiMalwareComputerExtension.realTimeScanScheduleID) &&
        Objects.equals(this.manualScanConfigurationID, antiMalwareComputerExtension.manualScanConfigurationID) &&
        Objects.equals(this.scheduledScanConfigurationID, antiMalwareComputerExtension.scheduledScanConfigurationID) &&
        Objects.equals(this.lastManualScan, antiMalwareComputerExtension.lastManualScan) &&
        Objects.equals(this.lastScheduledScan, antiMalwareComputerExtension.lastScheduledScan);
  }

  @Override
  public int hashCode() {
    return Objects.hash(state, moduleStatus, realTimeScanConfigurationID, realTimeScanScheduleID, manualScanConfigurationID, scheduledScanConfigurationID, lastManualScan, lastScheduledScan);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AntiMalwareComputerExtension {\n");
    
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    moduleStatus: ").append(toIndentedString(moduleStatus)).append("\n");
    sb.append("    realTimeScanConfigurationID: ").append(toIndentedString(realTimeScanConfigurationID)).append("\n");
    sb.append("    realTimeScanScheduleID: ").append(toIndentedString(realTimeScanScheduleID)).append("\n");
    sb.append("    manualScanConfigurationID: ").append(toIndentedString(manualScanConfigurationID)).append("\n");
    sb.append("    scheduledScanConfigurationID: ").append(toIndentedString(scheduledScanConfigurationID)).append("\n");
    sb.append("    lastManualScan: ").append(toIndentedString(lastManualScan)).append("\n");
    sb.append("    lastScheduledScan: ").append(toIndentedString(lastScheduledScan)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

