/*
 * Trend Micro Deep Security API
 * Copyright 2018 - 2020 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline.
 *
 * OpenAPI spec version: 12.5.855
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.trendmicro.deepsecurity.model;

import java.util.Objects;
import java.util.Arrays;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.trendmicro.deepsecurity.model.AntiMalwareConfigurationRights;
import com.trendmicro.deepsecurity.model.DirectoryListRights;
import com.trendmicro.deepsecurity.model.FileExtensionListRights;
import com.trendmicro.deepsecurity.model.FileListRights;
import com.trendmicro.deepsecurity.model.IdentifiedFileRights;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;


/**
 * Anti malware rights details.
 */
@ApiModel(description = "Anti malware rights details.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2020-04-28T12:18:09.226Z")
public class AntiMalwareRights {
  @JsonProperty("antiMalwareConfigurationRights")
  private AntiMalwareConfigurationRights antiMalwareConfigurationRights = null;

  @JsonProperty("directoryListRights")
  private DirectoryListRights directoryListRights = null;

  @JsonProperty("fileListRights")
  private FileListRights fileListRights = null;

  @JsonProperty("fileExtensionListRights")
  private FileExtensionListRights fileExtensionListRights = null;

  @JsonProperty("identifiedFileRights")
  private IdentifiedFileRights identifiedFileRights = null;

  public AntiMalwareRights antiMalwareConfigurationRights(AntiMalwareConfigurationRights antiMalwareConfigurationRights) {
    this.antiMalwareConfigurationRights = antiMalwareConfigurationRights;
    return this;
  }

   /**
   * Rights related to anti malware configurations.
   * @return antiMalwareConfigurationRights
  **/
  @ApiModelProperty(value = "Rights related to anti malware configurations.")
  public AntiMalwareConfigurationRights getAntiMalwareConfigurationRights() {
    return antiMalwareConfigurationRights;
  }

  public void setAntiMalwareConfigurationRights(AntiMalwareConfigurationRights antiMalwareConfigurationRights) {
    this.antiMalwareConfigurationRights = antiMalwareConfigurationRights;
  }

  public AntiMalwareRights directoryListRights(DirectoryListRights directoryListRights) {
    this.directoryListRights = directoryListRights;
    return this;
  }

   /**
   * Rights related to directory lists.
   * @return directoryListRights
  **/
  @ApiModelProperty(value = "Rights related to directory lists.")
  public DirectoryListRights getDirectoryListRights() {
    return directoryListRights;
  }

  public void setDirectoryListRights(DirectoryListRights directoryListRights) {
    this.directoryListRights = directoryListRights;
  }

  public AntiMalwareRights fileListRights(FileListRights fileListRights) {
    this.fileListRights = fileListRights;
    return this;
  }

   /**
   * Rights related to file lists.
   * @return fileListRights
  **/
  @ApiModelProperty(value = "Rights related to file lists.")
  public FileListRights getFileListRights() {
    return fileListRights;
  }

  public void setFileListRights(FileListRights fileListRights) {
    this.fileListRights = fileListRights;
  }

  public AntiMalwareRights fileExtensionListRights(FileExtensionListRights fileExtensionListRights) {
    this.fileExtensionListRights = fileExtensionListRights;
    return this;
  }

   /**
   * Rights related to file extension lists.
   * @return fileExtensionListRights
  **/
  @ApiModelProperty(value = "Rights related to file extension lists.")
  public FileExtensionListRights getFileExtensionListRights() {
    return fileExtensionListRights;
  }

  public void setFileExtensionListRights(FileExtensionListRights fileExtensionListRights) {
    this.fileExtensionListRights = fileExtensionListRights;
  }

  public AntiMalwareRights identifiedFileRights(IdentifiedFileRights identifiedFileRights) {
    this.identifiedFileRights = identifiedFileRights;
    return this;
  }

   /**
   * Rights related to identified files.
   * @return identifiedFileRights
  **/
  @ApiModelProperty(value = "Rights related to identified files.")
  public IdentifiedFileRights getIdentifiedFileRights() {
    return identifiedFileRights;
  }

  public void setIdentifiedFileRights(IdentifiedFileRights identifiedFileRights) {
    this.identifiedFileRights = identifiedFileRights;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AntiMalwareRights antiMalwareRights = (AntiMalwareRights) o;
    return Objects.equals(this.antiMalwareConfigurationRights, antiMalwareRights.antiMalwareConfigurationRights) &&
        Objects.equals(this.directoryListRights, antiMalwareRights.directoryListRights) &&
        Objects.equals(this.fileListRights, antiMalwareRights.fileListRights) &&
        Objects.equals(this.fileExtensionListRights, antiMalwareRights.fileExtensionListRights) &&
        Objects.equals(this.identifiedFileRights, antiMalwareRights.identifiedFileRights);
  }

  @Override
  public int hashCode() {
    return Objects.hash(antiMalwareConfigurationRights, directoryListRights, fileListRights, fileExtensionListRights, identifiedFileRights);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AntiMalwareRights {\n");
    
    sb.append("    antiMalwareConfigurationRights: ").append(toIndentedString(antiMalwareConfigurationRights)).append("\n");
    sb.append("    directoryListRights: ").append(toIndentedString(directoryListRights)).append("\n");
    sb.append("    fileListRights: ").append(toIndentedString(fileListRights)).append("\n");
    sb.append("    fileExtensionListRights: ").append(toIndentedString(fileExtensionListRights)).append("\n");
    sb.append("    identifiedFileRights: ").append(toIndentedString(identifiedFileRights)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

